<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */

// PMX-Umgebung schaffen:
include_once ('../../mainfile.php');
$module_name = 'alaBooking';
define ( 'PMX_MODULE', $module_name );

// Haupt-Klasse: alaBooking
include_once ('core/tabledef.php');
include_once (PMX_MODULES_DIR . DS . 'alaBooking' . DS . "includes/class.alaBooking.php");
// mxGetLangfile ( 'alaBooking' );

$LogFile = "alaBooking_read_ajax.log";

/**
 * eventuelle Ausgaben zwischenspeichern, um sie spaeter zu verwerfen ;-)
 */
ob_start ();

/* Fehlerausgaben unterdruecken */
if (pmxDebug::is_mode ( 'enhanced' )) {
  pmxDebug::level ( pmxDebug::level_logfile );
}

function get_autocomplete_verein($param) {
  
  // DB-Prefix:
  global $prefix, $LogFile;
  
  $log = date ( DATE_RSS );
  $log .= "Jep, wir sind im get_autocomplete_verein :-)" . "\n";
  $ok = file_put_contents ( $LogFile, $log . PHP_EOL, FILE_APPEND );
  
  // Check if parameter has to be converted from utf8?
  // $param = wka_utf8Decode ( $param );
  
  // query the database
  // $result = sql_query ( "SELECT * FROM " . $prefix . "_st_verein WHERE name LIKE '%$param%' OR v_id LIKE '%$param%' ORDER BY v_id " );
  $sql = "SELECT * FROM " . $prefix . "_st_verein WHERE name LIKE '%$param%' OR v_id LIKE '%$param%' ORDER BY v_id	";
  $result = sql_query ( $sql );
  
  $log = date ( DATE_RSS );
  $log .= $sql . "\n";
  $ok = file_put_contents ( $LogFile, $log . PHP_EOL, FILE_APPEND );
  
  $friends = array ();
  while ( $row = sql_fetch_assoc ( $result ) ) {
    $friends [] = array (
        "v_id" => $row ["v_id"],
        "name" => $row ["name"] 
    );
  }
  
  // echo JSON to page
  $response = $_GET ["callback"] . "(" . json_encode ( $friends ) . ")";
  
  $log = date ( DATE_RSS );
  $log .= $response . "\n";
  $ok = file_put_contents ( $LogFile, $log . PHP_EOL, FILE_APPEND );
  
  return $response;
}

function Get_Booking_Tooltip($b_id) {

  global $module_name;
  include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes/class.booking.php");
  $booking = new alaBooking_booking ();
  $ar_tooltip = $booking->getBookingTooltip ( $b_id );
  $booking = null;
  return $ar_tooltip;
}

function Get_Bookings($year, $month, $monthtoshow, $object) {

  $BookingObj = new alaBooking ();
  
  $ar_out = array ();
  $anz_row = intval ( $monthtoshow ['0'] );
  $anz_col = intval ( $monthtoshow ['2'] );
  $anzMonth = intval ( $anz_col * $anz_row );
  $anzMonth = ($anzMonth > 0) ? $anzMonth : 1;
  $dat_beg = sprintf ( "%04d-%02d-%02d", $year, $month, 1 );
  $dat_end = sprintf ( "%04d-%02d-%02d", $year, $month + $anzMonth, 31 );
  
  $sql = "SELECT * FROM `" . ALABOOKING_TABLE_BOOKING . "`";
  $sql .= " WHERE b_obj_id = " . $object;
  $sql .= " AND (";
  $sql .= " (b_begin >= '" . $dat_beg . "' AND b_begin <= '" . $dat_end . "')";
  $sql .= " OR (b_end >= '" . $dat_beg . "' AND b_end <= '" . $dat_end . "')";
  $sql .= " OR (b_begin <= '" . $dat_beg . "' AND b_end >= '" . $dat_end . "')";
  $sql .= " )";
  $sql .= " AND b_status >= " . STATUS_REQUESTED;
  $sql .= " AND b_status < " . STATUS_INACTIVE;
  $sql .= " ORDER BY b_begin ASC";
  // lachiDebugFuncVars ( $sql );
  
  $result = sql_query ( $sql );
  while ( $res_row = sql_fetch_assoc ( $result ) ) {
    // Transform from MySQL date to PHP date
    $tmp_date = trim ( $res_row ['b_begin'] );
    $dta = explode ( ' ', $tmp_date );
    $tms = $dta [1];
    $tms_begin = explode ( ':', $tms ); // array('13','30','40')
    $dta = $dta [0];
    $dta_begin = explode ( '-', $dta ); // array('2012','12','30')
    $php_begin = mktime ( $tms_begin [0], $tms_begin [1], $tms_begin [2], $dta_begin [1], $dta_begin [2], $dta_begin [0] );
    
    // Transform from MySQL date to PHP date
    $tmp_date = trim ( $res_row ['b_end'] );
    $dta = explode ( ' ', $tmp_date );
    $tms = $dta [1];
    $tms_end = explode ( ':', $tms ); // array('13','30','40')
    $dta = $dta [0];
    $dta_end = explode ( '-', $dta ); // array('2012','12','30')
    $php_end = mktime ( $tms_end [0], $tms_end [1], $tms_end [2], $dta_end [1], $dta_end [2], $dta_end [0] );
    $php_work = $php_begin;
    $i = 0;
    while ( $php_work <= $php_end ) {
      
      $key = mx_strftime ( '%Y-%m-%d', $php_work ); // 2015-12-24
                                                    // $date_rec [( string ) $key] = array (
                                                    // array (
                                                    // 'id' => $row ['b_id'],
                                                    // 'object' => $row ['b_obj_id']
                                                    // )
                                                    // )
      $date_rec [( string ) $key] [$row ['b_id']] = array (
          'id' => $row ['b_id'],
          'object' => $row ['b_obj_id'] 
      );
      
      // lachiDebugFuncVars ( $res_row );
      $row = array ();
      $row [] = mx_strftime ( '%m', $php_work ); // Monat
      $row [] = mx_strftime ( '%d', $php_work ); // Tag
      
      list ( $txt, $title, $class, $selectable ) = $BookingObj->get_StatusData ( $res_row ['b_status'] );
      $row [] = $class; // CSS-Klasse
      $row [] = $txt; // Statustext
      $row [] = $selectable; // Selectable
      $ar_out [] = $row;
      
      // Arbeitsdatum um einen Tag erhöhen:
      $i ++;
      $php_work = mktime ( $tms_begin [0], $tms_begin [1], $tms_begin [2], $dta_begin [1], $dta_begin [2] + $i, $dta_begin [0] );
    }
  }
  // lachiDebugFuncVars ( $ar_out );
  if (! $ar_out) {
    $ar_out = 'no valid data.';
  }
  
  return $ar_out;
}

function lachiDebugFuncVars() {

  global $LogFile;
  
  $log = "<pre style='font-size: 11
  px; text-align: 
  left;
  background: // FCFCFC; color: Black;'>\n";
  $args = func_get_args ();
  foreach ( $args as $i => $value ) {
    $log .= 'Argument <b>' . ($i + 1) . '</b>: ' . trim ( wordwrap ( htmlspecialchars ( print_r ( $value, true ) ), 200 ) ) . "\n";
  }
  $log .= "</pre>";
  
  $ok = file_put_contents ( $LogFile, $log . PHP_EOL, FILE_APPEND | FILE_TEXT );
  // $ok = mx_write_file($LogFile, $log, true);
}

/**
 * Hier geht es los:
 */

// Rückgabevariablen immer initialisieren!
$ar_out = array ();
$out = '';
// Übergabewerte ermitteln:
$g_year = $_GET ["g_year"];
$g_month = $_GET ['g_month'];
$g_monthtoshow = $_GET ['g_monthtoshow'];
$g_object = $_GET ['g_object'];
$b_id = $_GET ['b_id'];
$obj = $_GET ['obj'];

switch ($obj) {
  case 'bookings' :
    $ar_out = Get_Bookings ( $g_year, $g_month, $g_monthtoshow, $g_object );
    break;
  case 'b_tooltip' :
    if ((MX_IS_USER || MX_IS_ADMIN)) {
      $ar_out = Get_Booking_Tooltip ( $b_id );
    } else {
      $out = 'Unauthorised access!!!' . $obj;
    }
    break;
  default :
    $out = 'Unauthorised access!!!' . $obj;
    break;
}

/**
 * eventuelle Script oder Fehlerausgaben verwerfen
 */
for($i = 1; ($i <= 10 && ob_get_contents ()); $i ++) {
  ob_end_clean ();
}

// Rückgabewert an Aufrufer:
if ($ar_out) {
  echo json_encode ( $ar_out );
} else {
  echo json_encode ( $out );
}

?>
