<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
include_once ('../../mainfile.php');
$module_name = 'alaBooking';
define ( 'PMX_MODULE', $module_name );

// Haupt-Klasse: alaBooking
include_once ('core/tabledef.php');
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes" . DS . "class.alaBooking.php");
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes" . DS . "class.booking.php");

mxGetLangfile ( $module_name );

// include_once (PMX_MODULES_DIR . DS . 'WKAdm' . DS . 'includes' . DS . 'wka_lib_tools.php');
// include_once (PMX_MODULES_DIR . DS . 'WKAdm' . DS . 'includes' . DS . 'wka_lib_logfile.php');
// include_once(PMX_MODULES_DIR . DS . 'WKAdm' . DS . 'includes' . DS . 'class.teilnehmer.php');
// include_once(PMX_MODULES_DIR . DS . 'WKAdm' . DS . 'includes' . DS . 'wka_lib_teilnehmer.php');
/**
 * eventuelle Ausgaben zwischenspeichern, um sie spaeter zu verwerfen ;-)
 */
ob_start ();

/* Fehlerausgaben unterdruecken */
if (pmxDebug::is_mode ( 'enhanced' )) {
  pmxDebug::level ( pmxDebug::level_logfile );
}

// _defaults werden auch zur ChangeLog-Feldermittlung verwendet!
$ar_teilnehmer_defaults = array(/* Standardwerte */
            't_id' => '',
    't_name' => '',
    't_vorname' => '',
    't_geschlecht' => 'M',
    't_geburtsjahr' => 0,
    't_gebdat' => strftime ( _DATEPICKER, '00000000' ),
    't_strasse' => '',
    't_land' => 'D',
    't_plz' => '',
    't_ort' => '',
    't_verein' => '',
    't_email' => '',
    't_anlage_vg_id' => '',
    
    't_vereinsbez' => ''  // View-Feld - keine DB-Spalte
);

function teilnehmer_get_data($id) {
  // DB-Prefix:
  global $prefix, $ar_teilnehmer_defaults;
  
  $sql = "SELECT t.*, v.name as t_vereinsbez
                FROM `" . $prefix . "_wka_teilnehmer` AS t
                LEFT OUTER JOIN `" . $prefix . "_st_verein` AS v ON t.t_verein = v.v_id
                WHERE t_id=" . intval ( $id );
  $result = sql_query ( $sql );
  $row = sql_fetch_assoc ( $result );
  if (! $row) {
    return $ar_teilnehmer_defaults;
  }
  return array_merge ( $ar_teilnehmer_defaults, $row );
}

function insert_teilnehmer($data) {
  
  // DB-Prefix:
  global $prefix, $ar_teilnehmer_defaults;
  
  // Check if array has to be converted from utf8?
  $data = wka_utf8Decode ( $data );
  //lachiDebugFuncVars ( $data );
  
  // Neuer Teilnehmer?:
  $data ['t_id'] = empty ( $data ['t_id'] ) ? 0 : $data ['t_id'];
  // Falls existierender Teilnehmer:
  if ($data ['t_id'] != 0) {
    $data_old = teilnehmer_get_data ( $data ['t_id'] );
    $context = (empty ( $data ['context'] )) ? 'Modaler Dialog' : $data ['context'];
  } else {
    $data_old = array ();
  }
  
  $ar_upd_fields = array (); // Welche Felder sollen im ChageLog berücksichtigt werden?
                             
  // Daten checken:
  $data ['t_geburtsjahr'] = empty ( $data ['t_geburtsjahr'] ) ? 0 : $data ['t_geburtsjahr'];
  $data ['t_geschlecht'] = empty ( $data ['t_geschlecht'] ) ? 'M' : $data ['t_geschlecht'];
  $data ['t_verein'] = empty ( $data ['t_verein'] ) ? '' : $data ['t_verein'];
  $data ['t_gebdat'] = empty ( $data ['t_gebdat'] ) ? $data ['t_geburtsjahr'] . '-01-01' : $data ['t_gebdat'];
  
  // Mapping der Dialog-Widgets zu DB-Felder
  $fields = array ();
  $fields [] = "t_name = '" . mxAddSlashesForSQL ( $data ['t_name'] ) . "'";
  $ar_upd_fields ['t_name'] = '';
  $fields [] = "t_vorname = '" . mxAddSlashesForSQL ( $data ['t_vorname'] ) . "'";
  $ar_upd_fields ['t_vorname'] = '';
  $fields [] = "t_geschlecht = '" . mxAddSlashesForSQL ( $data ['t_geschlecht'] ) . "'";
  $ar_upd_fields ['t_geschlecht'] = '';
  $fields [] = "t_geburtsjahr = " . $data ['t_geburtsjahr'];
  $ar_upd_fields ['t_geburtsjahr'] = '';
  $fields [] = "t_gebdat = '" . $data ['t_gebdat'] . "'";
  $ar_upd_fields ['t_gebdat'] = '';
  $fields [] = "t_verein = '" . mxAddSlashesForSQL ( strtoupper ( $data ['t_verein'] ) ) . "'";
  $ar_upd_fields ['t_verein'] = '';
  $fields [] = "t_aenderdat = NOW()";
  
  if ($data ['t_id'] == 0) {
    $sql = "INSERT INTO " . $prefix . "_wka_teilnehmer SET " . implode ( ', ', $fields );
  } else {
    $sql = "UPDATE " . $prefix . "_wka_teilnehmer SET " . implode ( ', ', $fields );
    $sql .= " WHERE t_id=" . intval ( $data ['t_id'] );
  }
  $LogFile = "json.log";
  $ok = file_put_contents ( $LogFile, $sql, FILE_APPEND | FILE_TEXT );
  
  $result = sql_query ( $sql );
  
  // if ($result) {
  // $data['t_id'] = sql_insert_id();
  // $messages = utf8_encode('Neuer Teilnehmer <em>' . $data['t_name']. ", " . $data['t_vorname'] . '</em> erfolgreich in die Datenbank eingefuegt!');
  // } else {
  // $messages = utf8_encode('Insert <b>fehlerhaft!</b>');
  // }
  //
  // return $messages;
  
  if ($result) {
    if ($data ['t_id'] == 0) {
      $data ['t_id'] = sql_insert_id ();
      $message = 'Neuer Teilnehmer <em>' . $data ['t_name'] . ", " . $data ['t_vorname'] . '</em> erfolgreich in die Datenbank eingefuegt!';
      // Logfile
      wka_LogFileEntry ( $prefix . '_wka_teilnehmer', 'INSERT: ' . $data ['t_id'] . '; ' . $data ['t_name'] . ", " . $data ['t_vorname'], true );
    } else {
      $message = 'Teilnehmerdaten <em>' . $data ['t_name'] . ", " . $data ['t_vorname'] . '</em> erfolgreich in der Datenbank aktualisiert!';
      // Logfile
      // wka_LogFileEntry($prefix . '_wka_teilnehmer', 'UPDATE: ' . $data['t_id'] . '; ' . $data['t_name']. ", " . $data['t_vorname'], true);
      // ChangeLog
      wka_EntryChangeLog ( $prefix . "_wka_teilnehmer", $data ['t_id'], $ar_upd_fields, $data, $data_old, $context );
    }
    // query the database
    $sql = "SELECT t_id, t_name, t_vorname, t_verein, t_geburtsjahr, t_geschlecht, (EXTRACT(YEAR FROM curdate()) - t_geburtsjahr) as t_alter, a_klasse, a_geschlecht, a_bezeichnung\n" . "FROM `" . $prefix . "_wka_teilnehmer` as t \n" . "LEFT JOIN `" . $prefix . "_wka_altersklassen` as a\n" . "ON (\n" . " (EXTRACT(YEAR FROM curdate()) - t_geburtsjahr) between a.a_vonalter and a.a_bisalter\n" . "AND\n" . " t_geschlecht = a_geschlecht) WHERE t_id = " . $data ['t_id'];
    $result = sql_query ( $sql );
    
    $ar_teiln = array ();
    
    while ( $row = sql_fetch_assoc ( $result ) ) {
      $ar_teiln = array (
          "db_status" => 0,
          "db_message" => $message,
          "t_id" => $row ["t_id"],
          "t_name" => $row ["t_name"],
          "t_vorname" => $row ["t_vorname"],
          "t_verein" => $row ["t_verein"],
          "t_geburtsjahr" => $row ["t_geburtsjahr"],
          "t_geschlecht" => $row ["t_geschlecht"],
          "t_alter" => $row ["t_alter"],
          "a_klasse" => $row ["a_klasse"],
          "a_bezeichnung" => $row ["a_bezeichnung"] 
      );
    }
  } else {
    $message = 'Insert <b>fehlerhaft!</b>';
    $ar_teiln = array (
        "db_status" => 9,
        "db_message" => $message 
    );
  }
  
  return json_encode ( $ar_teiln );
}

function insert_verein($data) {
  
  // DB-Prefix:
  global $prefix;
  
  //lachiDebugFuncVars ( $data );
  
  // Mapping der Dialog-Widgets zu DB-Felder
  $fields = array ();
  $fields [] = "name = '" . mxAddSlashesForSQL ( $data ['v_name'] ) . "'";
  $fields [] = "plz = '" . mxAddSlashesForSQL ( $data ['v_plz'] ) . "'";
  $fields [] = "ort = '" . mxAddSlashesForSQL ( $data ['v_ort'] ) . "'";
  $fields [] = "homepage = '" . mxAddSlashesForSQL ( $data ['v_homepage'] ) . "'";
  $fields [] = "landesverband = '" . mxAddSlashesForSQL ( $data ['v_landesverband'] ) . "'";
  $fields [] = "kreis = '" . mxAddSlashesForSQL ( $data ['v_kreis'] ) . "'";
  
  // Key hinzufügen:
  $fields [] = "v_id = '" . mxAddSlashesForSQL ( $data ['v_id'] ) . "'";
  
  $sql = "INSERT INTO " . $prefix . "_st_verein SET " . implode ( ', ', $fields );
  $result = sql_query ( $sql );
  
  if ($result) {
    $message = 'Neuer Verein <b>' . $data ['v_id'] . '</b> erfolgreich in die Datenbank eingefuegt!';
    // query the database
    $result = sql_query ( "SELECT * FROM " . $prefix . "_st_verein WHERE v_id = '" . mxAddSlashesForSQL ( $data ['v_id'] ) . "'" );
    $friends = array ();
    
    while ( $row = sql_fetch_assoc ( $result ) ) {
      // $friends = array("db_status" => 0,
      // "db_message" => utf8_encode( $message ),
      // "v_id" => utf8_encode($row["v_id"]),
      // "name" => utf8_encode($row["name"]));
      $friends = array (
          "db_status" => 0,
          "db_message" => $message,
          "v_id" => $row ["v_id"],
          "name" => $row ["name"] 
      );
    }
  } else {
    $message = 'Insert <b>fehlerhaft!</b>';
    $friends = array (
        "db_status" => 9,
        "db_message" => $message 
    );
  }
  
  return json_encode ( $friends );
}

function booking_status_update($postvar) {

  global $module_name;
  
  // POST-Übergabewerte:
  // b_id : b_id,
  // b_newstat : new_stat,
  // b_addr_email: Addr_eMail,
  // b_send_email: Send_eMail,
  // b_copy_email: Copy_eMail,
  // b_note_email: Note_eMail,
  
  $ReturnToSender = array ();
  
  // den bisherigen Buchungssatz:
  $ObjBooking = new alaBooking_booking ();
  $data = $ObjBooking->get_data ( $postvar ['b_id'] );
  list ( $old_txt, $old_title, $old_class ) = $ObjBooking->get_StatusData ( $data ['b_status'] );
  
  // Änderungen vornehmen:
  $data ['b_status'] = $postvar ['b_newstat'];
  $data ['b_newstat'] = $postvar ['b_newstat'];
  // eMail-Aktivitäten:
  $data ['email_receiver'] = $postvar ['email_receiver']; // eMail-Adresse
  $data ['email_send'] = $postvar ['email_send']; // eMail senden?
  $data ['email_copy'] = $postvar ['email_copy']; // eMail-Kope an Absender?
  $data ['email_note'] = $postvar ['email_note']; // eMail-Bemerkungstext
  $ok = $ObjBooking->edit_send_save ( $data );
  
  $status = ''; // 'E'rror, 'W'arning oder '';
  $message = '<ul><li>' . implode ( '</li><li>', $ObjBooking->_messages ) . '</li></ul>';
    
  // Für den neuen Status noch die CSS-Klasse ermitteln:
  list ( $new_txt, $new_title, $new_class ) = $ObjBooking->get_StatusData ( $postvar ['b_newstat'] );
  
  $ReturnToSender = array (
      'db_status' => $status,
      'db_message' => $message,
      'b_id' => $postvar ['b_id'],
      'b_newstat' => $postvar ['b_newstat'],
      'class_old' => $old_class,
      'class_new' => $new_class 
  );
  return json_encode ( $ReturnToSender );
}

/**
 * Debug-Funktion in Datei:
 */
function lachiDebugFuncVars() {

  $log = "<pre style='font-size: 11px; text-align: left; background: #FCFCFC; color: Black;'>\n";
  $args = func_get_args ();
  foreach ( $args as $i => $value ) {
    $log .= 'Argument <b>' . ($i + 1) . '</b>: ' . trim ( wordwrap ( htmlspecialchars ( print_r ( $value, true ) ), 200 ) ) . "\n";
  }
  $log .= "</pre>";
  
  $LogFile = "alaBooking_upd.ajax.log";
  $ok = file_put_contents ( $LogFile, $log . PHP_EOL, FILE_APPEND | FILE_TEXT );
}

/**
 * Hier geht es los:
 */
if (MX_IS_USER || MX_IS_ADMIN) {
  
  // getJSON: parameter 'term' enthaelt den Suchstring
  $param = $_POST ["term"];
  $obj = $_POST ['obj'];
  
  $param = (! empty ( $param )) ? $param : 'LACHI';
  $obj = (! empty ( $obj )) ? $obj : 'tn';
  
  // Protokollieren der Übergabeparameter:
  //lachiDebugFuncVars ( $_POST );
  
  switch ($obj) {
    case 'UPD_B_STATUS' : // Vereinsdaten
      $out = booking_status_update ( $_POST );
      break;
    case 'teiln' : // Teilnehmerdaten
      $out = insert_teilnehmer ( $_POST );
      break;
    default :
      $out = '';
      break;
  }
  
  // Zum Debuggen:
  // lachiDebugFuncVars ( $out );
} else {
  $out = '';
}

/**
 * eventuelle Script oder Fehlerausgaben verwerfen
 */
for($i = 1; ($i <= 10 && ob_get_contents ()); $i ++) {
  ob_end_clean ();
}

// Rückgabewert an Aufrufer:
echo $out;
?>
