<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );
$modname = basename ( dirname ( __DIR__ ) );

include_once (dirname ( __FILE__ ) . DS . "tabledef.php");

unset ( $sqlqry );
// Objekte/Ressourcen
if (! isset ( $tables [ALABOOKING_TABLE_OBJECT] )) {
  $sqlqry [] = "
CREATE TABLE `" . ALABOOKING_TABLE_OBJECT . "` (
  `obj_id`  bigint(20) NOT NULL  AUTO_INCREMENT,
  `module` varchar(255) NOT NULL,
  `obj_name` varchar(255) NOT NULL,
  `obj_parent_id`  bigint(20) NULL,
  `obj_picture`  varchar(250) NULL,
  `obj_shortdescr` text NULL,
  `obj_description` text NULL COMMENT 'Kurzbeschreibung',
  `obj_bookingtype` int(2) NULL COMMENT '0=FullDay;1=Time',
  `obj_status` int(2) NULL COMMENT '0=requested;2=active;8=inactive;9=canceled',
  `obj_mod_date` datetime NOT NULL,
    PRIMARY KEY  (`obj_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (! isset ( $tables [ALABOOKING_TABLE_BOOKING] )) {
  $sqlqry [] = "
	CREATE TABLE `" . ALABOOKING_TABLE_BOOKING . "` (
    `b_id`  bigint(20) NOT NULL  AUTO_INCREMENT,
	`module` varchar(255) NOT NULL,
    `b_obj_id` bigint(20) NOT NULL,
	`b_begin` datetime NOT NULL,
	`b_end` datetime NOT NULL,
	`b_name` varchar(255) NOT NULL default '',
	`b_firstname` varchar(255) NOT NULL default '',
    `b_street` varchar(255) NULL,
    `b_country` varchar(255) NULL,
    `b_zip` varchar(255) NULL,
    `b_city` varchar(255) NULL,
	`b_email` varchar(255) NOT NULL default '',
	`b_phone` varchar(80) NOT NULL default '',
	`b_description` text NULL,
	`b_status` int(2) NULL COMMENT '0=request;1=confirmed;9=canceled',
	`b_creation_date` datetime NOT NULL,
	`b_uid` int(11) NULL, 
      PRIMARY KEY  (`b_id`)
	) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;
	";
}

if (! isset ( $tables [ALABOOKING_TABLE_BCOM] )) {
	$sqlqry [] = "
	CREATE TABLE `" . ALABOOKING_TABLE_BCOM . "` (
    `bcom_id`  bigint(20) NOT NULL  AUTO_INCREMENT,
	`module` varchar(255) NOT NULL,
    `bcom_b_id` bigint(20) NOT NULL,
	`bcom_receiver` varchar(255) NOT NULL default '',
	`bcom_sender` varchar(255) NOT NULL default '',
	`bcom_subject` varchar(255) NOT NULL default '',
	`bcom_message` text NULL,
	`bcom_type` varchar(30) NULL COMMENT 'text or html',
	`bcom_status` int(2) NULL COMMENT '0=error;1=send',
	`bcom_ts` timestamp DEFAULT CURRENT_TIMESTAMP,
      PRIMARY KEY  (`bcom_id`)
	) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;
	";
}
if (isset ( $sqlqry )) {
  setupDoAllQueries ( $sqlqry );
  unset ( $sqlqry );
}

?>