<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
/*
#alaBooking
RewriteRule ^alaBooking-object-detail-[^0-9]*-([0-9]+)(-.*)?\.html$ mod.php?name=alaBooking&op=object_detail&obj_id=$1&_MORE_=$2 [L]
RewriteRule ^alaBooking-booking-[^0-9]*-([0-9]+)(-.*)?\.html$ mod.php?name=alaBooking&op=booking&obj_id=$1&_MORE_=$2 [L]

*/

$hook = function ($name, $parameter, &$replaces) {
  
  if (! isset ( $parameter [$name] )) {
    return;
  }
  global $prefix;
  
  include_once ('modules'.DS.$name.DS.'core'.DS.'tabledef.php');
  
  $poll = array ();
  $objects = array ();
  $booking = array ();
  
  foreach ( $parameter [$name] as $key => $para ) {
    switch (true) {
      case ((isset ( $para ['op'] ) && $para ['op'] == 'object_detail') && (isset ( $para ['obj_id'] ) && intval ( $para ['obj_id'] ))) :
        $objects [0] [] = $para ['obj_id'];
        $objects [$key] = $para;
        break;
      case ((isset ( $para ['op'] ) && $para ['op'] == 'booking') && (isset ( $para ['obj_id'] ) && intval ( $para ['obj_id'] ))) :
        $booking [0] [] = $para ['obj_id'];
        $booking [$key] = $para;
        break;
    }
  }
  
  /**
   * alaBooking-object-detail-BEZEICHNUNG-3.html
   * RewriteRule ^alaBooking-object-detail-[^0-9]*-([0-9]+)(-.*)?\.html$ mod.php?name=alaBooking&op=object_detail&obj_id=$1&_MORE_=$2 [L]
   */
  if ($objects) {
    $inquery = implode ( ',', array_unique ( array_shift ( $objects ) ) );
    $qry = "SELECT obj_id, obj_name FROM " . ALABOOKING_TABLE_OBJECT . " WHERE `obj_id` in ($inquery)";
    $result = sql_query ( $qry );
    $titles = array ();
    while ( list ( $obj_id, $obj_name ) = sql_fetch_row ( $result ) ) {
      /**
       * den aus der DB ausgelesenen Titel als URL tauglich machen
       * - Umlaute werden umgeschrieben
       * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
       * Einstellung:
       * der zweite Parameter der Funktion, als Sonderzeichenersatz
       */
      $titles [$obj_id] = pmxModrewrite::title_entities ( $obj_name, '-' );
    }
    
    foreach ( $objects as $key => $link ) {
      if (isset ( $titles [$link ['obj_id']] )) {
        /**
         * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
         * also getrennt mit den Bindestrichen
         * Einstellung:
         * alle Parameter, die nicht benötigt werden, weil sie z.B.
         * anderweitig
         * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
         * übergeben
         */
        $new_url = pmxModrewrite::title_parameters ( $link, 'obj_id', 'op' );
        /**
         * den neuen URL zusammensetzen
         * Einstellung:
         * nach belieben zusammensetzen und entspr.
         * die .htaccess anpassen
         */
        // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
        $new_url = $name . '-object-detail-' . $titles [$link ['obj_id']] . '-' . $link ['obj_id'] . $new_url;
        /**
         * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
         * Einstellung: keine, muss exakt so bleiben!
         */
        $replaces [$key] = $link ['prefix'] . $new_url . $link ['suffix'];
      }
    }
  }
  
  
  /**
   * alaBooking-booking-BEZEICHNUNG-3.html
   * RewriteRule ^alaBooking-booking-[^0-9]*-([0-9]+)(-.*)?\.html$ mod.php?name=alaBooking&op=booking&obj_id=$1&_MORE_=$2 [L]
   */
  if ($booking) {
  	$inquery = implode ( ',', array_unique ( array_shift ( $booking ) ) );
  	$qry = "SELECT obj_id, obj_name FROM " . ALABOOKING_TABLE_OBJECT . " WHERE `obj_id` in ($inquery)";
  	$result = sql_query ( $qry );
  	$titles = array ();
  	while ( list ( $obj_id, $obj_name ) = sql_fetch_row ( $result ) ) {
  		/**
  		 * den aus der DB ausgelesenen Titel als URL tauglich machen
  		 * - Umlaute werden umgeschrieben
  		 * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
  		 * Einstellung:
  		 * der zweite Parameter der Funktion, als Sonderzeichenersatz
  		 */
  		$titles [$obj_id] = pmxModrewrite::title_entities ( $obj_name, '-' );
  	}
  
  	foreach ( $booking as $key => $link ) {
  		if (isset ( $titles [$link ['obj_id']] )) {
  			/**
  			 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
  			 * also getrennt mit den Bindestrichen
  			 * Einstellung:
  			 * alle Parameter, die nicht benötigt werden, weil sie z.B.
  			 * anderweitig
  			 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
  			 * übergeben
  			 */
  			$new_url = pmxModrewrite::title_parameters ( $link, 'obj_id', 'op' );
  			/**
  			 * den neuen URL zusammensetzen
  			 * Einstellung:
  			 * nach belieben zusammensetzen und entspr.
  			 * die .htaccess anpassen
  			*/
  			// $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
  			$new_url = $name . '-booking-' . $titles [$link ['obj_id']] . '-' . $link ['obj_id'] . $new_url;
  			/**
  			 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
  			 * Einstellung: keine, muss exakt so bleiben!
  			 */
  			$replaces [$key] = $link ['prefix'] . $new_url . $link ['suffix'];
  		}
  	}
  }
  
}

?>