<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

// eigene Includes einbinden
// $module_name ist hier 'admin';

// Haupt-Klasse: alaBooking
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes/class.alaBooking.php");

/**
 * alaBooking_admin
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_admin extends alaBooking {
	private $op = null;
	protected $_adminmode;
	
	/**
	 * alaBooking_admin::__construct()
	 *
	 * @param string $parameter        	
	 */
	function __construct($parameter = "") {
		global $prefix;
		
		parent::__construct ();
		
		if (! $this->_is_admin) {
			return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
		}
		$admindata = mxGetAdminSession ();
		$this->_adminmode = true; // Aufruf über die admin.php
		                          
		// Operator in Klassenvariable:
		$this->op = $parameter;
		
		// In die gewuenschte sektion/aktion verzweigen:
		switch ($this->op) {
			case "" : // Keine Funktionsauswahl - nur Constructur!
				return;
			case 'alaBooking/settings' :
				return $this->admin_settings ( $this->op );
				break;
			default :
				return $this->admin_main ( $this->op );
				break;
		}
	}
	
	/**
	 * Haupt-Navigation des Admin-Bereiches (nur Toolbar)
	 *
	 * @param unknown_type $op        	
	 */
	function admin_main($op) {
		global $credits;
		
		$tb = load_class ( 'AdminForm', "adminFormMain" );
		$tb->tb_text = _ALABOOKING_ADMIN;
		$tb->tb_direction = 'right';
		$tb->infobutton = true;
		$tb->tb_pic_heigth = 22;
		$tb->csstoolbar = "toolbar1";
	    $tb->cssform = "adminForm";
		$tb->homelink = false;
		
		// $tb->addToolbar("save");
		
		$tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
		$tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/calendar", _ALABOOKING_BTN_CALENDAR, $this->_module_image_path . 'alaBooking.png' );
		$tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/object", _ALABOOKING_BTN_OBJECT, $this->_module_image_path . 'alaObjects.png' );
		$tb->addToolbarLink ( "settings", "admin.php?op=" . $this->_module_name . "/settings", _ALABOOKING_BTN_SETTINGS, PMX_IMAGE_PATH . 'adminform/settings.png' );
		// $tb->addToolbarLink("cpanel", "admin.php?op=" . $this->_module_name);
		
		$form = $tb->Show ();
		$form .= "<hr><p class=\"align-center\" >$credits</p>";
		$form .= $this->alaBooking_vcheck ();
		
		// Check, whether mod_rewrite's customizing is correct:
		$this->check_mod_rewrite_settings ();
		
		$this->adminpage ( $form );
	}
	
	/**
	 * Prüfen, ob die mod_rewrite - Settings aktiviert sind und in der
	 * Datei '.htaccess' die
	 * notwendigen Einträge vorhanden sind...
	 */
	function check_mod_rewrite_settings() {
		load_class ( 'Modrewrite', false );
		$seo = load_class ( 'Config', 'pmx.seo' );
		$seo_config = $seo->get ();
		
		switch (true) {
			case ! file_exists ( PMX_REAL_BASE_DIR . DS . '.htaccess' ) :
				// $this->_warnings [] = _ALABOOKING_MODREWRITE_NOHTACCESS; 
				break;
			case ! $seo_config ['modrewriteextend'] : // Sind modul-extensions unterstützt?
			                                          // $this->_warnings [] = "mod_rewrite - Modulextension ist:".$seo_config['modrewriteextend'];
				break;
			case ! ($htaccess = file_get_contents ( '.htaccess' )) :
			case ! $htaccess :
			// case ! preg_match ( '!(RewriteEngine\s+on).*(\sRewriteRule\s)!si', $htaccess ) :
			case ! preg_match ( '/RewriteRule \^' . $this->_module_name . '-object-detail/', $htaccess ) :
				$this->_warnings [] = _ALABOOKING_MODREWRITE_MISSINGENTRY1 . ": <b>" . $this->_module_name . "</b>";
				$this->_warnings [] = _ALABOOKING_MODREWRITE_MISSINGENTRY2;
				break;
			default :
				break;
		}
	}
	
	/**
	 * Settings zum Modul...
	 * @param unknown $op
	 */
	function admin_settings($op) {
		// Nur Systemadministratoren!
		if (! MX_IS_SYSADMIN) {
			return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
		}
		
		// Formular initialisieren:
		$tb = load_class ( 'AdminForm', "adminFormMain" );
		
		// Verarbeitung der Aktionen:
		// 1. wurde ein AdminForm-Button gedrückt?
		switch (pmxAdminForm::CheckButton ()) {
			case "save" :
			case "accept" :
				$temp = $_POST ['config'];
				$this->config_save ( $temp );
				mxRedirect ( "admin.php?op=" . $this->_module_name . "/settings", _CHANGESAREOK, 1 );
				break;
		}
		
		// Formular initialisieren:
		$tb = load_class ( 'AdminForm', "adminFormMain" );
		$tb->tb_text = _ALABOOKING_BTN_SETTINGS;
		$tb->tb_direction = 'right';
		$tb->infobutton = $this->_config ['FormInfobutton'];
		$tb->tb_pic_heigth = 22;
		$tb->csstoolbar = "toolbar1";
	    $tb->cssform = "adminForm";
	    $tb->homelink = false;
		
		$tb->addToolbar ( "save" );
		$tb->addToolbarLink ( "email", "admin.php?op=" . $this->_module_name . "/email/settings", _ALABOOKING_BTN_EMAILSETTINGS, PMX_IMAGE_PATH . 'adminform/mail.png' );
		$tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
		
		// Die Objecte in das Optionsmenü:
		
		// Datumsformate
		$selDateFormat = array (
				mx_strftime ( '%d. %B %Y' ) => '%d. %B %Y',
				mx_strftime ( '%Y-%m-%d' ) => '%Y-%m-%d',
				mx_strftime ( '%m/%d/%Y' ) => '%m/%d/%Y',
				mx_strftime ( '%d/%m/%Y' ) => '%d/%m/%Y',
				mx_strftime ( '%d.%m.%Y' ) => '%d.%m.%Y',
				mx_strftime ( '%d.%m.%y' ) => '%d.%m.%y',
				strftime ( '%B' ) => '%B' 
		);
		
		// Zeitformate
		$selTimeFormat = array (
				date ( 'G:i' ) => 'G:i',
				date ( 'g:i A' ) => 'g:i A',
				date ( 'H:i' ) => 'H:i' 
		);
		
		// Kalender-Auswahlmöglichkeiten
		$selDateSelectionType = array (
				// _ALABOOKING_DATERANGE => 'range',
				_ALABOOKING_DATESINGLE => 'single',
				_ALABOOKING_DATEMULTIPLE => 'multiple' 
		);
		
		// Optionsmenü für die Objektanzeige im Kalenderblatt
		$selTimeTableObjects = array (
				_ALABOOKING_ALL => 'all',
				_ALABOOKING_ONE => 'one',
				_ALABOOKING_NONE => 'none' 
		);
		
		$i = 0;
		for($i; $i < 7; $i ++) {
			// der 10.Mai 2015 ist ein Sonntag :-)
			$mydate = mktime ( 0, 0, 0, 5, 10 + $i, 2015 );
			$selFirstDay [mx_strftime ( '%A', $mydate )] = $i;
		}
		
		// Kalenderblatt - Monate zur Anzeige
		for($x = 1; $x <= 6; $x ++) {
			for($y = 1; $y <= 6; $y ++) {
				$key = '[' . $y . ',' . $x . ']';
				$selCalMonthsToShow [$key] = $key;
			}
		}
		// Kalenderblatt - Schriftgröße
		$i = 50;
		for($i; $i <= 250; $i += 25) {
			$selCalFontSizePercent [$i . ' %'] = $i;
		}
		
		// Optionsmenü für die Formularfelder
		$selFormFieldEntry = array (
				_ALABOOKING_FIELD_HIDDEN => 'hidden',
				_ALABOOKING_FIELD_ENTRY => 'entry',
				_ALABOOKING_FIELD_REQUIRED => 'required' 
		);
		
		/* Form elements */
    /* FieldSet */
    $tb->addFieldSet ( "head", _ALABOOKING_CONF_TITLE, "", true );
		$tb->add ( "head", "date", "config[StartDatum]", mx_strftime ( _SHORTDATESTRING, $this->_config ['StartDatum'] ), _ALABOOKING_CONF_STARTDATUM, _ALABOOKING_CONF_STARTDATUM_INFO, 10 );
		$tb->add ( "head", "checkbox", "config[FormInfobutton]", $this->_config ['FormInfobutton'], _ALABOOKING_CONF_LOOK_FORMINFOBUTTON, _ALABOOKING_CONF_LOOK_FORMINFOBUTTON_INFO, 10 );
		$tb->add ( "head", "checkbox", "config[ViewTitle]", $this->_config ['ViewTitle'], _ALABOOKING_CONF_VIEWTITLE, _ALABOOKING_CONF_VIEWTITLE_INFO, 10 );
		$tb->add ( "head", "num", "config[NofObjectsPerPage]", $this->_config ['NofObjectsPerPage'], _ALABOOKING_CONF_NOFOBJECTSPERPAGE, _ALABOOKING_CONF_NOFOBJECTSPERPAGE_INFO, 4 );
		$tb->add ( "head", "editor", "config[Intro]", $this->_config ['Intro'], _ALABOOKING_CONF_MODULE_INTRO, _ALABOOKING_CONF_MODULE_INTRO_INFO, 40, array (
				'height' => 50 
		) );
		
		$tb->addFieldSet ( "calender", _ALABOOKING_CONF_CALENDER, "", true );
		$tb->add ( "calender", "select", "config[CalMonthsToShow]", $this->_config ['CalMonthsToShow'], _ALABOOKING_CONF_CALMONTHTOSHOW, _ALABOOKING_CONF_CALMONTHTOSHOW_INFO, 5, $selCalMonthsToShow );
		$tb->add ( "calender", "select", "config[DateFormat]", $this->_config ['DateFormat'], _ALABOOKING_CONF_DATEFORMAT, _ALABOOKING_CONF_DATEFORMAT_INFO, 10, $selDateFormat );
		$tb->add ( "calender", "select", "config[TimeFormat]", $this->_config ['TimeFormat'], _ALABOOKING_CONF_TIMEFORMAT, _ALABOOKING_CONF_TIMEFORMAT_INFO, 10, $selTimeFormat );
		$tb->add ( "calender", "input", "config[CalMultiSelect]", $this->_config ['CalMultiSelect'], _ALABOOKING_CONF_MULTISELECT, _ALABOOKING_CONF_MULTISELECT_INFO, 10 );
		$tb->add ( "calender", "select", "config[CalFirstDay]", $this->_config ['CalFirstDay'], _ALABOOKING_CONF_FIRSTDAY, _ALABOOKING_CONF_FIRSTDAY_INFO, 10, $selFirstDay );
		$tb->add ( "calender", "select", "config[CalFontSizePercent]", $this->_config ['CalFontSizePercent'], _ALABOOKING_CONF_CALFONTSIZEPERCENT, _ALABOOKING_CONF_CALFONTSIZEPERCENT_INFO, 5, $selCalFontSizePercent );
		
		$tb->addFieldSet ( "timetable", _ALABOOKING_CONF_TIMETABLE, "", true );
		$tb->add ( "timetable", "select", "config[TimeTableObjects]", $this->_config ['TimeTableObjects'], _ALABOOKING_CONF_TIMETABLERESOURCES, _ALABOOKING_CONF_TIMETABLERESOURCES_INFO, 10, $selTimeTableObjects );
		$tb->add ( "timetable", "color", "config[CalBGColorCurrDay]", $this->_config ['CalBGColorCurrDay'], _ALABOOKING_CALBGCURRDAY, _ALABOOKING_CALBGCURRDAY, 7 );
		$tb->add ( "timetable", "color", "config[CalBGColorDay6]", $this->_config ['CalBGColorDay6'], _ALABOOKING_CALBGCOLORDAY6, _ALABOOKING_CALBGCOLORDAY6, 7 );
		$tb->add ( "timetable", "color", "config[CalBGColorDay7]", $this->_config ['CalBGColorDay7'], _ALABOOKING_CALBGCOLORDAY7, _ALABOOKING_CALBGCOLORDAY7, 7 );
		$tb->add ( "timetable", "color", "config[CalColorLabelInBooking]", $this->_config ['CalColorLabelInBooking'], _ALABOOKING_CALCOLORLABELINBOOKING, _ALABOOKING_CALCOLORLABELINBOOKING, 7 );
		$tb->add ( "timetable", "color", "config[CalBGColorLabelInBooking]", $this->_config ['CalBGColorLabelInBooking'], _ALABOOKING_CALBGCOLORLABELINBOOKING, _ALABOOKING_CALBGCOLORLABELINBOOKING, 7 );
		
		$tb->addFieldSet ( "booking", _ALABOOKING_CONF_BOOKING, _ALABOOKING_FIELD_FORM, true );
		$tb->add ( "booking", "select", "config[BookingFormField][Street]", $this->_config ['BookingFormField'] ['Street'], _ALABOOKING_B_STREET, '', 10, $selFormFieldEntry );
		$tb->add ( "booking", "select", "config[BookingFormField][Zip]", $this->_config ['BookingFormField'] ['Zip'], _ALABOOKING_B_ZIP, '', 10, $selFormFieldEntry );
		$tb->add ( "booking", "select", "config[BookingFormField][Country]", $this->_config ['BookingFormField'] ['Country'], _ALABOOKING_B_COUNTRY, '', 10, $selFormFieldEntry );
		$tb->add ( "booking", "select", "config[BookingFormField][City]", $this->_config ['BookingFormField'] ['City'], _ALABOOKING_B_CITY, '', 10, $selFormFieldEntry );
		$tb->add ( "booking", "editor", "config[BookingRegIntro]", $this->_config ['BookingRegIntro'], _ALABOOKING_CONF_BOOKING_INTRO, _ALABOOKING_CONF_BOOKING_INTRO_INFO, 40, array (
				'height' => 50 
		) );
		$tb->add ( "booking", "editor", "config[BookingRegDisclaimer]", $this->_config ['BookingRegDisclaimer'], _ALABOOKING_CONF_BOOKING_DISCLAIMER, _ALABOOKING_CONF_BOOKING_DISCLAIMER_INFO, 40, array (
				'height' => 50 
		) );
		
		$tb->addFieldSet ( "colors", _ALABOOKING_CONF_BOOKING_COLORS, _ALABOOKING_CONF_BOOKING_COLORS_INFO, true );
		$tb->add ( "colors", "output", '<h3>' . _ALABOOKING_B_STATI . '</h3>' );
		$tb->add ( "colors", "color", "config[ColorStatusFree]", $this->_config ['ColorStatusFree'], _ALABOOKING_STATUS_FREE . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusFree]", $this->_config ['BGColorStatusFree'], _ALABOOKING_STATUS_FREE . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusRequested]", $this->_config ['ColorStatusRequested'], _ALABOOKING_STATUS_REQUESTED . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusRequested]", $this->_config ['BGColorStatusRequested'], _ALABOOKING_STATUS_REQUESTED . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusConfirmed]", $this->_config ['ColorStatusConfirmed'], _ALABOOKING_STATUS_CONFIRMED . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusConfirmed]", $this->_config ['BGColorStatusConfirmed'], _ALABOOKING_STATUS_CONFIRMED . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusActive]", $this->_config ['ColorStatusActive'], _ALABOOKING_STATUS_ACTIVE . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusActive]", $this->_config ['BGColorStatusActive'], _ALABOOKING_STATUS_ACTIVE . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusInactive]", $this->_config ['ColorStatusInactive'], _ALABOOKING_STATUS_INACTIVE . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusInactive]", $this->_config ['BGColorStatusInactive'], _ALABOOKING_STATUS_INACTIVE . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusDenied]", $this->_config ['ColorStatusDenied'], _ALABOOKING_STATUS_DENIED . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusDenied]", $this->_config ['BGColorStatusDenied'], _ALABOOKING_STATUS_DENIED . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		$tb->add ( "colors", "color", "config[ColorStatusCanceled]", $this->_config ['ColorStatusCanceled'], _ALABOOKING_STATUS_CANCELED . ': Color', _ALABOOKING_STYLE_COLOR, 7 );
		$tb->add ( "colors", "color", "config[BGColorStatusCanceled]", $this->_config ['BGColorStatusCanceled'], _ALABOOKING_STATUS_CANCELED . ': Background', _ALABOOKING_STYLE_BACKGROUND, 7 );
		
		$tb->addFieldSet ( "auth", _ALABOOKING_AUTH, '', true );
		$tb->add ( "auth", "info", _ALABOOKING_AUTH_INFO );
		$tb->add ( "auth", "selectusergroup", "config[authAdminGroup][]", $this->_config ['authAdminGroup'], _ALABOOKING_AUTH_ADMINGROUP, _ALABOOKING_AUTH_ADMINGROUP_INFO, 4, '', ' multiple=\"multiple\"' );
		$tb->add ( "auth", "selectuser", "config[authAdminUser][]", $this->_config ['authAdminUser'], _ALABOOKING_AUTH_ADMINUSER, _ALABOOKING_AUTH_ADMINUSER_INFO, 20, '', ' multiple=\"multiple\"' );
		
		$tb->addFieldSet ( "credits", _ALABOOKING_CREDITS, '', true );
		global $credits;
		$credits = "";
		include (PMX_MODULES_PATH . $this->_module_name . '/setup.pmx.php');
		$credits = '<div class="center">' . $credits . '<hr>';
		$credits .= 'Some functionality is based on free wp-extension <b>http://wpbookingcalendar.com</b><br>';
		$credits .= 'Using jQuery Datepicker from Keith-Wood <b>http://keith-wood.name/datepick.html</b><br>';
		$credits .= 'Using jQuery TimeEntry from Keith-Wood <b>http://keith-wood.name/timeEntry.html</b><br>' . "</div>";
		$tb->add ( "credits", "info", $credits );
		
		$form = $tb->Show ();
		
		// Seite ausgeben
		$this->adminpage ( $form );
	}
	private function alaBooking_vcheck() {
		global $currentlang, $alaBooking_version, $vkpIntranet;
		
		$check = '';
		
		if ($vkpIntranet)
			// return 'Intranet-Umgebung: Versionskontrolle nicht moeglich!';
			return $check;
			
			// Versionscheck nur 1x pro Sessionlifetime
		if ((mxSessionGetVar ( $this->_module_name . 'vcheck' ) + MX_SESSION_LIFETIME) > time ()) {
			return $check;
		}
		mxSessionSetVar ( $this->_module_name . 'vcheck', time () );
		
		$module = $this->_module_name;
		// Zuerst von der Versionsverwaltung die URL zum Modul-Check holen:
		$updateurl = $this->alaBooking_vcheck_connect ( "http://www.vcheck.alaniso.de/index.php" );
		if ($updateurl == false)
			return $check;
			
			// Versionscheck durchfuehren:
		$update1 = $this->alaBooking_vcheck_connect ( "http://" . $updateurl . "&module=" . $module . "&version=" . $alaBooking_version . "&lang=" . $currentlang . "&site=" . strip_tags ( PMX_HOME_URL ) );
		if ($update1 == false)
			return $check;
		
		$update = @unserialize ( json_decode ( trim ( $update1 ), TRUE ) );
		
		if (! is_array ( $update ))
			return $check;
		
		if ($update ['check']) { // ok
			$check .= "<div class=\"note\">";
			$check .= "<h4>" . $update ['title'] . "</h4>";
			$check .= $update ['text'] . ":" . $update ['version'] . "<br />";
			$check .= "<br />";
		} else { // new version
			$check .= "<div class=\"warning\">";
			$check .= "<h4>" . $update ['title'] . "</h4>";
			$check .= $update ['text'] . " [ " . $update ['version'] . " ]<br />";
			$check .= "<a href=\"" . $update ['updateurl'] . "\" target=\"_blank\" >" . $update ['updateurl'] . "</a><br />";
		}
		$check .= "<hr /><div class=\"tiny\">" . $update ['info'] . "&nbsp;:&nbsp;";
		$check .= "<a href=\"" . $update ['url'] . "\" target=\"_blank\" >" . $update ['url'] . "</a></div>";
		$check .= "</div>";
		
		return $check;
	}
	private function alaBooking_vcheck_connect($url = "") {
		if ($url == "")
			return;
		$useragent = $_SERVER ['HTTP_USER_AGENT'];
		$result = false;
		$msg = '';
		if (function_exists ( "curl_init" )) {
			/**
			 * cURL-Session initialisieren
			 */
			$ch = curl_init ( $url );
			/**
			 * Weiter Parameter der cURL-Session übergeben
			 */
			curl_setopt ( $ch, CURLOPT_URL, $url );
			curl_setopt ( $ch, CURLOPT_HEADER, 0 );
			// Post-Daten
			curl_setopt ( $ch, CURLOPT_POST, TRUE );
			curl_setopt ( $ch, CURLOPT_POSTFIELDS, $msg );
			
			/**
			 * cURL Anweisen, das die Übergabe
			 * zurückgegeben werden soll
			 */
			curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, TRUE );
			curl_setopt ( $ch, CURLOPT_FOLLOWLOCATION, 1 );
			
			/**
			 * cURL mitteilen, welcher Useragent übergeben
			 * werden soll.
			 */
			curl_setopt ( $ch, CURLOPT_USERAGENT, $useragent );
			/**
			 * cURL Rückgabe in $result speichern
			 */
			$result = @curl_exec ( $ch );
			curl_close ( $ch );
		} else {
			// echo "Function: curl_init nicht vorhanden!";
		}
		if (trim ( $result ) == "FORBIDDEN")
			return false;
		
		return $result;
	}
	
	/**
	 * alaBooking_admin::setup()
	 *
	 * @return
	 *
	 */
	public function setup() {
		require_once (dirname ( __FILE__ ) . DS . 'setup.php');
		$tmp_sup = new alaBooking_admin_setup ();
		$tmp_sup = null;
	}
}

?>