<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

// eigene Includes einbinden
// Tabellennamen:
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "core" . DS . "tabledef.php");
include (PMX_MODULES_DIR . DS . $module_name . DS . "setup.pmx.php");
global $alaBooking_version;

define ( 'STATUS_FREE', 0 );
define ( 'STATUS_REQUESTED', 1 );
define ( 'STATUS_CONFIRMED', 2 );
define ( 'STATUS_ACTIVE', 3 );
define ( 'STATUS_DENIED', 7 );
define ( 'STATUS_INACTIVE', 8 );
define ( 'STATUS_CANCELED', 9 );

/**
 * alaBooking
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking {
	/* Speichert die Instanz der Klasse */
	private static $_initialized = false;
	private $errors = array ();
	private $form = null;
	private $homepage = '';
	private static $__set = array (); // Konfiguration
	protected $_module_name = '';
	protected $_module_image_path = '';
	protected $_is_admin = false;
	protected $_adminmode = false; // es läuft über die admin.php
	protected $_user = array ();
	private static $ref_cfg; // Referenzvariable
	protected $_default_settings = array ();
	protected $_config = array ();
	protected $_tipp_status = array ();
	protected $_template; // Template zur HTML-Ausgabe
	protected $_messages = array ();
	protected $_warnings = array ();
	protected $_errors = array ();
	private $_perpage = 30;
	public $_tabs = array ();
	public $_use_bootstrap = false; // Depends on used Theme
	
	/**
	 * alaBooking::__construct()
	 *
	 * @param string $parameter        	
	 */
	function __construct() {
		
		// if (self::$_initialized) {
		// return;
		// }
		// self::$_initialized = true;
		mxGetLangfile ( PMX_MODULE );
		
		$this->_module_name = PMX_MODULE;
		$this->_module_image_path = PMX_MODULES_PATH . $this->_module_name . '/images/';
		
		// Defaults für die Settings
		$this->_default_settings = array(/* Standardwerte */
    		'StartDatum' => '',
				'FormInfobutton' => false,
				'ViewTitle' => true,
				'NofObjectsPerPage' => 5,
				'Intro' => _ALABOOKING_CONF_MODULE_INTRO_DEFAULT,
				'emailAdminNew' => array ( // eMail an Administrator bei Neuer Anfrage
						'Active' => true,
						'CopyToSender' => false,
						'Receiver' => $GLOBALS ['adminmail'],
						'Sender' => '[b_email]', // Substituionsfeld
						'Subject' => _ALABOOKING_EMAIL_BOOKINGNEWREQUEST,
						'MailContent' => ''  // Wird evt. in check_defaults gesetzt
								),
				'emailVisitorNew' => array ( // eMail an Seitenbesucher bei Neuer Anfrage
						'Active' => true,
						'CopyToSender' => false,
						'Receiver' => '[b_email]', // Substituionsfeld
						'Sender' => $GLOBALS ['adminmail'],
						'Subject' => _ALABOOKING_EMAIL_BOOKINGWASSENT,
						'MailContent' => ''  // Wird evt. in check_defaults gesetzt
								),
				'emailVisitorConfirm' => array ( // Buchungsbestätigung
						'Active' => true,
						'CopyToSender' => false,
						'Receiver' => '[b_email]', // Substituionsfeld
						'Sender' => $GLOBALS ['adminmail'],
						'Subject' => _ALABOOKING_EMAIL_BOOKINGCONFIRM,
						'MailContent' => ''  // Wird evt. in check_defaults gesetzt
								),
				'emailVisitorDeny' => array ( // Buchungs-Absage
						'Active' => true,
						'CopyToSender' => false,
						'Receiver' => '[b_email]', // Substituionsfeld
						'Sender' => $GLOBALS ['adminmail'],
						'Subject' => _ALABOOKING_EMAIL_BOOKINGDENY,
						'MailContent' => ''  // Wird evt. in check_defaults gesetzt
								),
				'emailVisitorCancel' => array ( // Löschung der Buchung
						'Active' => false,
						'CopyToSender' => false,
						'Receiver' => '[b_email]', // Substituionsfeld
						'Sender' => $GLOBALS ['adminmail'],
						'Subject' => _ALABOOKING_EMAIL_BOOKINGDENY,
						'MailContent' => ''  // Wird evt. in check_defaults gesetzt
								),
				'authAdminGroup' => "-1", // Gruppe der Administratoren
				'authAdminUser' => "0", // Einzelne Administratoren
				'BookingRegDisclaimer' => _ALABOOKING_CONF_BOOKING_DISCLAIMER_DEFAULT, // Disclaimer zur Buchung
				'BookingRegIntro' => _ALABOOKING_CONF_BOOKING_INTRO_DEFAULT, // Einleitungstext zur Buchung
				'BookingFormField' => array (
						'Street' => 'hidden',
						'Country' => 'hidden',
						'Zip' => 'hidden',
						'City' => 'hidden' 
				),
				'CalMonthsToShow' => '[1,1]', // maximale Anzahl von Monaten im Buchungskalender
				                              // 'CalDateSelectionType' => 'single', // Buchungskalender: Tagesauswahl (range, single, multiple)
				'CalMultiSelect' => 21, // Bei Mehrfachauswahl: Anzahl max. auswählbarer Tage
				'CalFirstDay' => 1, // // Erster Tag ist 0=Sonntag,1=Montag,ff.
				'CalFontSizePercent' => 100, // Schriftgröße des DatePicker
				'CalBGColorDay6' => '#FEB', // Hintergrundfarbe Samstag
				'CalBGColorDay7' => '#FEB', // Hintergrundfarbe Sonntag
				'CalBGColorCurrDay' => '#cdf3fe', // Hintergrundfarbe Aktueller Tag
				'CalColorLabelInBooking' => '#fff', // Schriftfarbe Belegungstext
				'CalBGColorLabelInBooking' => '#545455', // Hintergrundfarbe Belegungstext
				'DateFormat' => '%Y-%m-%d', // Datumsformat
				'TimeFormat' => 'G:i', // Zeitformat
				'TimeTableObjects' => 'none', // Anzeige der Objekte im TimeTable (all,one,none)
				'ColorStatusFree' => '#000000',
				'BGColorStatusFree' => 'inherit',
				'ColorStatusRequested' => '#000000',
				'BGColorStatusRequested' => '#FC4',
				'ColorStatusConfirmed' => '#000000',
				'BGColorStatusConfirmed' => '#78A',
				'ColorStatusActive' => '#000000',
				'BGColorStatusActive' => '#008040',
				'ColorStatusInactive' => '#ffffff',
				'BGColorStatusInactive' => '#804000',
				'ColorStatusDenied' => '#ffffff',
				'BGColorStatusDenied' => '#ff7575',
				'ColorStatusCanceled' => '#ffffff',
				'BGColorStatusCanceled' => '#ff4040' 
		);
		
		// Configuration: Objektreferenz erzeugen:
		self::$ref_cfg = load_class ( "Config", $this->_module_name );
		
		// Konfigurationsdaten lesen:
		$this->config_load ();
		
		switch (true) {
			case MX_IS_USER :
				$userinfo = mxGetUserData ();
				$this->_user = array(/* Userdaten */
            'uid' => $userinfo ['uid'],
						'uname' => $userinfo ['uname'],
						'email' => $userinfo ['email'],
						'user_ingroup' => $userinfo ['user_ingroup'],
						'city' => $userinfo ['user_from'] 
				);
				break;
			case MX_IS_ADMIN :
				$userinfo = mxGetAdminData ();
				if ($userinfo ['user_uid']) {
					/* Userdaten */
					$userinfo = mxGetUserDataFromUid ( $userinfo ['user_uid'] );
					$this->_user = array(/* Userdaten aus Admindaten */
              'uid' => $userinfo ['uid'],
							'uname' => $userinfo ['uname'],
							'email' => $userinfo ['email'],
							'user_ingroup' => $userinfo ['user_ingroup'],
							'city' => $userinfo ['user_from'] 
					);
				} else {
					$this->_user = array(/* Userdaten */
              'uid' => $userinfo ['uid'],
							'uname' => $userinfo ['aid'],
							'email' => $userinfo ['email'],
							'user_ingroup' => $userinfo ['user_ingroup'],
							'city' => $userinfo ['user_from'] 
					);
				}
				break;
			default :
				$this->_user = array(/* Userdaten */
            'uid' => '',
						'uname' => '',
						'email' => '',
						'user_ingroup' => '',
						'city' => '' 
				);
		}
		
		/* Administratorgruppen die das Modul administrieren dürfen */
		$this->_is_admin = false;
		switch (true) {
			case MX_IS_SYSADMIN :
				$this->_is_admin = true;
			// break;
			case MX_IS_ADMIN :
				// Einschränkung auf Benutzer?
				if (is_array ( $this->_config ['authAdminUser'] ))
					if (in_array ( $this->_user ['uid'], $this->_config ['authAdminUser'] )) {
						// mxDebugFuncvars ( 'authAdminUser is valid!' );
						$this->_is_admin = true;
						break;
					}
					
					// Einschränkung auf Benutzergruppe?
				if (is_array ( $this->_config ['authAdminGroup'] )) {
					if (in_array ( $this->_user ['user_ingroup'], $this->_config ['authAdminGroup'] )) {
						// mxDebugFuncvars ( 'authAdminGroup is valid!' );
						$this->_is_admin = true;
						break;
					}
					// Falls keine Benutzer/Gruppeneinschränkungen: Alle Administratoren!
					if (($this->_config ['authAdminGroup'] [0] == "-1") && ($this->_config ['authAdminUser'] [0] == '0')) {
						$this->_is_admin = true;
						// mxDebugFuncvars ( '-1 0 is detected: No access restrictions for Admins found!' );
						break;
					}
				}
			default :
				break;
		}
		
		// Tabs im der user-Ausgabe (page.html)
		
		$this->_tabs = array(/* Standardtabs */
        'object_detail' => _ALABOOKING_TAB_OBJECTDETAIL,
				'booking' => _ALABOOKING_TAB_BOOKING 
		);
		
		/* Wird ein bootstrap-Theme verwendet? */
		$this->_use_bootstrap = call_theme_use_bootstrap ();
		
		/* modulspezifisches Stylesheet einbinden */
		pmxHeader::add_style ( PMX_MODULES_PATH . $this->_module_name . '/style/style.css' );
		pmxHeader::add_style ( PMX_MODULES_PATH . $this->_module_name . '/style/style.alaBooking.css' ); // aus config
		
		/* Template initialisieren */
		$this->_template = load_class ( 'Template' );
		$this->_template->init_path ( __FILE__ );
		$this->_template->assign ( 'modulname', $this->_module_name );
		$this->_template->assign ( '_config', $this->_config );
		$this->_template->assign ( '_is_admin', $this->_is_admin );
		$this->_template->assign ( '_use_bootstrap', $this->_use_bootstrap );
	}
	
	/**
	 * Check, wheter a special template should be used...
	 *
	 * @param unknown $templatename        	
	 * @return string|unknown
	 */
	public function get_template_name($templatename) {
		$prefix = '';
		switch (true) {
			case ($this->_use_bootstrap) :
				$prefix = 'bt.';
				break;
			default :
				$prefix = '';
				break;
		}
		$new_templatename = $prefix . $templatename;
		
		$new_templatepath = $this->_template->getConfig ( 'template_path' )[0] . $new_templatename;
		if ($new_templatepath && is_file ( $new_templatepath )) {
			return $new_templatename;
		}
		return $templatename;
	}
	
	/**
	 * alaBooking::config_save()
	 * Konfiguration auslesen
	 *
	 * @param array $temp        	
	 * @return
	 *
	 */
	public function config_save($temp = array()) {
		if (! isset ( $this->ref_cfg )) {
			self::$ref_cfg = load_class ( "Config", $this->_module_name );
		}
		self::$ref_cfg->setSection ( $this->_module_name, $temp );
		// die style.alaBooking.css erstellen:
		$this->save_css_file ();
		
		return;
	}
	
	/**
	 * Schreiben der CSS-Datei zum Modul
	 */
	protected function save_css_file() {
		$CssFile = PMX_MODULES_PATH . $this->_module_name . "/style/style.alaBooking.css";
		
		include ($CssFile);
		extract ( $_POST, EXTR_OVERWRITE );
		
		global $credits;
		$credits = "";
		include (PMX_MODULES_PATH . $this->_module_name . '/setup.pmx.php');
		
		$cont = "/*" . "\n";
		$cont .= str_replace ( '<br />', '', mxHtmlEntityDecode ( $credits ) );
		$cont .= "*/" . "\n" . "\n";
		
		$cont .= "/* Farben Buchungsstatus */" . "\n";
		$cont .= "\n";
		
		$cont .= "/* Status Free */" . "\n";
		$col = ($this->_config ['ColorStatusFree']) ? '#' . $this->_config ['ColorStatusFree'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusFree']) ? '#' . $this->_config ['BGColorStatusFree'] : 'inherit';
		$cont .= ".booking-status-free," . "\n";
		$cont .= ".time_booked_in_day.free {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Status Requested */" . "\n";
		$col = ($this->_config ['ColorStatusRequested']) ? '#' . $this->_config ['ColorStatusRequested'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusRequested']) ? '#' . $this->_config ['BGColorStatusRequested'] : 'inherit';
		$cont .= ".booking-status-requested," . "\n";
		$cont .= ".time_booked_in_day.requested {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Status Confirmed */" . "\n";
		$col = ($this->_config ['ColorStatusConfirmed']) ? '#' . $this->_config ['ColorStatusConfirmed'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusConfirmed']) ? '#' . $this->_config ['BGColorStatusConfirmed'] : 'inherit';
		$cont .= ".booking-status-confirmed," . "\n";
		$cont .= ".time_booked_in_day.confirmed {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "";
		
		$cont .= "/* Status Active */" . "\n";
		$col = ($this->_config ['ColorStatusActive']) ? '#' . $this->_config ['ColorStatusActive'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusActive']) ? '#' . $this->_config ['BGColorStatusActive'] : 'inherit';
		$cont .= ".booking-status-active," . "\n";
		$cont .= ".time_booked_in_day.active {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Status Inactive */" . "\n";
		$col = ($this->_config ['ColorStatusInactive']) ? '#' . $this->_config ['ColorStatusInactive'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusInactive']) ? '#' . $this->_config ['BGColorStatusInactive'] : 'inherit';
		$cont .= ".booking-status-inactive," . "\n";
		$cont .= ".time_booked_in_day.inactive {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Status Denied */" . "\n";
		$col = ($this->_config ['ColorStatusDenied']) ? '#' . $this->_config ['ColorStatusDenied'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusDenied']) ? '#' . $this->_config ['BGColorStatusDenied'] : 'inherit';
		$cont .= ".booking-status-denied," . "\n";
		$cont .= ".time_booked_in_day.denied {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "";
		
		$cont .= "/* Status Canceled */" . "\n";
		$col = ($this->_config ['ColorStatusCanceled']) ? '#' . $this->_config ['ColorStatusCanceled'] : 'inherit';
		$bgcol = ($this->_config ['BGColorStatusCanceled']) ? '#' . $this->_config ['BGColorStatusCanceled'] : 'inherit';
		$cont .= ".booking-status-canceled," . "\n";
		$cont .= ".time_booked_in_day.canceled {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "";
		
		$cont .= "" . "\n";
		$cont .= "/* Farben Timeline */" . "\n";
		$cont .= "" . "\n";
		$cont .= "/* Aktueller Tag */" . "\n";
		$bgcol = ($this->_config ['CalBGColorCurrDay']) ? '#' . $this->_config ['CalBGColorCurrDay'] : 'inherit';
		$cont .= ".calendar_overview_cell.today_date {" . "\n";
		$cont .= "	background: " . $bgcol . " !important;" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Samstag */" . "\n";
		$bgcol = ($this->_config ['CalBGColorDay6']) ? '#' . $this->_config ['CalBGColorDay6'] : 'inherit';
		$cont .= ".matrix_resources .calendar_timeline_frame .calendar_overview_cell.weekday6,";
		$cont .= ".single_resource .calendar_timeline_frame .weekday6.calendar_overview_cell {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Sonntag */" . "\n";
		$bgcol = ($this->_config ['CalBGColorDay7']) ? '#' . $this->_config ['CalBGColorDay7'] : 'inherit';
		$cont .= ".matrix_resources .calendar_timeline_frame .calendar_overview_cell.weekday7,";
		$cont .= ".single_resource .calendar_timeline_frame .weekday7.calendar_overview_cell {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$cont .= "/* Label in Booking */" . "\n";
		$col = ($this->_config ['CalColorLabelInBooking']) ? '#' . $this->_config ['CalColorLabelInBooking'] : 'inherit';
		$bgcol = ($this->_config ['CalBGColorLabelInBooking']) ? '#' . $this->_config ['CalBGColorLabelInBooking'] : 'inherit';
		$cont .= "a.label_in_booking {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $bgcol . ";" . "\n";
		$cont .= "	color: " . $col . " !important;" . "\n";
		$cont .= "}" . "\n";
		$cont .= "a.label_in_booking:hover {" . "\n";
		$cont .= "	background: none repeat scroll 0 0 " . $col . ";" . "\n";
		$cont .= "	color: " . $bgcol . " !important;" . "\n";
		$cont .= "	text-shadow: 0px 0px 0px 0px;" . "\n";
		$cont .= "}" . "\n";
		$cont .= "" . "\n";
		
		$ok = mx_write_file ( $CssFile, $cont, false );
		
		return;
	}
	private function booking_mylink() {
		$link = "";
		$link .= '<a class="button myLinkButton" href="modules.php?name=' . $this->_module_name . '&amp;op=myBooking&amp;act=show" title="' . _ALABOOKING_MYBOOKING . '">' . _ALABOOKING_MYBOOKING . '</a>';
		
		return $link;
	}
	
	/**
	 * alaBooking::config_load()
	 *
	 * @return
	 *
	 */
	public function config_load() {
		
		// Config from System:
		$this->_config = self::$ref_cfg->getSection ( $this->_module_name );
		//
		if (count ( $this->_config ) == 0) { // Array leer
		                                     // defaultwerte eintragen
			$this->_config = $this->_default_settings;
			self::$ref_cfg->setSection ( $this->_module_name, $this->_config );
		} else {
			// Merge with Defaults:
			$this->_config = array_merge ( $this->_default_settings, $this->_config );
		}
	}
	
	/**
	 * alaBooking::__get()
	 *
	 * @param string $name        	
	 * @return
	 *
	 */
	public function __get($name) {
		if (array_key_exists ( $name, $this->_config )) {
			return $this->_config [$name];
		}
		$trace = debug_backtrace ();
		trigger_error ( 'undefined property \'' . $name . '\' in ' . mx_strip_sysdirs ( $trace [0] ['file'] ) . ' line ' . $trace [0] ['line'], E_USER_NOTICE );
		return null;
	}
	
	/**
	 * alaBooking::__set()
	 *
	 * @param string $name        	
	 * @param mixed $value        	
	 * @return
	 *
	 */
	public function __set($name, $value) {
		$this->_config [$name] = $value;
	}
	public function imgModul() {
		$images = "alaBooking.png";
		return "<img src=\"" . $this->_module_image_path . $images . "\" alt=\"\" />";
	}
	
	/**
	 *
	 * Enter description here ...
	 *
	 * @param unknown_type $form        	
	 */
	public function adminpage($form) {
		/*
		 * Template ist bereits im Konstruktor referenziert
		 */
		$info2 = $this->imgModul () . ' <span title = "Modulname: ' . $this->_module_name . '">' . _ALABOOKING . '</span>';
		
		/* hier die Ausgabefelder angeben */
		$this->_template->assign ( compact ( 'credits', 'toolbar', 'info2', 'form', 'formClose' ) );
		$this->_template->assign ( 'messages', $this->_messages );
		$this->_template->assign ( 'warnings', $this->_warnings );
		$this->_template->assign ( 'errors', $this->_errors );
		
		include ('header.php');
		/* Template ausgeben (echo) */
		$this->_template->display ( 'admin.html' );
		
		/* Footer: */
		$this->print_Footer ();
	}
	public function adminlink($routing) {
		$adminlink = "";
		
		/* graphiclinks */
		// $img_edit = "<img src=\"" . PMX_MODULES_PATH . $module_name . "/style/images/edit.png\" title=\"" . _DOCS_PAGE_EDIT . "\" style=\"margin-right:5px;\" />";
		// $img_new = "<img src=\"" . PMX_MODULES_PATH . $module_name . "/style/images/new.png\" title=\"" . _DOCS_PAGE_NEW . "\" style=\"margin-right:5px;\" />";
		$img_admin = "<img src=\"" . PMX_MODULES_PATH . $this->_module_name . "/images/administration.png\" title=\"" . _ALABOOKING_ADMIN_PANEEL . "\" style=\"margin-right:5px;\" />";
		
		if ($routing) {
			$adminlink .= ($this->_is_admin) ? "<a href=\"admin.php?op=$this->_module_name/" . $routing . "\" title=\"" . _ALABOOKING_ADMIN_PANEEL . "\">" . $img_admin . "</a>" : "";
		} else {
			$adminlink .= ($this->_is_admin) ? "<a href=\"admin.php?op=$this->_module_name\" title=\"" . _ALABOOKING_ADMIN_PANEEL . "\">" . $img_admin . "</a>" : "";
		}
		return $adminlink;
	}
	function page($form, $submodule = '') {
		$info2 = $this->imgModul () . ' <span title = "Modulname: ' . $this->_module_name . '">' . _ALABOOKING . '</span>';
		$myBookinglink = $this->booking_mylink ();
		// // Link zum Backend (Administration):
		// $adminlink = $this->adminlink ( $submodule );
		
		/* hier die Ausgabefelder angeben */
		$this->_template->assign ( 'tabs', $this->_tabs );
		$this->_template->assign ( compact ( 'myBookinglink', 'form', 'info2' ) );
		$this->_template->assign ( 'messages', $this->_messages );
		$this->_template->assign ( 'warnings', $this->_warnings );
		$this->_template->assign ( 'errors', $this->_errors );
		
		include ('header.php');
		/* Template ausgeben (echo) */
		$this->_template->display ( $this->get_template_name ( 'page.html' ) );
		/* Footer: */
		$this->print_Footer ();
	}
	
	/**
	 * alaBooking::pagination()
	 * Page Numbering
	 *
	 * @param mixed $count_rows        	
	 * @param mixed $start        	
	 * @param mixed $show        	
	 * @param mixed $link        	
	 * @return
	 *
	 */
	public function pagination($count_rows, $start, $show, $link) {
		$pages = ceil ( $count_rows / $show );
		// wenn weniger als 2 Seiten, nix anzeigen
		if ($pages <= 1) {
			return;
		}
		
		$max = intval ( $start + $show );
		$prev = intval ( $start - $show );
		$currentpage = ceil ( $max / $show );
		$start = '';
		$ende = '';
		$counter = 1;
		$part = array ();
		
		if ($currentpage > 3 && $pages > 6) {
			$start = '<a href="' . sprintf ( $link, 0 ) . '" title="' . _GOTOPAGEFIRST . '">1&nbsp;<span class="arrows">&laquo;</span></a><span class="points">..</span>';
			if ($currentpage >= $pages - 3) {
				$counter = $currentpage - ($currentpage - $pages + 4);
			} else {
				$counter = $currentpage - 1;
			}
		}
		// Schleife durch Suchergebnisse
		while ( $counter <= $pages ) {
			$mintemp = ($show * $counter) - $show;
			switch (true) {
				case ($counter > 5) && ($counter > $currentpage + 2) && ($counter < $pages) && $pages > 6 :
					$ende = '<span class="points">..</span><a href="' . sprintf ( $link, ($pages - 1) * $show ) . '" title="' . _GOTOPAGELAST . '"><span class="arrows">&raquo;</span>&nbsp;' . $pages . ' </a>';
					break 2;
				case $counter == $currentpage :
					$part [] = '<a href="' . sprintf ( $link, $mintemp ) . '" title="' . sprintf ( _PAGEOFPAGES, $currentpage, $pages ) . '" class="current">' . $counter . '</a>';
					break;
				default :
					$part [] = '<a href="' . sprintf ( $link, $mintemp ) . '" title="' . _GOTOPAGE . ' ' . $counter . '">' . $counter . '</a>';
			}
			
			$counter ++;
		}
		
		if ($part) {
			return '
            <div class="pagination align-right">
              <span class="counter">' . sprintf ( _PAGEOFPAGES, $currentpage, $pages ) . '</span>
              ' . $start . implode ( '', $part ) . $ende . '
            </div>';
		}
	}
	public function print_Footer() {
		// Autorenhinweis - bitte nicht entfernen!
		$year = (date ( "Y" ) > "2015") ? "2015-" . date ( "Y" ) : date ( "Y" );
		echo '<div class="clear"></div><div class="align-right tiny">' . _ALABOOKING . ' by <a href="http://www.alaniso.de" title="alaBooking &copy;' . $year . ' by aLaNiSo" target="_blank" >aLaNiSo</a></div><div class="clear"></div>';
		include ('footer.php');
	}
	
	/**
	 * alaBooking::convert_date()
	 * Konvertiert ein String-Datum, welches vom Datepicker kommt in
	 * einen Timestamp
	 *
	 * @param mixed $date        	
	 * @return integer timestamp
	 */
	protected function convert_date($date) {
		switch (true) {
			case is_numeric ( $date ) :
				return $date;
			case empty ( $date ) :
			case ! is_scalar ( $date ) :
				return 0;
			default :
				return mkfromstrptime ( $date, _DATEPICKER );
		}
	}
	
	/**
	 * alaBooking::convert_to_sql_date()
	 * Konvertiert ein String-Datum, welches vom Datepicker kommt in
	 * ein SQL-Format "YYYY-MM-DD"
	 *
	 * @param mixed $date        	
	 * @return integer timestamp
	 */
	protected function convert_to_sql_date($date) {
		
		// mxDebugFuncvars ( $date );
		switch (true) {
			case is_numeric ( $date ) :
				return $date;
			case empty ( $date ) :
			case ! is_scalar ( $date ) :
				return 'NULL';
			default :
				return mkfromstrptime ( $date, _DATEPICKER );
		}
	}
	
	/**
	 * alaBooking::convert_to_sql_date()
	 * Konvertiert ein String-Datum, welches vom Datepicker kommt in
	 * ein SQL-Format "YYYY-MM-DD"
	 *
	 * @param mixed $date        	
	 * @return integer timestamp
	 */
	protected function convert_to_sql_datetime($date) {
		switch (true) {
			case is_numeric ( $date ) :
				return $date;
			case empty ( $date ) :
			case ! is_scalar ( $date ) :
				return 0;
			default :
				$tmp = strptime ( $date, _ALABOOKING_DATETIMEPICKER );
				return "'" . sprintf ( "%04d-%02d-%02d %02d:%02d:%02d", ($tmp ['tm_year'] + 1900), ($tmp ['tm_mon'] + 1), $tmp ['tm_mday'], $tmp ['tm_hour'], $tmp ['tm_min'], $tmp ['tm_sec'] ) . "'";
		}
	}
	
	/**
	 * alaBooking::get_AdmFrmSel_art()
	 */
	public function get_AdmFrm_Status() {
		foreach ( $this->_module_status as $key => $value ) {
			$SelList [$value] = $key;
		}
		return $SelList;
	}
	
	/**
	 * alaBooking::get_StatusFormOption()
	 *
	 * Option-Menue der übergebenen Satzstati für das AdminForm
	 */
	public function get_StatusFormOption($ar_obj_stati) {
		$Opt_RecStatus = array ();
		foreach ( $ar_obj_stati as $key => $value ) {
			$Opt_RecStatus [$value] = $key;
		}
		return $Opt_RecStatus;
	}
	
	// Status-HTML <span>-Element aufbereiten:
	// css liegt aktuell in style.css
	public function get_StatusData($status) {
		$title = '';
		switch ($status) {
			case STATUS_FREE :
				$txt = _ALABOOKING_STATUS_FREE;
				$title = _ALABOOKING_STATUS_FREE_INFO;
				$class = 'free';
				$selectable = true;
				break;
			case STATUS_REQUESTED :
				$txt = _ALABOOKING_STATUS_REQUESTED;
				$title = _ALABOOKING_STATUS_REQUESTED_INFO;
				$class = 'requested';
				$selectable = false; // true, damit nochmals ausgewaehlt werden kann!
				break;
			case STATUS_CONFIRMED :
				$txt = _ALABOOKING_STATUS_CONFIRMED;
				$title = _ALABOOKING_STATUS_CONFIRMED_INFO;
				$class = 'confirmed';
				$selectable = false;
				break;
			case STATUS_ACTIVE :
				$txt = _ALABOOKING_STATUS_ACTIVE;
				$title = _ALABOOKING_STATUS_ACTIVE_INFO;
				$class = 'active';
				$selectable = false;
				break;
			case STATUS_DENIED :
				$txt = _ALABOOKING_STATUS_DENIED;
				$title = _ALABOOKING_STATUS_DENIED_INFO;
				$class = 'denied';
				$selectable = true;
				break;
			case STATUS_INACTIVE :
				$txt = _ALABOOKING_STATUS_INACTIVE;
				$title = _ALABOOKING_STATUS_INACTIVE_INFO;
				$class = 'inactive';
				$selectable = true;
				break;
			case STATUS_CANCELED :
			default :
				$txt = _ALABOOKING_STATUS_CANCELED;
				$title = _ALABOOKING_STATUS_CANCELED_INFO;
				$class = 'canceled';
				$selectable = true;
				break;
		}
		$title = empty ( $title ) ? $txt : $title;
		return array (
				$txt,
				$title,
				$class,
				$selectable 
		);
		return $out;
	}
	
	/**
	 * Erstellt ein <span> - Code für die übergebenen Satzstatus
	 * Status-HTML <span>-Element aufbereiten:
	 * css liegt aktuell in style.css
	 */
	public function get_StatusIcon($status) {
		list ( $txt, $title, $class, $selectable ) = $this->get_StatusData ( $status );
		$out = "<span class='booking-status-" . $class . "' title='" . $title . "'>" . $txt . "</span>";
		return $out;
	}
	
	/**
	 * Erstellt den <option> - Code aller aktiven Objekte aus der DB
	 */
	public function get_ObjectHtmlOpt($curr_obj_id) {
		$new_op = $_REQUEST ['op'];
		$selectfilter2 = "<select class=\"form\" name=\"qryresource\" size=\"1\" onchange=\"document[adminForm].action='admin.php?op=" . $new_op . "';document[adminForm].submit();\" >";
		$selectfilter2 .= "<option value=\"0\" >" . _ALL . "&nbsp;&nbsp;</option>";
		
		$qry = "SELECT obj_id, obj_name FROM `" . ALABOOKING_TABLE_OBJECT . "` ";
		$qry .= " WHERE obj_status = " . STATUS_ACTIVE;
		
		// Objekte-Optionsmenü
		$result1 = sql_query ( $qry );
		while ( list ( $obj_id, $obj_name ) = sql_fetch_row ( $result1 ) ) {
			$selected = ($obj_id == $curr_obj_id) ? "selected=\"selected\"" : "";
			if ($selected != "")
				$docfilter = $obj_id;
			$selectfilter2 .= "<option value=\"" . $obj_id . "\" " . $selected . " >" . $obj_name . " " . "&nbsp;&nbsp;</option>";
		}
		$selectfilter2 .= "</select>";
		return $selectfilter2;
	}
}

/**
 * Check, whether actual Theme is using bootstrap-style...
 *
 * @return boolean
 */
if (! function_exists ( 'call_theme_use_bootstrap' )) {
	function call_theme_use_bootstrap() {
		$use_bootstrap = false;
		// Try to read a function of the theme located in theme/ThemeName/module.functions.php...
		$module_function_file = MX_THEME_DIR . DS . 'module.functions.php';
		if ($module_function_file && is_file ( $module_function_file )) {
			include ($module_function_file);
			if (function_exists ( 'theme_use_bootstrap' )) {
				$use_bootstrap = theme_use_bootstrap ();
			}
		} else {
			// Try to read a function of the theme located in theme/ThemeName/includes/module.functions.php...
			$module_function_file = MX_THEME_DIR . DS . 'includes' . DS . 'module.functions.php';
			if ($module_function_file && is_file ( $module_function_file )) {
				include ($module_function_file);
				if (function_exists ( 'theme_use_bootstrap' )) {
					$use_bootstrap = theme_use_bootstrap ();
				}
			}
		}
		return $use_bootstrap;
	}
}
?>