<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/07/06 $
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

/**
 * alaBooking_booking
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_booking extends alaBooking {
  public $_defaults = array ();
  public $_messages = array ();
  public $_warnings = array ();
  public $_errors = array ();
  
  /**
   * alaBooking_booking::__construct()
   */
  // protected function __construct()
  function __construct() {
    parent::__construct ();
    // Defaults für den Club-Mitglieder DB-Satz
    $this->_defaults = array(/* Standardwerte */
            'module' => $this->_module_name,
        'b_id' => 0,
        'b_obj_id' => '',
        'b_begin' => '',
        'b_end' => '',
        'b_name' => '',
        'b_firstname' => '',
        'b_street' => '',
        'b_country' => '',
        'b_zip' => '',
        'b_city' => '',
        'b_email' => '',
        'b_phone' => '',
        'b_description' => '',
        'b_status' => 0,
        'b_uid' => 0,
        'buchdatuemer' => '' 
    );
    // Beschreibungen aller Datensatz-Stati:
    $this->_rec_status = array (
        STATUS_REQUESTED => _ALABOOKING_STATUS_REQUESTED,
        STATUS_CONFIRMED => _ALABOOKING_STATUS_CONFIRMED,
        STATUS_ACTIVE => _ALABOOKING_STATUS_ACTIVE,
        STATUS_INACTIVE => _ALABOOKING_STATUS_INACTIVE,
        STATUS_DENIED => _ALABOOKING_STATUS_DENIED,
        STATUS_CANCELED => _ALABOOKING_STATUS_CANCELED 
    );
  }
  
  /**
   * Erstellt den <option> - Code für die gültigen Satzstati
   */
  public function get_statusHtmlOpt($curr_status) {
    $new_op = $_REQUEST ['op'];
    $selectfilter2 = "<select class=\"form\" name=\"qrystatus\" size=\"1\" onchange=\"document[adminForm].action='admin.php?op=" . $new_op . "';document[adminForm].submit();\" >";
    $selectfilter2 .= "<option value=\"\" >" . _ALL . "&nbsp;&nbsp;</option>";
    foreach ( $this->_rec_status as $key => $value ) {
      $selected = ($key == $curr_status) ? "selected=\"selected\"" : "";
      $selectfilter2 .= "<option value=\"" . $key . "\" " . $selected . " >" . $value . " " . "&nbsp;&nbsp;</option>";
    }
    $selectfilter2 .= "</select>";
    return $selectfilter2;
  }
  
  /**
   * alaBooking_booking::add_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function add_send_save($data) {
    
    // Daten validieren:
    $data ['b_status'] = empty ( $data ['b_status'] ) ? STATUS_REQUESTED : $data ['b_status'];
    $data ['myApplication'] = empty ( $data ['myApplication'] ) ? '' : $data ['myApplication'];
    $data ['b_uid'] = empty ( $data ['b_uid'] ) ? $this->_user ['uid'] : $data ['b_uid'];
    
    // Die Datumsbehandlung ist abhängig vom Formular:
    switch ($data ['myApplication']) {
      case 'admin_booking' :
        // Typenkonvertierung vom DATETIMEPICKER in SQL-Date:
        $sql_begin = $this->convert_to_sql_datetime ( $data ['b_begin'] );
        $sql_end = $this->convert_to_sql_datetime ( $data ['b_end'] );
        if (! $sql_begin)
          $sql_begin = 'NULL';
        if (! $sql_end)
          $sql_end = 'NULL';
        break;
      default :
        $sql_begin = "'" . $data ['b_begin'] . " " . $data ['zeitvon'] . "'";
        $sql_end = "'" . $data ['b_end'] . " " . $data ['zeitbis'] . "'";
        break;
    }
    
    // Daten checken:
    $data ['sql_begin'] = $sql_begin;
    $data ['sql_end'] = $sql_end;
    if (! $this->check_booking ( $data )) {
      return false;
    }
    
    $data ['b_creation_date'] = strftime ( "%Y/%m/%d %H:%M:%S", time () );
    
    $fields [] = "b_begin = " . $sql_begin;
    $fields [] = "b_end = " . $sql_end;
    
    $fields [] = "module = '" . $this->_module_name . "'";
    $fields [] = "b_obj_id = " . intval ( $data ['b_obj_id'] );
    $fields [] = "b_name = '" . mxAddSlashesForSQL ( $data ['b_name'] ) . "'";
    $fields [] = "b_firstname = '" . mxAddSlashesForSQL ( $data ['b_firstname'] ) . "'";
    $fields [] = "b_street = '" . mxAddSlashesForSQL ( $data ['b_street'] ) . "'";
    $fields [] = "b_country = '" . mxAddSlashesForSQL ( $data ['b_country'] ) . "'";
    $fields [] = "b_zip = '" . mxAddSlashesForSQL ( $data ['b_zip'] ) . "'";
    $fields [] = "b_city = '" . mxAddSlashesForSQL ( $data ['b_city'] ) . "'";
    $fields [] = "b_email = '" . mxAddSlashesForSQL ( $data ['b_email'] ) . "'";
    $fields [] = "b_phone = '" . mxAddSlashesForSQL ( $data ['b_phone'] ) . "'";
    $fields [] = "b_description = '" . mxAddSlashesForSQL ( $data ['b_description'] ) . "'";
    $fields [] = "b_uid = " . intval ( $data ['b_uid'] );
    $fields [] = "b_status = " . intval ( $data ['b_status'] );
    $fields [] = "b_creation_date = '" . $data ['b_creation_date'] . "'";
    
    $sql = "INSERT INTO `" . ALABOOKING_TABLE_BOOKING . "` SET " . implode ( ', ', $fields );
    $result = sql_query ( $sql );
    
    if ($result) {
      $data ['b_id'] = sql_insert_id ();
      
      // Hier können noch einige Zusatz-Updates erfolgen....
      
      // Sollen eMails versendet werden?
      // Falls kein neuer Status übergeben, den aktuellen nutzen:
      $data ['b_newstat'] = (isset ( $data ['b_newstat'] )) ? isset ( $data ['b_newstat'] ) : $data ['b_status'];
      $ar_eMail_messages = $this->SendEmailNotification_booking ( $data );
      $this->_messages = array_merge ( $this->_messages, $ar_eMail_messages );
      
      // Zurück zum Formular (mit Löschung der Inhalte!)
      $this->_messages [] = _ALABOOKING_B_THANKSFORBOOKING;
      // mxRedirect ( 'modules.php?name=' . $this->_module_name . '&op=booking&obj_id=' . $data ['b_obj_id'], _ALABOOKING_B_THANKSFORBOOKING, 5 );
      
      $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENADDED;
    } else {
      $this->_errors [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENADDEDNOT;
    }
    // }
    return $data ['b_id'];
  }
  protected function SendEmailNotification_booking($data) {
    $ret_MailMsg = array ();
    $eMailType = array ();
    // eMail-Type ist abhängig vom neuen Status:
    $data ['b_newstat'] = isset ( $data ['b_newstat'] ) ? $data ['b_newstat'] : false;
    switch ($data ['b_newstat']) {
      case STATUS_REQUESTED :
        $eMailType [] = 'emailAdminNew';
        $eMailType [] = 'emailVisitorNew';
        break;
      case STATUS_CONFIRMED :
        $eMailType [] = 'emailVisitorConfirm';
        break;
      case STATUS_DENIED :
        $eMailType [] = 'emailVisitorDeny';
        break;
      case STATUS_CANCELED :
        $eMailType [] = 'emailVisitorCancel';
        break;
      case false :
      default :
        $eMailType = array ();
        break;
    }
    
    // Jede eMail-Type aufarbeiten...
    foreach ( $eMailType as $loopType ) {
      // eMail versenden? Falls nicht gesetzt, wird die _config-Einstellung verwendet:
      if (isset ( $data ['email_send'] )) {
        $weiter = ($data ['email_send']) ? ($data ['email_send']) : false;
      } else {
        $weiter = isset ( $this->_config [$loopType] ['Active'] ) ? $this->_config [$loopType] ['Active'] : false;
      }
      
      // Kopie an den Absender?
      if (isset ( $data ['email_copy'] )) {
        $eMailCopy = ($data ['email_copy']) ? ($data ['email_copy']) : false;
      } else {
        $eMailCopy = isset ( $this->_config [$loopType] ['CopyToSender'] ) ? $this->_config [$loopType] ['CopyToSender'] : false;
      }
      
      if ($weiter) {
        
        // eMail-Klasse:
        include_once (PMX_MODULES_DIR . DS . $this->_module_name . DS . "includes/class.email.php");
        $email = new alaBooking_email ();
        
        // eMail-Inhalt aus der Buchung aufbereiten:
        
        // Evt. fehlende Substitutionsvariablen in $data-Array aufnehmen:
        $data ['url2maintain'] = '<a href="' . PMX_HOME_URL . '/admin.php?op=' . $this->_module_name . '/booking&amp;act=edit&amp;b_id=' . $data ['b_id'] . '" title="' . _EDIT . '">' . _EDIT . '</a>';
        
        // Falls Objektbezeichnung fehlt: nachlesen:
        if (! isset ( $data ['obj_name'] )) {
          $sql2 = "SELECT obj_name FROM `" . ALABOOKING_TABLE_OBJECT . "`";
          $sql2 .= " WHERE module = '" . $this->_module_name . "'";
          $sql2 .= "  AND obj_id=" . $data ['b_obj_id'];
          $result2 = sql_query ( $sql2 );
          $row2 = sql_fetch_assoc ( $result2 );
          if ($row2) {
            $data ['obj_name'] = $row2 ['obj_name'];
          }
        }
        $b_content = '';
        $b_content .= '<p>' . _ALABOOKING_O . " : " . $data ['b_obj_id'] . ": <b>" . $data ['obj_name'] . "</b></p>";
        $b_content .= '<p>' . _ALABOOKING_B_BEGIN . "/" . _ALABOOKING_B_END . " : <b>";
        $b_content .= mx_strftime ( $this->_config ['DateFormat'], $data ['b_begin'] ) . " - ";
        $b_content .= mx_strftime ( $this->_config ['DateFormat'], $data ['b_end'] ) . "</b></p>";
        $b_content .= '<p><u>' . _ALABOOKING_B_ENQUIRING . ':</u></p>';
        $b_content .= '<p>' . _ALABOOKING_B_NAME . ", " . _ALABOOKING_B_FIRSTNAME . " : <b>" . $data ['b_name'] . ", " . $data ['b_firstname'] . "</b></p>";
        if ($data ['b_street']) {
          $b_content .= '<p>' . _ALABOOKING_B_STREET . " : <b>" . $data ['b_street'] . "</b></p>";
        }
        if (($data ['b_country']) || ($data ['b_zip']) || ($data ['b_city'])) {
          $b_content .= '<p>' . _ALABOOKING_B_COUNTRY . ", " . _ALABOOKING_B_ZIP . ", " . _ALABOOKING_B_CITY . " : <b>" . $data ['b_country'] . " " . $data ['b_zip'] . " " . $data ['b_city'] . "</b></p>";
        }
        
        $b_content .= '<p>' . _ALABOOKING_B_PHONE . " : <b>" . $data ['b_phone'] . "</b></p>";
        $b_content .= '<p>' . _ALABOOKING_B_EMAIL . " : <b>" . $data ['b_email'] . "</b></p>";
        if (MX_IS_USER) {
          $b_content .= '<p>' . _ALABOOKING_B_UID . " : <b>" . $data ['b_uid'] . "</b> / " . $this->_user ['uname'] . "</p>";
        }
        $b_content .= '<p><u>' . _ALABOOKING_B_DESCRIPTION . ':</u></p>';
        $b_content .= '<p>' . mxAddSlashesForSQL ( $data ['b_description'] ) . "</p>";
        
        $data ['b_content'] = $b_content;
        
        $email->SendEmailNotification ( $loopType, $data, $eMailCopy );
        $ret_MailMsg = $email->_messages;
        
        $email = null;
      }
    }
    return $ret_MailMsg;
  }
  protected function save_from_public_FormBooking($data) {
    if (empty ( $data ['buchdatuemer'] )) {
      $this->_errors [] = _ALABOOKING_B_MUST_DATE;
      return;
    }
    
    // ToDo: Konfiguration für Range einsetzen:
    switch ($data ['obj_bookingtype']) {
      case 0 : // nur ein Tag
      case 1 : // nur ein Tag mit Uhrzeit
        $data ['b_begin'] = $data ['buchdatuemer'];
        $data ['b_end'] = $data ['buchdatuemer'];
        if (! isset ( $data ['zeitvon'] ))
          $data ['zeitvon'] = "00:00:00";
        if (! isset ( $data ['zeitbis'] ))
          $data ['zeitbis'] = "23:59:59";
        return $this->add_send_save ( $data );
        break;
      case 2 : // Tag für Tag
        $old_end_date = '';
        $curr_end_date = '';
        $beg_date = '';
        $ar_datum = explode ( ",", $data ['buchdatuemer'] );
        sort ( $ar_datum ); // Aufsteigend sortieren!
                            
        // $dat_begin = trim ( $ar_datum [0] );
                            // $dat_end = trim ( $ar_datum [1] );
        if (! isset ( $data ['zeitvon'] ))
          $data ['zeitvon'] = "00:00:00";
        if (! isset ( $data ['zeitbis'] ))
          $data ['zeitbis'] = "23:59:59";
        foreach ( $ar_datum as $key => $tmp_datum ) {
          
          // Prüfen, ob mehrere Tage in Folge in einer Buchung zusammengefasst werden können:
          $loc_ardate = explode ( '/', trim ( $tmp_datum ) );
          $loc_year = $loc_ardate [0]; // 2012
          $loc_mont = $loc_ardate [1]; // 09
          $loc_day = $loc_ardate [2]; // date("d");//1; //31
          $curr_date = mktime ( 0, 0, 0, $loc_mont, $loc_day, $loc_year );
          
          if (! $beg_date) {
            $beg_date = mktime ( 0, 0, 0, $loc_mont, $loc_day, $loc_year );
            $end_date = mktime ( 0, 0, 0, $loc_mont, $loc_day, $loc_year );
            $next_end_date = mktime ( 0, 0, 0, $loc_mont, $loc_day + 1, $loc_year ); // nächster Tag:
            $data ['b_begin'] = trim ( $tmp_datum );
            $data ['b_end'] = trim ( $tmp_datum );
          } else {
            if ($curr_date == $next_end_date) {
              $next_end_date = mktime ( 0, 0, 0, $loc_mont, $loc_day + 1, $loc_year ); // nächster Tag:
              $data ['b_end'] = trim ( $tmp_datum );
            } else {
              // Sonst buchen:
              $ar_b_id [] = $this->add_send_save ( $data );
              // und von vorne beginnen :-)
              $beg_date = mktime ( 0, 0, 0, $loc_mont, $loc_day, $loc_year );
              $end_date = mktime ( 0, 0, 0, $loc_mont, $loc_day, $loc_year );
              $next_end_date = mktime ( 0, 0, 0, $loc_mont, $loc_day + 1, $loc_year ); // nächster Tag:
              $data ['b_begin'] = trim ( $tmp_datum );
              $data ['b_end'] = trim ( $tmp_datum );
            }
          }
        }
        // Letzen Satz auch noch verbuchen:
        $ar_b_id [] = $this->add_send_save ( $data );
        
        // mxRedirect ( 'modules.php?name=' . $this->_module_name . '&op=booking&obj_id=' . $data ['b_obj_id'], _ALABOOKING_B_THANKSFORBOOKING, 5 );
        
        return $ar_b_id;
        break;
      default :
        $this->_errors [] = _ALABOOKING_B_THEBTYPE . ' <b>' . $data ['obj_bookingtype'] . '</b> ' . _ALABOOKING_B_NOT_SUPPORTED;
        break;
    }
    return false;
  }
  
  /**
   * alaBooking_booking::check_booking()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  protected function check_booking($data) {
    if (empty ( $data ['b_name'] )) {
      $this->_errors [] = _ALABOOKING_B_MUST_NAME;
    }
    if (empty ( $data ['b_firstname'] )) {
      $this->_errors [] = _ALABOOKING_B_MUST_FIRSTNAME;
    }
    // if (empty ( $data ['b_email'] )) {
    // $this->_errors [] = _ALABOOKING_B_MUST_EMAIL;
    // }
    if (! mxCheckEmail ( $data ['b_email'] )) {
      $this->_errors [] = _ALABOOKING_B_WRONG_EMAIL;
    }
    if (! empty ( $data ['sql_begin'] ) && ! empty ( $data ['sql_end'] )) {
      if ($data ['sql_end'] < $data ['sql_begin']) {
        $this->_errors [] = _ALABOOKING_B_DATENDLTDATBEG . $data ['sql_begin'] . "->" . $data ['sql_end'];
      }
    }
    if (($this->_config ['BookingFormField'] ['Street'] == 'required') && (empty ( $data ['b_street'] ))) {
      $this->_errors [] = _ALABOOKING_B_MUST_STREET;
    }
    if (($this->_config ['BookingFormField'] ['Country'] == 'required') && (empty ( $data ['b_country'] ))) {
      $this->_errors [] = _ALABOOKING_B_MUST_COUNTRY;
    }
    if (($this->_config ['BookingFormField'] ['Zip'] == 'required') && (empty ( $data ['b_zip'] ))) {
      $this->_errors [] = _ALABOOKING_B_MUST_ZIP;
    }
    if (($this->_config ['BookingFormField'] ['City'] == 'required') && (empty ( $data ['b_city'] ))) {
      $this->_errors [] = _ALABOOKING_B_MUST_CITY;
    }
    
    return ! $this->_errors;
  }
  
  /**
   * alaBooking_booking_booking::del_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function del_send_save($b_id, $data) {
    $sql = "DELETE FROM `" . ALABOOKING_TABLE_BOOKING . "` WHERE b_id= " . $b_id;
    $sql .= " AND module = '" . $this->_module_name . "'";
    $result = sql_query ( $sql );
    if ($result) {
      // $this->delete_photo($data);
      $this->_messages [] = _ALABOOKING_B . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENDELETED;
      
      // Zugehörige eMails löschen...
      include_once ('class.email.php');
      $ObjEmail = new alaBooking_email ();
      $ObjEmail->del_send_save_b_id ( $b_id );
      // Messages und Errors übernehmen...:
      $this->_messages = array_merge ( $this->_messages, $ObjEmail->_messages );
    } else
      
      $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENDELETEDNOT;
    
    return true;
  }
  
  /**
   * alaBooking_booking::edit_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function edit_send_save($data) {
    
    // Daten validieren:
    $data ['b_status'] = empty ( $data ['b_status'] ) ? 0 : $data ['b_status'];
    $data ['myApplication'] = empty ( $data ['myApplication'] ) ? '' : $data ['myApplication'];
    
    // Die Datumsbehandlung ist abhängig vom Formular:
    switch ($data ['myApplication']) {
      case 'admin_booking' :
        // Typenkonvertierung vom DATETIMEPICKER in SQL-Date:
        $sql_begin = $this->convert_to_sql_datetime ( $data ['b_begin'] );
        $sql_end = $this->convert_to_sql_datetime ( $data ['b_end'] );
        if (! $sql_begin)
          $sql_begin = 'NULL';
        if (! $sql_end)
          $sql_end = 'NULL';
        break;
      default :
        $sql_begin = "'" . $data ['b_begin'] . " " . $data ['zeitvon'] . "'";
        $sql_end = "'" . $data ['b_end'] . " " . $data ['zeitbis'] . "'";
        break;
    }
    
    // Daten checken:
    $data ['sql_begin'] = $sql_begin;
    $data ['sql_end'] = $sql_end;
    if (! $this->check_booking ( $data )) {
      return false;
    }
    
    $fields [] = "b_begin = " . $sql_begin;
    $fields [] = "b_end = " . $sql_end;
    
    $fields [] = "module = '" . $this->_module_name . "'";
    $fields [] = "b_obj_id = " . intval ( $data ['b_obj_id'] );
    $fields [] = "b_name = '" . mxAddSlashesForSQL ( $data ['b_name'] ) . "'";
    $fields [] = "b_firstname = '" . mxAddSlashesForSQL ( $data ['b_firstname'] ) . "'";
    $fields [] = "b_street = '" . mxAddSlashesForSQL ( $data ['b_street'] ) . "'";
    $fields [] = "b_country = '" . mxAddSlashesForSQL ( $data ['b_country'] ) . "'";
    $fields [] = "b_zip = '" . mxAddSlashesForSQL ( $data ['b_zip'] ) . "'";
    $fields [] = "b_city = '" . mxAddSlashesForSQL ( $data ['b_city'] ) . "'";
    $fields [] = "b_email = '" . mxAddSlashesForSQL ( $data ['b_email'] ) . "'";
    $fields [] = "b_phone = '" . mxAddSlashesForSQL ( $data ['b_phone'] ) . "'";
    $fields [] = "b_description = '" . mxAddSlashesForSQL ( $data ['b_description'] ) . "'";
    $fields [] = "b_status = " . intval ( $data ['b_status'] );
    
    $sql = "UPDATE `" . ALABOOKING_TABLE_BOOKING . "` SET " . implode ( ', ', $fields );
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND b_id=" . $data ['b_id'];
    $result = sql_query ( $sql );
    
    $this->_messages [] = _ALABOOKING_B . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENCHANGED;
    
    // Sollen eMails versendet werden?
    // Status wurde ja schon geändert! also immer den neuen nehmen:
    $data ['b_newstat'] = $data ['b_status'];
    $ar_eMail_messages = $this->SendEmailNotification_booking ( $data );
    $this->_messages = array_merge ( $this->_messages, $ar_eMail_messages );
    
    return true;
  }
  public function email_show_list($b_id) {
    $sql = "SELECT * FROM " . ALABOOKING_TABLE_BCOM;
    $sql .= " WHERE bcom_b_id = " . $b_id;
    $sql .= " ORDER BY bcom_ts";
    $result = sql_query ( $sql );
    $rowset = array ();
    while ( $row = sql_fetch_assoc ( $result ) ) {
      $rowset [] = $row;
    }
    
    $this->_template->assign ( compact ( 'rowset', 'query', 'total' ) );
    $this->_template->assign ( 'adminmode', $this->_adminmode );
    
    return $this->_template->fetch ( 'email_list.html' );
  }
  public function set_status_selection($new_status, $ar_b_id) {
    foreach ( $ar_b_id as $b_id ) {
      
      $b_data = $this->get_data ( $b_id );
      if ($b_data ['b_status'] != $new_status) {
        $sql = "UPDATE `" . ALABOOKING_TABLE_BOOKING . "` SET b_status = " . $new_status;
        $sql .= " WHERE module = '" . $this->_module_name . "'";
        $sql .= "  AND b_id=" . $b_id;
        $result = sql_query ( $sql );
        $this->_messages [] = _ALABOOKING_THERECORD . $b_id . '/' . $b_data ['b_name'] . ', ' . $b_data ['b_firstname'] . _ALABOOKING_SETNEWSTATUSTO . $this->get_StatusIcon ( $b_data ['b_status'] ) . ' => ' . $this->get_StatusIcon ( $new_status );
      } else {
        $this->_messages [] = _ALABOOKING_THERECORD . $b_id . '/' . $b_data ['b_name'] . ', ' . $b_data ['b_firstname'] . _ALABOOKING_CHANGENOTRELEVANT . $this->get_StatusIcon ( $new_status );
      }
    }
  }
  
  /**
   * alaBooking_booking_booking::get_data()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  public function get_data($id) {
    $sql = "SELECT * FROM `" . ALABOOKING_TABLE_BOOKING . "`";
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND b_id=" . $id;
    $result = sql_query ( $sql );
    $row = sql_fetch_assoc ( $result );
    if (! $row) {
      return $this->_defaults;
    }
    
    return array_merge ( $this->_defaults, $row );
  }
  
  /**
   * Erstellt ein ToolTip-HTML zur Anzeige!
   */
  public function getBookingTooltip($b_id) {
    $tooltip = isset ( $tooltip ) ? $tooltip : '';
    
    // Es koennen auch mehrere IDs übergeben werden:
    $ar_b_id = preg_split ( "/,/", $b_id );
    foreach ( $ar_b_id as $key => $id ) {
      $tt_data = $this->get_data ( $id );
      // Nächste Stati wären:
      $ar_next_stat = array ();
      switch ($tt_data ['b_status']) {
        case STATUS_FREE :
        case STATUS_REQUESTED :
          $ar_next_stat [STATUS_CONFIRMED] = array (
              'title' => $this->_rec_status [STATUS_CONFIRMED],
              'class' => 'icon-ok',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CONFIRMED] 
          );
          $ar_next_stat [STATUS_DENIED] = array (
              'title' => $this->_rec_status [STATUS_DENIED],
              'class' => 'icon-remove',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_DENIED] 
          );
          $ar_next_stat [STATUS_CANCELED] = array (
              'title' => $this->_rec_status [STATUS_CANCELED],
              'class' => 'icon-trash',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CANCELED] 
          );
          break;
        case STATUS_CONFIRMED :
          $ar_next_stat [STATUS_REQUESTED] = array (
              'title' => $this->_rec_status [STATUS_REQUESTED],
              'class' => 'icon-step-backward',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_REQUESTED] 
          );
          $ar_next_stat [STATUS_DENIED] = array (
              'title' => $this->_rec_status [STATUS_DENIED],
              'class' => 'icon-remove',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_DENIED] 
          );
          $ar_next_stat [STATUS_CANCELED] = array (
              'title' => $this->_rec_status [STATUS_CANCELED],
              'class' => 'icon-trash',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CANCELED] 
          );
          break;
        case STATUS_DENIED :
          $ar_next_stat [STATUS_REQUESTED] = array (
              'title' => $this->_rec_status [STATUS_REQUESTED],
              'class' => 'icon-step-backward',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_REQUESTED] 
          );
          $ar_next_stat [STATUS_CONFIRMED] = array (
              'title' => $this->_rec_status [STATUS_CONFIRMED],
              'class' => 'icon-ok',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CONFIRMED] 
          );
          break;
          $ar_next_stat [STATUS_CANCELED] = array (
              'title' => $this->_rec_status [STATUS_CANCELED],
              'class' => 'icon-trash',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CANCELED] 
          );
          break;
        case STATUS_ACTIVE :
        case STATUS_INACTIVE :
        case STATUS_CANCELED :
        default :
          $ar_next_stat [STATUS_CANCELED] = array (
              'title' => $this->_rec_status [STATUS_CANCELED],
              'class' => 'icon-trash',
              'DialogTitle' => _ALABOOKING_CHANGESTATUSTO . $this->_rec_status [STATUS_CANCELED] 
          );
          break;
      }
      
      // eMail-Versand+Kopie ist abhängig vom Status:
      foreach ( $ar_next_stat as $statID => &$stat ) {
        switch ($statID) {
          case STATUS_CONFIRMED :
            $stat ['eMail'] = ($this->_config ['emailVisitorConfirm'] ['Active']) ? '1' : '0';
            $stat ['CopyToSender'] = ($this->_config ['emailVisitorConfirm'] ['CopyToSender']) ? '1' : '0';
            break;
          case STATUS_DENIED :
            $stat ['eMail'] = ($this->_config ['emailVisitorDeny'] ['Active']) ? '1' : '0';
            $stat ['CopyToSender'] = ($this->_config ['emailVisitorDeny'] ['CopyToSender']) ? '1' : '0';
            break;
          case STATUS_DENIED :
            $stat ['eMail'] = ($this->_config ['emailVisitorCancel'] ['Active']) ? '1' : '0';
            $stat ['CopyToSender'] = ($this->_config ['emailVisitorCancel'] ['CopyToSender']) ? '1' : '0';
            break;
          default :
            $stat ['eMail'] = '0';
            $stat ['CopyToSender'] = '0';
            break;
        }
      }
      $booking_status = $this->get_StatusIcon ( $tt_data ['b_status'] );
      $this->_template->assign ( 'booking_status', $booking_status );
      $this->_template->assign ( 'booking', $tt_data );
      $this->_template->assign ( 'next_stat', $ar_next_stat );
      $tooltip .= ($key > 0) ? '<hr>' : '';
      $tooltip .= $this->_template->fetch ( 'timeline_tooltip_booking.html' );
    }
    
    $ar_return = array ();
    $ar_return ['tooltip'] = $tooltip;
    $ar_return ['reasonlabel'] = 'only a test';
    
    return $ar_return;
  }
}

/**
 * alaBooking_booking
 *
 * Administrator-Klasse zu alaBooking_booking
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_booking_admin extends alaBooking_booking {
  
  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {
    parent::__construct ();
    
    if (! $this->_is_admin) {
      return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
    }
    $this->_adminmode = true; // Aufruf über die admin.php
  }
  
  /**
   *
   * alaBooking_booking_admin::admin_booking
   *
   * @param
   *          $op
   */
  public function admin_booking($op) {
    
    // evt. Aktion uebergeben?
    $act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "";
    $b_id = (isset ( $_GET ['b_id'] )) ? $_GET ['b_id'] : "";
    /* Filter-Ausgangswert festlegen */
    $qryfilter = ((isset ( $_POST ['qryfilter'] )) ? $_POST ['qryfilter'] : ((mxSessionGetVar ( "qryfilter" )) ? mxSessionGetVar ( "qryfilter" ) : ''));
    $qrystatus = ((isset ( $_POST ['qrystatus'] )) ? $_POST ['qrystatus'] : ((mxSessionGetVar ( "qrystatus" )) ? mxSessionGetVar ( "qrystatus" ) : ''));
    $qryresource = ((isset ( $_POST ['qryresource'] )) ? $_POST ['qryresource'] : ((mxSessionGetVar ( "qryresource" )) ? mxSessionGetVar ( "qryresource" ) : ''));
    
    $data = array ();
    if ($b_id) {
      $data = $this->get_data ( $b_id );
    }
    // Defaults setzen und mit Form-Daten überschreiben:
    $data = array_merge ( $this->_defaults, $data, $_POST );
    
    // Verarbeitung der Aktionen:
    // 1. wurde ein AdminForm-Button gedrückt?
    $tb = load_class ( 'AdminForm', "adminBooking" );
    switch (pmxAdminForm::CheckButton ()) {
      case "save" :
        // In DB Speichern:
        $id = $this->add_send_save ( $data );
        
        if (! $id || $this->_errors) {
          mxStripSlashes ( $data );
          $act = 'new'; // Neuanlage wiederholen!
        } else {
          $act = ''; // Default-Aktion: Liste
        }
        break;
      case "edit" :
      case "accept" :
        // In DB Speichern:
        $id = $this->edit_send_save ( $data );
        
        if ($this->_errors) {
          mxStripSlashes ( $data );
          $act = 'edit'; // Edit wiederholen!
        } else {
          $act = ''; // Default-Aktion: Liste
        }
        break;
      case "set_qryfilter" :
        $act = ''; // Default-Aktion: Liste
        break;
      case "Cancel" :
        $this->set_status_selection ( STATUS_CANCELED, $_POST ['cid'] );
        $act = ''; // Default-Aktion: Liste
        break;
      case "Confirm" :
        $this->set_status_selection ( STATUS_CONFIRMED, $_POST ['cid'] );
        $act = ''; // Default-Aktion: Liste
        break;
    }
    
    // Verarbeitung der Aktionen:
    // 2. wurde ein act-Parameter gesendet?
    switch ($act) {
      case "delete" :
        $data = $this->get_data ( $b_id );
        $this->del_send_save ( $b_id, $data );
        $act = '';
        break;
    }
    
    // Admin-Formular aufbauen:
    $tb = load_class ( 'AdminForm', "adminClubMember" );
    $tb->tb_text = _ALABOOKING_BTN_BOOKING;
    $tb->tb_direction = 'right';
    $tb->acceptbutton = false; //
    $tb->infobutton = $this->_config ['FormInfobutton']; // Info-Button oder als Text
    $tb->tb_pic_heigth = 22;
    $tb->csstoolbar = "toolbar1";
    $tb->cssform = "adminForm";
    $tb->homelink = false;
    $tb->buttontext = false; // Anzeige von SAVE und UP-Button unter der Feldliste
    $tb->tb_show = "top"; // Wo steht die Toolbar: top/bottom/both
    $tb->checklistflag = 1; // Es soll eine Liste sein
    $tb->checkselector = 'cid'; // In der Liste können alle Zeilen mit dem namen 'cid' markiert werden!
                                
    // Die Objekte in das Optionsmenü:
    $SelList = array (
        '' => 0 
    );
    
    $qry = "SELECT obj_id, obj_name FROM `" . ALABOOKING_TABLE_OBJECT . "` ";
    $qry .= " WHERE obj_status = " . STATUS_ACTIVE;
    
    // Objekte-Optionsmenü
    $result1 = sql_query ( $qry );
    while ( list ( $obj_id, $obj_name ) = sql_fetch_row ( $result1 ) ) {
      $SelList [$obj_name] = $obj_id;
    }
    
    // Satzstatus:
    $Opt_Rec_Status = $this->get_StatusFormOption ( $this->_rec_status );
    
    switch ($act) {
      
      // -------------------------------------
      // - Buchung: Neuanlegen
      // -------------------------------------
      case 'new' :
        $tb->addToolbar ( "save" );
        $tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        /* Form elements */
        $tb->addFieldSet ( "booking", _ALABOOKING_TXT_BOOKING_NEW, "", false );
        $tb->add ( "booking", "hidden", "myApplication", 'admin_booking' );
        $tb->add ( "booking", "select", "b_obj_id", $data ['b_obj_id'], _ALABOOKING_O, _ALABOOKING_O, 1, $SelList );
        $tb->add ( "booking", "input", "b_name", $data ['b_name'], _ALABOOKING_B_NAME, _ALABOOKING_B_NAME_INFO, 40 );
        $tb->add ( "booking", "input", "b_firstname", $data ['b_firstname'], _ALABOOKING_B_FIRSTNAME, _ALABOOKING_B_FIRSTNAME_INFO, 40 );
        $tb->add ( "booking", "datetime", "b_begin", ($data ['b_begin']) ? mx_strftime ( _ALABOOKING_DATETIMEPICKER, $data ['b_begin'] ) : '', _ALABOOKING_B_BEGIN, _ALABOOKING_B_BEGIN, 20 );
        $tb->add ( "booking", "datetime", "b_end", ($data ['b_end']) ? mx_strftime ( _ALABOOKING_DATETIMEPICKER, $data ['b_end'] ) : '', _ALABOOKING_B_END, _ALABOOKING_B_END, 20 );
        $tb->add ( "booking", "input", "b_street", $data ['b_street'], _ALABOOKING_B_STREET, '', 40 );
        $tb->add ( "booking", "input", "b_country", $data ['b_country'], _ALABOOKING_B_COUNTRY, '', 10 );
        $tb->add ( "booking", "input", "b_zip", $data ['b_zip'], _ALABOOKING_B_ZIP, '', 40 );
        $tb->add ( "booking", "input", "b_city", $data ['b_city'], _ALABOOKING_B_CITY, '', 40 );
        $tb->add ( "booking", "email", "b_email", $data ['b_email'], _ALABOOKING_B_EMAIL, _ALABOOKING_B_EMAIL_INFO, 40 );
        $tb->add ( "booking", "phone", "b_phone", $data ['b_phone'], _ALABOOKING_B_PHONE, _ALABOOKING_B_PHONE_INFO, 40 );
        $tb->add ( "booking", "textarea", "b_description", $data ['b_description'], _ALABOOKING_B_DESCRIPTION, _ALABOOKING_B_DESCRIPTION_INFO, 40, array (
            'rows' => 10 
        ) );
        $tb->add ( "booking", "select", "b_status", $data ['b_status'], _ALABOOKING_B_STATUS, '', 1, $Opt_Rec_Status );
        
        // eMail versenden?
        $tb->add ( "booking", "html", '<h4>eMail-Option</h4>' );
        if (! isset ( $data ['email_send'] ))
          $data ['email_send'] = $this->_config ['emailVisitorNew'] ['Active'];
        $tb->add ( "booking", "checkbox", "email_send", $data ['email_send'], _ALABOOKING_B_EMAILSEND, _ALABOOKING_B_EMAILSEND_INFO, 10 );
        if (! isset ( $data ['email_copy'] ))
          $data ['email_copy'] = $this->_config ['emailVisitorNew'] ['CopyToSender'];
        $tb->add ( "booking", "checkbox", "email_copy", $data ['email_copy'], _ALABOOKING_B_EMAILCOPYSENDER, _ALABOOKING_B_EMAILCOPYSENDER, 10 );
        if (! isset ( $data ['email_note'] ))
          $data ['email_note'] = '';
        $tb->add ( "booking", "textarea", "email_note", $data ['email_note'], _ALABOOKING_B_EMAILNOTE, _ALABOOKING_B_EMAILNOTE_INFO, 40, array (
            'rows' => 10 
        ) );
        
        $my_html = '';
        $tb->add ( "booking", "html", $my_html );
        
        $form = $tb->Show ();
        break;
      // -------------------------------------
      // - Buchung: Ändern
      // -------------------------------------
      case 'edit' :
        $tb->addToolbar ( "edit" );
        $tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        /* Form elements */
        $tb->addFieldSet ( "booking", _ALABOOKING_TXT_BOOKING_CHANGE, "", false );
        $tb->add ( "booking", "hidden", "myApplication", 'admin_booking' );
        $tb->add ( "booking", "select", "b_obj_id", $data ['b_obj_id'], _ALABOOKING_O, _ALABOOKING_O, 1, $SelList );
        $tb->add ( "booking", "input", "b_name", $data ['b_name'], _ALABOOKING_B_NAME, _ALABOOKING_B_NAME_INFO, 40, 5 );
        $tb->add ( "booking", "input", "b_firstname", $data ['b_firstname'], _ALABOOKING_B_FIRSTNAME, _ALABOOKING_B_FIRSTNAME_INFO, 40, 5 );
        $tb->add ( "booking", "datetime", "b_begin", ($data ['b_begin']) ? mx_strftime ( _ALABOOKING_DATETIMEPICKER, $data ['b_begin'] ) : '', _ALABOOKING_B_BEGIN, _ALABOOKING_B_BEGIN, 20 );
        $tb->add ( "booking", "datetime", "b_end", ($data ['b_end']) ? mx_strftime ( _ALABOOKING_DATETIMEPICKER, $data ['b_end'] ) : '', _ALABOOKING_B_END, _ALABOOKING_B_END, 20 );
        $tb->add ( "booking", "input", "b_street", $data ['b_street'], _ALABOOKING_B_STREET, '', 40 );
        $tb->add ( "booking", "input", "b_country", $data ['b_country'], _ALABOOKING_B_COUNTRY, '', 10 );
        $tb->add ( "booking", "input", "b_zip", $data ['b_zip'], _ALABOOKING_B_ZIP, '', 40 );
        $tb->add ( "booking", "input", "b_city", $data ['b_city'], _ALABOOKING_B_CITY, '', 40 );
        $tb->add ( "booking", "email", "b_email", $data ['b_email'], _ALABOOKING_B_EMAIL, _ALABOOKING_B_EMAIL_INFO, 40, 5 );
        $tb->add ( "booking", "phone", "b_phone", $data ['b_phone'], _ALABOOKING_B_PHONE, _ALABOOKING_B_PHONE_INFO, 40 );
        $tb->add ( "booking", "textarea", "b_description", $data ['b_description'], _ALABOOKING_B_DESCRIPTION, _ALABOOKING_B_DESCRIPTION_INFO, 40, array (
            'rows' => 10 
        ) );
        $tb->add ( "booking", "select", "b_status", $data ['b_status'], _ALABOOKING_B_STATUS, '', 1, $Opt_Rec_Status );
        
        // eMail versenden?
        $tb->add ( "booking", "html", '<h4>eMail-Option</h4>' );
        if (! isset ( $data ['email_send'] ))
          $data ['email_send'] = $this->_config ['emailVisitorNew'] ['Active'];
        $tb->add ( "booking", "checkbox", "email_send", $data ['email_send'], _ALABOOKING_B_EMAILSEND, _ALABOOKING_B_EMAILSEND_INFO, 10 );
        if (! isset ( $data ['email_copy'] ))
          $data ['email_copy'] = $this->_config ['emailVisitorNew'] ['CopyToSender'];
        $tb->add ( "booking", "checkbox", "email_copy", $data ['email_copy'], _ALABOOKING_B_EMAILCOPYSENDER, _ALABOOKING_B_EMAILCOPYSENDER, 10 );
        if (! isset ( $data ['email_note'] ))
          $data ['email_note'] = '';
        $tb->add ( "booking", "textarea", "email_note", $data ['email_note'], _ALABOOKING_B_EMAILNOTE, _ALABOOKING_B_EMAILNOTE_INFO, 40, array (
            'rows' => 10 
        ) );
        
        // eMail-Übersicht
        $tb->addFieldSet ( "emails", _ALABOOKING_EMAIL_LIST, "", true, array (
            "width" => "100%" 
        ) );
        $html_emails = $this->email_show_list ( $data ['b_id'] );
        $tb->add ( "emails", "html", $html_emails );
        
        $my_html = '';
        // $ar_tooltip = $this->getBookingTooltip ( $data ['b_id'] );
        // $my_html = $ar_tooltip['tooltip'];
        $tb->add ( "booking", "html", $my_html );
        
        $form = $tb->Show ();
        break;
      // ------------------------------------------
      // - Buchung: Liste zur Bearbeitung anzeigen
      // ------------------------------------------
      default :
        
        // Das X bedeutet, dass die Listfunktion eingeschaltet wird!
        $tb->addToolbar ( 'ConfirmX', _ALABOOKING_BTN_CONFIRM, PMX_IMAGE_PATH . 'adminform/publish.png', _ALABOOKING_BTN_CONFIRM_INFO );
        $tb->addToolbar ( 'CancelX', _ALABOOKING_BTN_CANCEL, PMX_IMAGE_PATH . 'adminform/cancel.png' );
        
        $tb->addToolbarLink ( "new", "admin.php?op=" . $this->_module_name . "/booking&amp;act=new", _ALABOOKING_BTN_BOOKING_NEW, PMX_IMAGE_PATH . 'adminform/new.png' );
        $tb->addToolbarLink ( "calendar", "admin.php?op=" . $this->_module_name . "/calendar", _ALABOOKING_BTN_CALENDAR, $this->_module_image_path . 'alaBooking.png' );
        $tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        
        /* benötigte Werte in der Session speichern */
        mxSessionSetVar ( "qryfilter", $qryfilter );
        mxSessionSetVar ( "qrystatus", $qrystatus );
        mxSessionSetVar ( "qryresource", $qryresource );
        
        $qry_where = ($qryfilter) ? " AND (b_name like '%" . $qryfilter . "%' OR b_firstname like '%" . $qryfilter . "%' OR obj_name like '%" . $qryfilter . "%' )" : "";
        $qry_where .= ($qrystatus != '') ? " AND (b_status = " . $qrystatus . " )" : "";
        $qry_where .= ($qryresource) ? " AND (obj_id = '" . $qryresource . "' )" : "";
        
        $sql = "SELECT * FROM " . ALABOOKING_TABLE_BOOKING . " AS b";
        $sql .= " LEFT JOIN " . ALABOOKING_TABLE_OBJECT . " as r ON b.b_obj_id = r.obj_id ";
        $sql .= " WHERE b.module = '" . $this->_module_name . "'";
        $sql .= $qry_where;
        $result = sql_query ( $sql );
        $rowset = array ();
        while ( $row = sql_fetch_assoc ( $result ) ) {
          $row ['status_icon'] = $this->get_StatusIcon ( $row ['b_status'] );
          $rowset [] = $row;
        }
        
        // Searchfilter:
        $this->_template->assign ( compact ( 'query', 'qryfilter' ) );
        $this->_template->assign ( 'qrystatus', $this->get_statusHtmlOpt ( $qrystatus ) );
        $this->_template->assign ( 'qryresource', $this->get_ObjectHtmlOpt ( $qryresource ) );
        $out = $this->_template->fetch ( 'searchfilter_list.html' );
        
        $this->_template->assign ( compact ( 'rowset' ) );
        $out .= $this->_template->fetch ( 'admin_booking_list.html' );
        $tb->add ( "", "html", $out );
        $form = $tb->Show ();
        break;
    }
    
    $this->adminpage ( $form );
  }
}

/**
 * alaBooking_booking_user
 *
 * User-Klasse zu alaBooking_booking
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_booking_user extends alaBooking_booking {
  
  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {
    parent::__construct ();
    
    // if (!$this->_is_admin) {
    // return mxredirect('modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA);
    // }
  }
  
  /**
   *
   * myBooking
   *
   * @param
   *          $op
   */
  public function myBooking($op, $userdata) {
    // evt. Aktion uebergeben?
    $act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "";
    // $sp_id = (isset ($_GET['sp_id'])) ? $_GET['sp_id'] : "";
    
    $data = array ();
    if ($userdata ['uid']) {
      $data = $this->get_data ( 0, $userdata ['uid'] );
    }
    // Defaults setzen und mit Form-Daten überschreiben:
    $data = array_merge ( $this->_defaults, $data, $_POST );
    
    // Verarbeitung der Aktionen:
    // 1. wurde ein AdminForm-Button gedrückt?
    $tb = load_class ( 'AdminForm', "adminClubMember" );
    switch (pmxAdminForm::CheckButton ()) {
      case "save" :
        // In DB Speichern:
        if (! $data ['m_id']) {
          $id = $this->add_send_save ( $data );
        } else {
          $id = $this->edit_send_save ( $data );
        }
        if ($this->_errors) {
          mxStripSlashes ( $data );
          $act = 'edit'; // Edit wiederholen!
        } else {
          mxRedirect ( "modules.php?name=" . $this->_module_name . "&op=myBooking&act=edit", _CHANGESAREOK, 1 );
        }
        break;
    }
    
    // Verarbeitung der Aktionen:
    // 2. wurde ein act-Parameter gesendet?
    switch ($act) {
      case "delete" :
        $data = $this->get_data ( $b_id );
        $this->del_send_save ( $b_id, $data );
        $act = '';
        break;
    }
    
    // Admin-Formular aufbauen:
    $tb = load_class ( 'AdminForm', "userBooking" );
    $tb->tb_text = _ALABOOKING_BTN_BOOKING;
    $tb->tb_direction = 'right';
    $tb->acceptbutton = false; //
    $tb->infobutton = $this->_config ['FormInfobutton']; // Info-Button oder als Text
    $tb->tb_pic_heigth = 22;
    $tb->csstoolbar = "toolbar1";
    $tb->cssform = "adminForm";
    $tb->homelink = false;
    
    switch ($act) {
      
      // -------------------------------------
      // - Buchung: Ändern
      // -------------------------------------
      case 'edit' :
        // $tb->addToolbar ( "save" );
        // // Immer den Rücksprung zum Admin-Menü:
        // // nur admin: $tb->addToolbarLink("cpanel", "admin.php?op=" . $this->_module_name);
        // /* Form elements */
        $tb->addFieldSet ( "buchungen", _ALABOOKING_B, "", false );
        
        $tb->add ( "buchungen", "html", 'Nothing to edit - sorry!' );
        $form = $tb->Show ();
        break;
      // ------------------------------------------
      // - Buchung: Liste zur Bearbeitung anzeigen
      // ------------------------------------------
      default :
        
        $tb->addToolbarLink ( "new", "modules.php?name=" . $this->_module_name, _ALABOOKING_BTN_BOOKING_NEW, PMX_IMAGE_PATH . 'adminform/new.png' );
        
        $sql = "SELECT * FROM " . ALABOOKING_TABLE_BOOKING . " AS b";
        $sql .= " LEFT JOIN " . ALABOOKING_TABLE_OBJECT . " as r ON b.b_obj_id = r.obj_id ";
        $sql .= " WHERE b.module = '" . $this->_module_name . "'";
        $sql .= " AND b.b_uid = " . $userdata ['uid'];
        $result = sql_query ( $sql );
        $rowset = array ();
        while ( $row = sql_fetch_assoc ( $result ) ) {
          // if (!$row['catname'] || !$row['cid']) {
          // $row['catname'] = _INACTIVE;
          // }
          $row ['status_icon'] = $this->get_StatusIcon ( $row ['b_status'] );
          $rowset [] = $row;
        }
        
        $this->_template->assign ( compact ( 'rowset' ) );
        $out = $this->_template->fetch ( 'user_booking_list.html' );
        $tb->add ( "", "html", $out );
        $form = $tb->Show ();
        break;
    }
    
    return $form;
  }
}

/**
 * alaBooking_booking_public
 *
 * AnonymeBesucher-Klasse zu alaBooking_booking
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_booking_public extends alaBooking_booking {
  
  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {
    parent::__construct ();
    
    $this->op = (empty ( $_REQUEST ['op'] )) ? '' : rtrim ( $_REQUEST ['op'], ' /' );
    switch ($this->op) {
      case 'booking' :
      default :
        // Aktives Tab setzen:
        $currenttab = 'hidetabs'; // Tabs ausblenden
        $content = $this->public_FormBooking ();
        break;
    }
    
    // Link zum Backend (Administration):
    $adminlink = $this->adminlink ( 'member' );
    $this->_template->assign ( 'adminlink', $adminlink );
    
    // Aktives Tab setzen:
    $this->_template->assign ( 'current', $currenttab );
    
    // Ausgabe im Haupt-Template
    return $this->page ( $content );
  }
  
  /**
   * alaBooking_booking_public::public_FormBooking
   */
  public function public_FormBooking() {
    
    // Übergabeparameter
    // evt. Aktion uebergeben?
    $act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "";
    $b_id = (isset ( $_GET ['b_id'] )) ? $_GET ['b_id'] : "";
    $obj_id = ($_GET ['obj_id']) ? $_GET ['obj_id'] : 0;
    
    // Objektinformationen:
    $obj_obj = new alaBooking_object ();
    $data_res = $obj_obj->get_data ( $obj_id );
    
    // Buchungsinformation
    $data = array ();
    if ($b_id) {
      $data = $this->get_data ( $b_id );
    }
    // Defaults setzen und mit Form-Daten überschreiben:
    $data = array_merge ( $this->_defaults, $data, $_POST );
    
    if (! $data ['b_obj_id'])
      $data ['b_obj_id'] = $obj_id;
      
      // Wenn wir von einer erfolgreichen Registrierung hierher geleitet werden:
    if ($act == 'clear') {
      $data = array ();
      $data = array_merge ( $this->_defaults, $data );
      $act = 'new';
    }
    
    // Verarbeitung der Aktionen:
    // 1. wurde ein AdminForm-Button gedrückt?
    $tb = load_class ( 'AdminForm', "CourseRegistration" );
    switch (pmxAdminForm::CheckButton ()) {
      case "save" :
      case "accept" :
        
        $captcha = pmxAdminForm::checkCaptcha ( "registrationcaptcha" );
        if (! $captcha)
          $this->_errors [] = _CAPTCHAWRONG;
          
          // In DB Speichern:
        if (! $this->_errors)
          $id = $this->save_from_public_FormBooking ( $data );
        
        if (! $id || $this->_errors) {
          mxStripSlashes ( $data );
          $act = 'new'; // Neuanlage wiederholen!
        } else {
          $act = ''; // Default-Aktion: Liste
          mxRedirect ( 'modules.php?name=' . $this->_module_name, implode ( '<br>', $this->_messages ), 5 );
        }
        break;
      case "edit" :
        $act = 'new'; // Neuanlage wiederholen!
        break;
      case "cancel" :
        mxRedirect ( 'modules.php?name=' . $this->_module_name, 5 );
        break;
    }
    
    // Evt. Userdaten setzen:
    if (MX_IS_USER) {
      $data ['b_email'] = (! $data ['b_email']) ? $this->_user ['email'] : $data ['b_email'];
      $data ['b_city'] = (! $data ['b_city']) ? $this->_user ['city'] : $data ['b_city'];
    }
    
    // Buchungskalender: her damit:
    $this->_template->assign ( compact ( 'data_res' ) );
    $this->_template->assign ( 'stat_free', $this->get_StatusIcon ( STATUS_FREE ) );
    $this->_template->assign ( 'stat_requested', $this->get_StatusIcon ( STATUS_REQUESTED ) );
    $this->_template->assign ( 'stat_confirmed', $this->get_StatusIcon ( STATUS_CONFIRMED ) );
    $html_calendar = $this->_template->fetch ( 'booking_form.html' );
    
    // Admin-Formular aufbauen:
    $tb = load_class ( 'AdminForm', "PublicBooking" );
    $tb->tb_direction = 'left';
    $tb->tb_show = 'bottom';
    $tb->acceptbutton = false; //
    $tb->infobutton = $this->_config ['FormInfobutton']; // Info-Button oder Erklärende Texte
    $tb->tb_pic_heigth = 22;
    $tb->csstoolbar = "toolbar1";
    $tb->cssform = "adminForm";
    $tb->homelink = true;
    $tb->buttontext = false; // Anzeige von SAVE und UP-Button unter der Feldliste
    $tb->enctype = "multipart/form-data";
    $tb->title = _ALABOOKING_B; // Titel des Formulars
    $tb->description = _ALABOOKING_B_REQUEST; // Text unter dem Titel
    
    $tb->addToolbar ( "save", _ALABOOKING_B_SEND );
    $tb->addToolbar ( "cancel" );
    /* Form elements */
    $tb->add ( "", "html", $html_calendar );
    
    $tb->add ( "", "hidden", "b_obj_id", $data ['b_obj_id'], '', '', 40 );
    $tb->add ( "", "hidden", "obj_bookingtype", $data_res ['obj_bookingtype'], '', '', 40 );
    $tb->add ( "", "hidden", "obj_name", $data_res ['obj_name'], '', '', 40 );
    $tb->add ( "", "hidden", "buchdatuemer", $data ['buchdatuemer'], '', '', 40, 'id="buchdatuemer"' );
    
    if (array_key_exists ( 'BookingRegIntro', $this->_config ))
      $tb->add ( "", "html", $this->_config ['BookingRegIntro'] );
    $tb->add ( "", "input", "b_name", $data ['b_name'], _ALABOOKING_B_NAME . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', _ALABOOKING_B_NAME_INFO, 40 );
    $tb->add ( "", "input", "b_firstname", $data ['b_firstname'], _ALABOOKING_B_FIRSTNAME . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', _ALABOOKING_B_FIRSTNAME_INFO, 40 );
    // angemeldete Benutzer: Anzeige der user-ID
    if (MX_IS_USER) {
      if (! $data ['b_uid'])
        $data ['b_uid'] = $this->_user ['uid'];
      $tb->add ( "", "input", "b_uid", $data ['b_uid'], _ALABOOKING_B_UID, _ALABOOKING_B_UID_INFO, 40, array (
          'disabled' => 'disabled' 
      ) );
    }
    
    switch ($this->_config ['BookingFormField'] ['Street']) {
      case 'entry' :
        $tb->add ( "", "input", "b_street", $data ['b_street'], _ALABOOKING_B_STREET, '', 40 );
        break;
      case 'required' :
        $tb->add ( "", "input", "b_street", $data ['b_street'], _ALABOOKING_B_STREET . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', '', 40 );
        break;
      case 'hidden' :
      default :
        break;
    }
    
    switch ($this->_config ['BookingFormField'] ['Country']) {
      case 'entry' :
        $tb->add ( "", "input", "b_country", $data ['b_country'], _ALABOOKING_B_COUNTRY, '', 40 );
        break;
      case 'required' :
        $tb->add ( "", "input", "b_country", $data ['b_country'], _ALABOOKING_B_COUNTRY . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', '', 40 );
        break;
      case 'hidden' :
      default :
        break;
    }
    switch ($this->_config ['BookingFormField'] ['Zip']) {
      case 'entry' :
        $tb->add ( "", "input", "b_zip", $data ['b_zip'], _ALABOOKING_B_ZIP, '', 40 );
        break;
      case 'required' :
        $tb->add ( "", "input", "b_zip", $data ['b_zip'], _ALABOOKING_B_ZIP . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', '', 40 );
        break;
      case 'hidden' :
      default :
        break;
    }
    switch ($this->_config ['BookingFormField'] ['City']) {
      case 'entry' :
        $tb->add ( "", "input", "b_city", $data ['b_city'], _ALABOOKING_B_CITY, '', 40 );
        break;
      case 'required' :
        $tb->add ( "", "input", "b_city", $data ['b_city'], _ALABOOKING_B_CITY . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', '', 40 );
        break;
      case 'hidden' :
      default :
        break;
    }
    
    $tb->add ( "", "email", "b_email", $data ['b_email'], _ALABOOKING_B_EMAIL . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', _ALABOOKING_B_EMAIL_INFO, 40 );
    $tb->add ( "", "phone", "b_phone", $data ['b_phone'], _ALABOOKING_B_PHONE, _ALABOOKING_B_PHONE_INFO, 40 );
    $tb->add ( "", "textarea", "b_description", $data ['b_description'], _ALABOOKING_B_DESCRIPTION, _ALABOOKING_B_DESCRIPTION_INFO, 40, array (
        'rows' => 5 
    ) );
    
    $tb->add ( "", "captcha", "registrationcaptcha", "documentson", _CAPTCHAINSERT . '<span style="color: rgb(255, 0, 0);">&nbsp;*</span>', _CAPTCHAINSERT );
    $tb->add ( "", "html", $this->_config ['BookingRegDisclaimer'] );
    
    $form = $tb->Show ();
    
    return $form;
  }
}

?>
