<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

// include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes/alaBooking.timeline.php");
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes/class.timeline.php");

/**
 * alaBooking_calendar
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_calendar extends alaBooking {
  public $_defaults = array ();
  public $_f_defaults = array ();
  public $_acc_defaults = array ();


  function __construct() {

    parent::__construct ();
    // Defaults für den Club-Mitglieder DB-Satz
    $this->_defaults = array(/* Standardwerte */
            'module' => $this->_module_name,
        'b_id' => 0,
        'b_obj_id' => '',
        'b_begin' => '',
        'b_end' => '',
        'b_name' => '',
        'b_firstname' => '',
        'b_email' => '',
        'b_description' => '',
        'b_status' => 0 
    );
  }

  /**
   * alaBooking_booking::add_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function add_send_save($data) {

    if (! $this->check_booking ( $data )) {
      return false;
    }
    
    $ar_datum = explode ( ",", $data ['buchdatuemer'] );
    // mxDebugFuncvars ( $ar_datum );
    
    foreach ( $ar_datum as $datum ) {
      $fields = array ();
      $fields [] = "b_begin = '" . $datum . " 00:00:00'";
      $fields [] = "b_end = '" . $datum . " 23:59:59'";
      
      // Daten checken:
      $data ['b_status'] = empty ( $data ['b_status'] ) ? 0 : $data ['b_status'];
      
      $fields [] = "module = '" . $this->_module_name . "'";
      $fields [] = "b_obj_id = " . intval ( $data ['b_obj_id'] );
      $fields [] = "b_name = '" . mxAddSlashesForSQL ( $data ['b_name'] ) . "'";
      $fields [] = "b_firstname = '" . mxAddSlashesForSQL ( $data ['b_firstname'] ) . "'";
      $fields [] = "b_email = '" . mxAddSlashesForSQL ( $data ['b_email'] ) . "'";
      $fields [] = "b_description = '" . mxAddSlashesForSQL ( $data ['b_description'] ) . "'";
      $fields [] = "b_status = " . intval ( $data ['b_status'] );
      
      $sql = "INSERT INTO `" . ALABOOKING_TABLE_BOOKING . "` SET " . implode ( ', ', $fields );
      $result = sql_query ( $sql );
      
      if ($result) {
        $data ['b_id'] = sql_insert_id ();
        
        // Hier können noch einige Zusatz-Updates erfolgen....
        // if ($this->_config ['FuncAssignAtUserMgmt']) {
        // if ($data ['f_function']) {
        // $data ['f_m_id'] = $data ['m_id'];
        // $id = $this->f_add_send_save ( $data );
        // }
        // }
        
        $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENADDED;
      } else {
        $this->_errors [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENADDEDNOT;
      }
    }
    return $data ['b_id'];
  }

  /**
   * alaBooking_booking::check_booking()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  protected function check_booking($data) {

    if (empty ( $data ['b_name'] )) {
      $this->_errors [] = _ALABOOKING_B_MUST_NAME;
    }
    
    return ! $this->_errors;
  }

  /**
   * CLUB::convert_to_sql_date()
   * Konvertiert ein String-Datum, welches vom Datepicker kommt in
   * ein SQL-Format "YYYY-MM-DD"
   *
   * @param mixed $date          
   * @return integer timestamp
   */
  protected function convert_to_sql_date($date) {
    
    switch (true) {
      case is_numeric ( $date ) :
        return $date;
      case empty ( $date ) :
      case ! is_scalar ( $date ) :
        return 'NULL';
      default :
        return mkfromstrptime ( $date, _DATEPICKER );
    }
  }

  /**
   * alaBooking_booking_booking::del_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function del_send_save($b_id, $data) {

    $sql = "DELETE FROM `" . ALABOOKING_TABLE_BOOKING . "` WHERE b_id= " . $b_id;
    $sql .= " AND module = '" . $this->_module_name . "'";
    $result = sql_query ( $sql );
    if ($result) {
      $this->_messages [] = _ALABOOKING_B . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENDELETED;
    }
    
    $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENDELETED;
    
    return true;
  }

  /**
   * alaBooking_calendar::edit_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function edit_send_save($data) {

    if (! $this->check_booking ( $data )) {
      return false;
    }
    
    // Daten checken:
    $data ['b_status'] = empty ( $data ['b_status'] ) ? 0 : $data ['b_status'];
    
    $fields [] = "module = '" . $this->_module_name . "'";
    $fields [] = "b_obj_id = " . intval ( $data ['b_obj_id'] );
    $fields [] = "b_begin = '" . $data ['b_begin'] . "'";
    $fields [] = "b_end = '" . $data ['b_end'] . "'";
    $fields [] = "b_name = '" . mxAddSlashesForSQL ( $data ['b_name'] ) . "'";
    $fields [] = "b_firstname = '" . mxAddSlashesForSQL ( $data ['b_firstname'] ) . "'";
    $fields [] = "b_email = '" . mxAddSlashesForSQL ( $data ['b_email'] ) . "'";
    $fields [] = "b_description = '" . mxAddSlashesForSQL ( $data ['b_description'] ) . "'";
    $fields [] = "b_status = " . intval ( $data ['b_status'] );
    
    $sql = "UPDATE `" . ALABOOKING_TABLE_BOOKING . "` SET " . implode ( ', ', $fields );
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND b_id=" . $data ['b_id'];
    $result = sql_query ( $sql );
    
    $this->_messages [] = _ALABOOKING_B . " <em>" . $data ['b_name'] . "</em> " . _ALABOOKING_HASBEENCHANGED;
    
    return true;
  }

  /**
   * alaBooking_booking_booking::get_data()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  public function get_data($id) {

    $sql = "SELECT * FROM `" . ALABOOKING_TABLE_BOOKING . "`";
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND b_id=" . $id;
    $result = sql_query ( $sql );
    $row = sql_fetch_assoc ( $result );
    if (! $row) {
      return $this->_defaults;
    }
    
    return array_merge ( $this->_defaults, $row );
  }



}

/**
 * alaBooking_calendar_admin
 *
 * Administrator-Klasse zum Kalender alaBooking_calendar
 * 
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_calendar_admin extends alaBooking_calendar {
  private $spieler = null;

  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {

    parent::__construct ();
    
    if (! $this->_is_admin) {
      return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
    }
    $this->_adminmode = true; // Aufruf über die admin.php
  }

  /**
   * alaBooking_calendar_admin::admin_calendar_show
   * 
   * Anzeige Buchungskalender
   * 
   * @param unknown $op
   */
  public function admin_calendar_show($op) {

    global $user_prefix;
    
    // evt. Aktion uebergeben?
    $act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "";
    $obj_id = (isset ( $_GET ['obj_id'] )) ? $_GET ['obj_id'] : "";
    /* Filter-Ausgangswert festlegen */
    $qryfilter = ((isset ( $_POST ['qryfilter'] )) ? $_POST ['qryfilter'] : ((mxSessionGetVar ( "qryfilter" )) ? mxSessionGetVar ( "qryfilter" ) : ''));
    
    // Verarbeitung der Aktionen:
    // 1. wurde ein AdminForm-Button gedrückt?
    $tb = load_class ( 'AdminForm', "admin_alaBookingCalendar" );
    switch (pmxAdminForm::CheckButton ()) {
      case "ShowCalendar" :
        $obj_id = implode ( ',', $_POST ['cid'] );
        // mxRedirect("admin.php?op=" . $this->_module_name . "/calendar&act=show&obj_id=".$obj_id,'zum Kalender...',0);
        $act = 'show';
        break;
      case "set_qryfilter" :
        $act = ''; // Default-Aktion: Liste
    }
    
    
    // Datenbeschaffung:
    /* benötigte Werte in der Session speichern */
    mxSessionSetVar ( "qryfilter", $qryfilter );
    
    $qry_where = ($qryfilter) ? " AND (obj_name like '%" . $qryfilter . "%' OR obj_description like '%" . $qryfilter . "%' )" : "";
    
    $sql = "SELECT *  FROM " . ALABOOKING_TABLE_OBJECT . "";
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= $qry_where;
    $sql .= " AND obj_status = ". STATUS_ACTIVE;
    $result = sql_query ( $sql );
    $rowset = array ();
    while ( $row = sql_fetch_assoc ( $result ) ) {
    	// if (!$row['catname'] || !$row['cid']) {
    	// $row['catname'] = _INACTIVE;
    	// }
    	$row ['status_icon'] = $this->get_StatusIcon ( $row ['obj_status'] );
    	$rowset [] = $row;
    }
    
    // Falls nur ein Eintrag, in den 'show' - Moduls gehen!
    if (count($rowset) == 1){
      $obj_id = $rowset[0]['obj_id'];
      $act = 'show';
    }
    
    
    
    
    // Formular TimeLine vor dem Rahmen-Formular aufbauen:
    if ($act == 'show') {
      $timeline = new alaBooking_TimeLine ( $obj_id );
      $html_timeline = $timeline->TimeLine_Show ( $op );
    }
    
    // Admin-Formular aufbauen:
    $tb = load_class ( 'AdminForm', "admin_alaBookingCalendar" );
    $tb->tb_text = _ALABOOKING_TXT_TIMELINE ;
    $tb->tb_direction = 'right';
    $tb->acceptbutton = false; //
    $tb->infobutton = $this->_config ['FormInfobutton']; // Info-Button oder als Text
    $tb->tb_pic_heigth = 22;
    $tb->csstoolbar = "toolbar1";
	$tb->cssform = "adminForm";
    $tb->homelink = false;
    $tb->buttontext = false; // Anzeige von SAVE und UP-Button unter der Feldliste
    $tb->tb_show = "top"; // Wo steht die Toolbar: top/bottom/both
    $tb->checklistflag = 1; // Es soll eine Liste sein
    $tb->checkselector = 'cid'; // In der Liste können alle Zeilen mit dem namen 'cid' markiert werden!
    
    switch ($act) {
      
      case 'show' :
        $tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/calendar", _ALABOOKING_BTN_CALENDAR, $this->_module_image_path . 'alaBooking.png' );
        $tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        
        $tb->add ( "", "html", $html_timeline );
        $form = $tb->Show ();
        
        break;
      
      // ------------------------------------------
      // - Buchungen: Liste zur Auswahl anzeigen
      // ------------------------------------------
      default :
        
        // $tb->addToolbar($name, $text = '', $pic = '', $alttext = '', $listfunc = false);
        
        // Das X bedeutet, dass die Listfunktion eingeschaltet wird!
        $tb->addToolbar ( 'ShowCalendarX', _ALABOOKING_BTN_DETAIL, 'images/adminform/preview.png', _ALABOOKING_BTN_DETAIL_INFO );
        
        // $tb->addToolbarLink ( "new", "admin.php?op=" . $this->_module_name . "/resource&amp;act=new", _ALABOOKING_BTN_OBJECT_NEW, PMX_IMAGE_PATH . 'adminform/new.png' );
        $tb->addToolbarLink ( "bookinglist", "admin.php?op=" . $this->_module_name . "/booking", _ALABOOKING_BTN_BOOKING, $this->_module_image_path . 'booking_list.png' );
        $tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/calendar", _ALABOOKING_BTN_CALENDAR, $this->_module_image_path . 'alaBooking.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        
        
        // Searchfilter:
        $this->_template->assign ( compact ( 'query', 'qryfilter' ) );
        $out = $this->_template->fetch('searchfilter_list.html');
        
        $this->_template->assign ( compact ( 'rowset' ));
        $out .= $this->_template->fetch ( 'admin_calendar_list.html' );
        $tb->add ( "", "html", $out );
        $form = $tb->Show ();
        break;
    }
    
    $this->adminpage ( $form );
  }

}


?>
