<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

// eigene Includes einbinden
// $module_name ist hier 'admin';
global $module_name;

// Haupt-Klasse: alaBooking
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "includes/class.alaBooking.php");

/**
 * alaBooking_email
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_email extends alaBooking {
	private $op = null;
	protected $_adminmode;
	protected $_dummyvars = array ();
	public $_messages = array ();
	
	/**
	 * alaBooking_admin::__construct()
	 *
	 * @param string $parameter        	
	 */
	function __construct() {
		global $prefix;
		
		parent::__construct ();
		
		// Check Defaults
		$this->check_defaults ();
		
		// Maximal-Template-Platzhalter
		$this->_dummyvars = array (
				'[b_id]' => _ALABOOKING_B_ID_INFO,
				'[b_email]' => _ALABOOKING_B_EMAIL_INFO,
				'[b_creation_date]' => _ALABOOKING_B_CREATIONDATE,
				'[b_content]' => _ALABOOKING_B_CONTENT,
				'[email_note]' => _ALABOOKING_EMAIL_NOTE,
				'[url2maintain]' => _ALABOOKING_B_URL2MAINTAIN,
				'[siteurl]' => _ALABOOKING_URL,
				'[sitename]' => _ALABOOKING_SITENAME,
				'[disclaimer]' => _ALABOOKING_CONF_BOOKING_DISCLAIMER
		)
		;
		
		// Defaults für eMail DB-Satz
		$this->_defaults = array(/* Standardwerte */
    		'module' => $this->_module_name,
				'bcom_b_id' => 0,
				'bcom_receiver' => '',
				'bcom_sender' => '',
				'bcom_subject' => '',
				'bcom_message' => '',
				'bcom_type' => '',
				'bcom_status' => 0,
				'bcom_ts' => '' 
		);
	}
	
	/**
	 * alaBooking_email::get_data()
	 *
	 * Enter description here ...
	 *
	 * @param unknown_type $data        	
	 */
	public function get_data($id) {
		$sql = "SELECT * FROM `" . ALABOOKING_TABLE_BCOM . "`";
		$sql .= " WHERE module = '" . $this->_module_name . "'";
		$sql .= "  AND bcom_id=" . $id;
		$result = sql_query ( $sql );
		$row = sql_fetch_assoc ( $result );
		if (! $row) {
			return $this->_defaults;
		}
		
		return array_merge ( $this->_defaults, $row );
	}
	
	/**
	 *
	 * eMail-Versand eines Templates
	 *
	 * --> Vor Versand wird eine ShortCut-Substitution durchgeführt
	 *
	 * @param string $eMailType
	 *        	Art der eMail zur Identifizierung des eMail-Templates
	 * @param array $data
	 *        	DatenArray mit
	 */
	public function SendEmailNotification($eMailType = 'emailAdminNew', $data, $CopyToSender = false) {
		
		// Standard-Shortcuts ergänzen:
		$data = array_merge ( $data, $this->get_standard_shortcut ( $eMailType, $data ) );
		// Daten filtern, damit kein dummes Zeug gemacht werden kann!
		$data = $this->filter_shortcut_for_type ( $eMailType, $data );
		
		// Empfänger
		$receiver = $this->_config [$eMailType] ['Receiver'];
		// evt. überschreiben:
		$receiver = isset ( $data ['email_receiver'] ) ? $data ['email_receiver'] : $receiver;
		$receiver = $this->email_replace_shortcut_in_text ( $receiver, $data, true );
		// Versender
		$sender = $this->_config [$eMailType] ['Sender'];
		$sender = $this->email_replace_shortcut_in_text ( $sender, $data, true );
		// Betreff
		$subject = $this->_config [$eMailType] ['Subject']; // Roh-Formular
		$subject = $this->email_replace_shortcut_in_text ( $subject, $data, true );
		// Nachricht
		$message = $this->_config [$eMailType] ['MailContent'];
		$message = $this->email_replace_shortcut_in_text ( $message, $data, true );
		
		// mxDebugFuncvars ( $message );
		
		// bei Sendeart 'text' die HTML-Tags entfernen:
		// $message = strip_tags ( $message );
		
		if (mxMail ( $receiver, $subject, $message, $sender, "html", "alaBooking" )) {
			$this->_messages [] = 'eMail send to: ' . $receiver . ' / ' . $subject;
			$success = 1;
		} else {
			$this->_messages [] = 'ERROR by eMail send to: ' . $receiver . ' / ' . $subject;
			$success = 1;
		}
		$this->write_log_db ( $receiver, $subject, $message, $sender, "html", $success, $data ['b_id'] );
		
		if ($CopyToSender) {
			// Betreff:
			$subject = 'Copy: ' . $subject;
			$receiver = $sender;
			if (mxMail ( $receiver, $subject, $message, $sender, "html", "alaBooking" )) {
				$this->_messages [] = 'eMail send to: ' . $receiver . ' / ' . $subject;
				$success = 1;
			} else {
				$this->_messages [] = 'ERROR by eMail send to: ' . $receiver . ' / ' . $subject;
				$success = 0;
			}
			$this->write_log_db ( $receiver, $subject, $message, $sender, "html", $success, $data ['b_id'] );
		}
	}
	protected function write_log_db($receiver, $subject, $message, $sender, $type, $status, $b_id = 0) {
		$fields [] = "module = '" . $this->_module_name . "'";
		$fields [] = "bcom_b_id = " . intval ( $b_id );
		$fields [] = "bcom_receiver = '" . mxAddSlashesForSQL ( $receiver ) . "'";
		$fields [] = "bcom_sender = '" . mxAddSlashesForSQL ( $sender ) . "'";
		$fields [] = "bcom_subject = '" . mxAddSlashesForSQL ( $subject ) . "'";
		$fields [] = "bcom_message = '" . mxAddSlashesForSQL ( $message ) . "'";
		$fields [] = "bcom_type = '" . mxAddSlashesForSQL ( $type ) . "'";
		$fields [] = "bcom_status = " . intval ( $status );
		
		$sql = "INSERT INTO `" . ALABOOKING_TABLE_BCOM . "` SET " . implode ( ', ', $fields );
		$result = sql_query ( $sql );
	}
	
	/**
	 *
	 * Erzeugt ein Array mit Standard-Abkürzungen für die Substitution von Werten
	 *
	 * @return array
	 */
	protected function get_standard_shortcut() {
		$field_values = array ();
		// Noch einige Standard-Feldwerte hinzufügen:
		$field_values ['sitename'] = $GLOBALS ['sitename'];
		$field_values ['siteurl'] = '<a href="' . $GLOBALS ['nukeurl'] . '">' . $GLOBALS ['sitename'] . '</a>';
		$field_values ['disclaimer'] = $this->_config ['BookingRegDisclaimer'];
		return $field_values;
	}
	
	/**
	 *
	 * Erstellt eine Zusatzinformation für die eMail-Templates, welche ShortCuts für die
	 * Substitution gültig sind.
	 *
	 * @param string $type
	 *        	Art der eMail zur Identifizierung des eMail-Templates
	 * @return string HTML <div></div> mit den Informationen
	 */
	protected function build_add_info_email($type) {
		$ar_shortcuts = $this->filter_shortcut_for_type ( $type, $this->_dummyvars );
		
		$out = '<p>' . _ALABOOKING_EMAIL_NOTE_TEMPLATES . ':</p>';
		
		foreach ( $ar_shortcuts as $key => $descr ) {
			$out .= '<p class="admin_addinfo"><code>' . $key . '</code> - ' . $descr . '</p>';
		}
		return $out;
	}
	
	/**
	 *
	 * Filter auf ShortCuts für die eMail-Substitution ...
	 *
	 * @param string $type
	 *        	Art der eMail zur Identifizierung des eMail-Templates
	 * @param unknown $ar_data
	 *        	Array mit den zu filternden Daten
	 * @return array: gefiltertes Array basierend auf $this->_dummyvars
	 */
	protected function filter_shortcut_for_type($type, $ar_data) {
		$ar_shortcuts = $ar_data;
		switch ($type) {
			case 'emailAdminNew' :
				unset ( $ar_shortcuts ['[email_note]'] ); // Falls es sich um das ShortCut-Array handelt:
				unset ( $ar_shortcuts ['email_note'] ); // Falls es sich um ein Daten-Array handelt:
				break;
			case 'emailVisitorNew' :
				unset ( $ar_shortcuts ['[email_note]'] ); // Falls es sich um das ShortCut-Array handelt:
				unset ( $ar_shortcuts ['email_note'] ); // Falls es sich um ein Daten-Array handelt:
				unset ( $ar_shortcuts ['[url2maintain]'] ); // Falls es sich um das ShortCut-Array handelt:
				unset ( $ar_shortcuts ['url2maintain'] ); // Falls es sich um ein Daten-Array handelt:
				break;
			case '' :
			default :
				unset ( $ar_shortcuts ['[url2maintain]'] ); // Falls es sich um das ShortCut-Array handelt:
				unset ( $ar_shortcuts ['url2maintain'] ); // Falls es sich um ein Daten-Array handelt:
				break;
		}
		return $ar_shortcuts;
	}
	
	/**
	 *
	 * Ersetzt die Dummys (Shortcuts) im $input_text mit den Variablen-Werten aus dem $field_values -
	 *
	 * @param unknown $input_text
	 *        	Text, in dem die ShortCuts ersetzt werden sollen
	 * @param unknown $field_values
	 *        	Array mit Daten
	 * @param string $is_delete_unknown_shortcodes        	
	 * @return Ambigous <unknown, mixed>
	 */
	function email_replace_shortcut_in_text($input_text, $field_values = array(), $is_delete_unknown_shortcodes = false) {
		$out_text = $input_text;
		
		// Pattern for searching of the shortcodes in the Text
		$any_shortcodes = '[a-zA-Z][0-9a-zA-Z:._-]*';
		$regex = '%\[\s*(' . $any_shortcodes . ')\s*\]%';
		
		// Search any shortcodes in the $form
		preg_match_all ( $regex, $input_text, $matches, PREG_PATTERN_ORDER ); // PREG_PATTERN_ORDER, PREG_SET_ORDER, PREG_OFFSET_CAPTURE
		                                                                      
		// Loop all found shortcodes
		if (isset ( $matches [1] )) {
			foreach ( $matches [1] as $key => $field ) {
				
				// $field // secondname
				// $matches[0][$key] // [secondname]
				// $matches[1][$key] // secondname
				
				if (isset ( $field_values [$field] ))
					$replace_value = $field_values [$field];
				else {
					if ($is_delete_unknown_shortcodes)
						$replace_value = '';
					else
						$replace_value = $matches [0] [$key];
				}
				
				$out_text = str_replace ( $matches [0] [$key], $replace_value, $out_text );
			}
		}
		return $out_text;
	}
	
	/**
	 * Prüft, ob Default-Werte für die Template-Texte vorhanden sind
	 */
	protected function check_defaults() {
		if (! $this->_config ['emailAdminNew'] ['MailContent'])
			$this->_config ['emailAdminNew'] ['MailContent'] = _ALABOOKING_EMAIL_DEF_ADMINNEW;
		if (! $this->_config ['emailVisitorNew'] ['MailContent'])
			$this->_config ['emailVisitorNew'] ['MailContent'] = _ALABOOKING_EMAIL_DEF_VISITORNEW;
		if (! $this->_config ['emailVisitorConfirm'] ['MailContent'])
			$this->_config ['emailVisitorConfirm'] ['MailContent'] = _ALABOOKING_EMAIL_DEF_VISITORCONFIRM;
		if (! $this->_config ['emailVisitorDeny'] ['MailContent'])
			$this->_config ['emailVisitorDeny'] ['MailContent'] = _ALABOOKING_EMAIL_DEF_VISITORDENY;
	}
	
	/**
	 * alaBooking_email::del_send_save()
	 *
	 * Löschen einer einzelnen eMail über die eMail-ID bcom_id
	 *
	 * @param unknown_type $data        	
	 */
	function del_send_save($bcom_id, $data) {
		$sql = "DELETE FROM `" . ALABOOKING_TABLE_BCOM . "` WHERE bcom_id= " . $bcom_id;
		$sql .= " AND module = '" . $this->_module_name . "'";
		$result = sql_query ( $sql );
		if ($result) {
			$this->_messages [] = _ALABOOKING_EMAIL . " <em>" . $data ['bcom_b_id'] . "/" . $data ['bcom_subject'] . "</em> " . _ALABOOKING_HASBEENDELETED;
			// Zusätzliche Informationen löschen?
		} else
			$this->_messages [] = _ALABOOKING_EMAIL . " <em>" . $data ['bcom_b_id'] . "/" . $data ['bcom_subject'] . "</em> " . _ALABOOKING_HASBEENDELETEDNOT;
		
		return true;
	}
	
	/**
	 * alaBooking_email::del_send_save_b_id()
	 *
	 * Löscht alle eMails zu einer Buchungs-ID
	 *
	 * @param unknown_type $b_id        	
	 */
	function del_send_save_b_id($b_id) {
		
		// Alle Templates von der Datenbank lesen:
		$sql = "SELECT * FROM `" . ALABOOKING_TABLE_BCOM . "`";
		$sql .= " WHERE module = '" . $this->_module_name . "'";
		$sql .= " AND bcom_b_id = " . $b_id;
		$result = sql_query ( $sql );
		while ( $row = sql_fetch_assoc ( $result ) ) {
			$this->del_send_save ( $row ['bcom_id'], $row );
		}
		return true;
	}
	
	/**
	 * Anzeige einer eMail
	 *
	 * @param unknown $op        	
	 */
	public function admin_email_show($op) {
		// evt. Aktion uebergeben?
		$act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "show";
		$bcom_id = (isset ( $_GET ['bcom_id'] )) ? $_GET ['bcom_id'] : "";
		
		$data = $this->get_data ( $bcom_id );
		
		$this->_template->assign ( compact ( 'data' ) );
		
		echo $this->_template->fetch ( 'email_show.html' );
		
		return;
	}
	
	/**
	 *
	 * Settings für die eMail-Funktionalität: Template-Texte und sonstige Settings
	 *
	 * @param unknown $op        	
	 */
	function admin_email_settings($op) {
		// Nur Administratoren!
		if (! $this->_is_admin) {
			return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
		}
		$admindata = mxGetAdminSession ();
		$this->_adminmode = true; // Aufruf über die admin.php
		                          
		// Formular initialisieren:
		$tb = load_class ( 'AdminForm', "adminFormMain" );
		
		// Verarbeitung der Aktionen:
		// 1. wurde ein AdminForm-Button gedrückt?
		switch (pmxAdminForm::CheckButton ()) {
			case "save" :
			case "accept" :
				$temp = $_POST ['config'];
				$this->config_save ( $temp );
				mxRedirect ( "admin.php?op=" . $this->_module_name . "/email/settings", _CHANGESAREOK, 1 );
				break;
		}
		
		// Formular initialisieren:
		$tb = load_class ( 'AdminForm', "adminFormMain" );
		$tb->tb_text = _ALABOOKING_BTN_EMAILSETTINGS;
		$tb->tb_direction = 'right';
		$tb->infobutton = $this->_config ['FormInfobutton'];
		$tb->tb_pic_heigth = 22;
		$tb->csstoolbar = "toolbar1";
		$tb->cssform = "adminForm";
		$tb->homelink = false;
		
		$tb->addToolbar ( "save" );
		$tb->addToolbarLink ( "settings", "admin.php?op=" . $this->_module_name . "/settings", _ALABOOKING_BTN_SETTINGS, PMX_IMAGE_PATH . 'adminform/settings.png' );
		$tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
		
		/* Form elements */
    /* FieldSet */
    
    $tb->addFieldSet ( "admin_new", _ALABOOKING_EMAIL_ADMINNEW, _ALABOOKING_EMAIL_ADMINNEW_INFO, true );
		$tb->add ( "admin_new", "checkbox", "config[emailAdminNew][Active]", $this->_config ['emailAdminNew'] ['Active'], _ALABOOKING_EMAIL_ACTIVE . ':', _ALABOOKING_EMAIL_ACTIVE, 10 );
		$tb->add ( "admin_new", "input", "config[emailAdminNew][Sender]", $this->_config ['emailAdminNew'] ['Sender'], _ALABOOKING_EMAIL_FROM . ':', _ALABOOKING_EMAIL_FROM_INFO, 40 );
		$tb->add ( "admin_new", "input", "config[emailAdminNew][Receiver]", $this->_config ['emailAdminNew'] ['Receiver'], _ALABOOKING_EMAIL_TO . ':', _ALABOOKING_EMAIL_TO_INFO, 40 );
		$tb->add ( "admin_new", "input", "config[emailAdminNew][Subject]", $this->_config ['emailAdminNew'] ['Subject'], _ALABOOKING_EMAIL_SUBJECT . ':', _ALABOOKING_EMAIL_SUBJECT, 40 );
		$tb->add ( "admin_new", "checkbox", "config[emailAdminNew][CopyToSender]", $this->_config ['emailAdminNew'] ['CopyToSender'], _ALABOOKING_EMAIL_COPYTOSENDER . ':', _ALABOOKING_EMAIL_COPYTOSENDER_INFO, 10 );
		$tb->add ( "admin_new", "editor", "config[emailAdminNew][MailContent]", $this->_config ['emailAdminNew'] ['MailContent'], _ALABOOKING_EMAIL_CONTENT . ':', '', 40, array (
				'height' => 250 
		) );
		$tb->add ( "admin_new", "info", $this->build_add_info_email ( 'emailAdminNew' ) );
		
		$tb->addFieldSet ( "request_new", _ALABOOKING_EMAIL_VISITORNEW, _ALABOOKING_EMAIL_VISITORNEW_INFO, true );
		$tb->add ( "request_new", "checkbox", "config[emailVisitorNew][Active]", $this->_config ['emailVisitorNew'] ['Active'], _ALABOOKING_EMAIL_ACTIVE . ':', _ALABOOKING_EMAIL_ACTIVE, 10 );
		$tb->add ( "request_new", "input", "config[emailVisitorNew][Sender]", $this->_config ['emailVisitorNew'] ['Sender'], _ALABOOKING_EMAIL_FROM . ':', _ALABOOKING_EMAIL_FROM_INFO, 40 );
		$tb->add ( "request_new", "input", "config[emailVisitorNew][Receiver]", $this->_config ['emailVisitorNew'] ['Receiver'], _ALABOOKING_EMAIL_TO . ':', _ALABOOKING_EMAIL_TO_INFO, 40 );
		$tb->add ( "request_new", "input", "config[emailVisitorNew][Subject]", $this->_config ['emailVisitorNew'] ['Subject'], _ALABOOKING_EMAIL_SUBJECT . ':', _ALABOOKING_EMAIL_SUBJECT, 40 );
		$tb->add ( "request_new", "checkbox", "config[emailVisitorNew][CopyToSender]", $this->_config ['emailVisitorNew'] ['CopyToSender'], _ALABOOKING_EMAIL_COPYTOSENDER . ':', _ALABOOKING_EMAIL_COPYTOSENDER_INFO, 10 );
		$tb->add ( "request_new", "editor", "config[emailVisitorNew][MailContent]", $this->_config ['emailVisitorNew'] ['MailContent'], _ALABOOKING_EMAIL_CONTENT . ':', '', 40, array (
				'height' => 250 
		) );
		$tb->add ( "request_new", "info", $this->build_add_info_email ( 'emailVisitorNew' ) );
		
		$tb->addFieldSet ( "b_confirm", _ALABOOKING_EMAIL_VISITORCONFIRM, _ALABOOKING_EMAIL_VISITORCONFIRM_INFO, true );
		$tb->add ( "b_confirm", "checkbox", "config[emailVisitorConfirm][Active]", $this->_config ['emailVisitorConfirm'] ['Active'], _ALABOOKING_CONF_BOOKING_EMAILATCONFIRM . ':', _ALABOOKING_CONF_BOOKING_EMAILATCONFIRM_INFO, 10 );
		$tb->add ( "b_confirm", "input", "config[emailVisitorConfirm][Sender]", $this->_config ['emailVisitorConfirm'] ['Sender'], _ALABOOKING_EMAIL_FROM . ':', _ALABOOKING_EMAIL_FROM_INFO, 40 );
		$tb->add ( "b_confirm", "input", "config[emailVisitorConfirm][Receiver]", $this->_config ['emailVisitorConfirm'] ['Receiver'], _ALABOOKING_EMAIL_TO . ':', _ALABOOKING_EMAIL_TO_INFO, 40 );
		$tb->add ( "b_confirm", "input", "config[emailVisitorConfirm][Subject]", $this->_config ['emailVisitorConfirm'] ['Subject'], _ALABOOKING_EMAIL_SUBJECT . ':', _ALABOOKING_EMAIL_SUBJECT, 40 );
		$tb->add ( "b_confirm", "checkbox", "config[emailVisitorConfirm][CopyToSender]", $this->_config ['emailVisitorConfirm'] ['CopyToSender'], _ALABOOKING_EMAIL_COPYTOSENDER . ':', _ALABOOKING_EMAIL_COPYTOSENDER_INFO, 10 );
		$tb->add ( "b_confirm", "editor", "config[emailVisitorConfirm][MailContent]", $this->_config ['emailVisitorConfirm'] ['MailContent'], _ALABOOKING_EMAIL_CONTENT . ':', '', 40, array (
				'height' => 250 
		) );
		$tb->add ( "b_confirm", "info", $this->build_add_info_email ( 'emailVisitorConfirm' ) );
		
		$tb->addFieldSet ( "b_deny", _ALABOOKING_EMAIL_VISITORDENY, _ALABOOKING_EMAIL_VISITORDENY_INFO, true );
		$tb->add ( "b_deny", "checkbox", "config[emailVisitorDeny][Active]", $this->_config ['emailVisitorDeny'] ['Active'], _ALABOOKING_CONF_BOOKING_EMAILATDENY . ':', _ALABOOKING_CONF_BOOKING_EMAILATDENY_INFO, 10 );
		$tb->add ( "b_deny", "input", "config[emailVisitorDeny][Sender]", $this->_config ['emailVisitorDeny'] ['Sender'], _ALABOOKING_EMAIL_FROM . ':', _ALABOOKING_EMAIL_FROM_INFO, 40 );
		$tb->add ( "b_deny", "input", "config[emailVisitorDeny][Receiver]", $this->_config ['emailVisitorDeny'] ['Receiver'], _ALABOOKING_EMAIL_TO . ':', _ALABOOKING_EMAIL_TO_INFO, 40 );
		$tb->add ( "b_deny", "input", "config[emailVisitorDeny][Subject]", $this->_config ['emailVisitorDeny'] ['Subject'], _ALABOOKING_EMAIL_SUBJECT . ':', _ALABOOKING_EMAIL_SUBJECT, 60 );
		$tb->add ( "b_deny", "checkbox", "config[emailVisitorConfirm][CopyToSender]", $this->_config ['emailVisitorConfirm'] ['CopyToSender'], _ALABOOKING_EMAIL_COPYTOSENDER . ':', _ALABOOKING_EMAIL_COPYTOSENDER_INFO, 10 );
		$tb->add ( "b_deny", "editor", "config[emailVisitorDeny][MailContent]", $this->_config ['emailVisitorDeny'] ['MailContent'], _ALABOOKING_EMAIL_CONTENT . ':', '', 40, array (
				'height' => 250 
		) );
		$tb->add ( "b_deny", "info", $this->build_add_info_email ( 'emailVisitorDeny' ) );
		
		$tb->addFieldSet ( "b_cancel", _ALABOOKING_EMAIL_VISITORCANCEL, _ALABOOKING_EMAIL_VISITORCANCEL_INFO, true );
		$tb->add ( "b_cancel", "checkbox", "config[emailVisitorCancel][Active]", $this->_config ['emailVisitorCancel'] ['Active'], _ALABOOKING_CONF_BOOKING_EMAILATCANCEL . ':', _ALABOOKING_CONF_BOOKING_EMAILATCANCEL_INFO, 10 );
		$tb->add ( "b_cancel", "input", "config[emailVisitorCancel][Sender]", $this->_config ['emailVisitorCancel'] ['Sender'], _ALABOOKING_EMAIL_FROM . ':', _ALABOOKING_EMAIL_FROM_INFO, 40 );
		$tb->add ( "b_cancel", "input", "config[emailVisitorCancel][Receiver]", $this->_config ['emailVisitorCancel'] ['Receiver'], _ALABOOKING_EMAIL_TO . ':', _ALABOOKING_EMAIL_TO_INFO, 40 );
		$tb->add ( "b_cancel", "input", "config[emailVisitorCancel][Subject]", $this->_config ['emailVisitorCancel'] ['Subject'], _ALABOOKING_EMAIL_SUBJECT . ':', _ALABOOKING_EMAIL_SUBJECT, 60 );
		$tb->add ( "b_cancel", "checkbox", "config[emailVisitorConfirm][CopyToSender]", $this->_config ['emailVisitorConfirm'] ['CopyToSender'], _ALABOOKING_EMAIL_COPYTOSENDER . ':', _ALABOOKING_EMAIL_COPYTOSENDER_INFO, 10 );
		$tb->add ( "b_cancel", "editor", "config[emailVisitorCancel][MailContent]", $this->_config ['emailVisitorCancel'] ['MailContent'], _ALABOOKING_EMAIL_CONTENT . ':', '', 40, array (
				'height' => 250 
		) );
		$tb->add ( "b_cancel", "info", $this->build_add_info_email ( 'emailVisitorCancel' ) );
		
		$form = $tb->Show ();
		
		// Seite ausgeben
		$this->adminpage ( $form );
	}
}

?>