<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

/**
 * alaBooking_object
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_object extends alaBooking {
  public $_defaults = array ();
  public $_f_defaults = array ();
  public $_acc_defaults = array ();

  /**
   * alaBooking_object::__construct()
   */
  // protected function __construct()
  function __construct() {

    parent::__construct ();
    // Defaults für den Club-Mitglieder DB-Satz
    $this->_defaults = array(/* Standardwerte */
            'module' => $this->_module_name,
        'obj_id' => 0,
        'obj_name' => '',
        'obj_parent_id' => 0,
        'obj_shortdescr' => '',
        'obj_description' => '',
        'obj_bookingtype' => 0,
        'obj_status' => 0,
        'obj_picture' => '',
        'obj_mod_date' => '' 
    );
    // Beschreibungen aller Datensatz-Stati:
    $this->_rec_status = array (
        STATUS_ACTIVE => _ALABOOKING_STATUS_ACTIVE,
        STATUS_INACTIVE => _ALABOOKING_STATUS_INACTIVE,
        STATUS_CANCELED => _ALABOOKING_STATUS_CANCELED 
    );
  }

  /**
   * Erstellt den <option> - Code für die gültigen Satzstati
   */
  public function get_statusHtmlOpt($curr_status) {

    $new_op = $_REQUEST ['op'];
    $selectfilter2 = "<select class=\"form\" name=\"qrystatus\" size=\"1\" onchange=\"document[adminForm].action='admin.php?op=" . $new_op . "';document[adminForm].submit();\" >";
    $selectfilter2 .= "<option value=\"\" >" . _ALL . "&nbsp;&nbsp;</option>";
    foreach ( $this->_rec_status as $key => $value ) {
      $selected = ($key == $curr_status) ? "selected=\"selected\"" : "";
      $selectfilter2 .= "<option value=\"" . $key . "\" " . $selected . " >" . $value . " " . "&nbsp;&nbsp;</option>";
    }
    $selectfilter2 .= "</select>";
    return $selectfilter2;
  }

  /**
   * alaBooking_object::add_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function add_send_save($data) {

    if (! $this->check_object ( $data )) {
      return false;
    }
    
    // Daten checken:
    $data ['obj_status'] = empty ( $data ['obj_status'] ) ? 0 : $data ['obj_status'];
    
    $fields [] = "module = '" . $this->_module_name . "'";
    $fields [] = "obj_name = '" . mxAddSlashesForSQL ( $data ['obj_name'] ) . "'";
    $fields [] = "obj_shortdescr = '" . mxAddSlashesForSQL ( $data ['obj_shortdescr'] ) . "'";
    $fields [] = "obj_description = '" . mxAddSlashesForSQL ( $data ['obj_description'] ) . "'";
    $fields [] = "obj_parent_id = " . intval ( $data ['obj_parent_id'] );
    $fields [] = "obj_picture = '" . mxAddSlashesForSQL ( $data ['obj_picture'] ) . "'";
    $fields [] = "obj_bookingtype = " . intval ( $data ['obj_bookingtype'] );
    $fields [] = "obj_status = " . intval ( $data ['obj_status'] );
    // $fields [] = "obj_mod_date = DATE()";
    
    // Pseudo-Unique-Key checken:
    $sql = "SELECT obj_name FROM `" . ALABOOKING_TABLE_OBJECT . "` WHERE obj_name='" . $data ['obj_name'] . "'";
    $sql .= " AND module= '" . $this->_module_name . "'";
    $result = sql_query ( $sql );
    // list($xaid, $xname) = sql_fetch_row($result);
    list ( $schonda ) = sql_fetch_row ( $result );
    if ($schonda) {
      $this->_errors [] = _ALABOOKING_O_NAME_EXISTS . "  <em>" . $data ['obj_name'] . "</em> ";
      $this->_errors [] = _ALABOOKING_O_NAME_CHOOSEOTHER;
      return;
    }
    
    $sql = "INSERT INTO `" . ALABOOKING_TABLE_OBJECT . "` SET " . implode ( ', ', $fields );
    $result = sql_query ( $sql );
    
    if ($result) {
      $data ['obj_id'] = sql_insert_id ();
      
      // Hier können noch einige Zusatz-Updates erfolgen....
      
      $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['obj_name'] . "</em> " . _ALABOOKING_HASBEENADDED;
    } else {
      $this->_errors [] = _ALABOOKING_THERECORD . " <em>" . $data ['obj_name'] . "</em> " . _ALABOOKING_HASBEENADDEDNOT;
    }
    
    return $data ['obj_id'];
  }

  /**
   * alaBooking_object::check_member()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  protected function check_object($data) {

    if (empty ( $data ['obj_name'] )) {
      $this->_errors [] = _ALABOOKING_O_MUST_NAME;
    }
    
    return ! $this->_errors;
  }

  /**
   * alaBooking_object::del_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function del_send_save($obj_id, $data) {

    $sql = "DELETE FROM `" . ALABOOKING_TABLE_OBJECT . "` WHERE obj_id= " . $obj_id;
    $sql .= " AND module = '" . $this->_module_name . "'";
    $result = sql_query ( $sql );
    if ($result) {
      // $this->delete_photo($data);
    }
    
    $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['obj_name'] . "</em> " . _ALABOOKING_HASBEENDELETED;
    
    return true;
  }

  /**
   * alaBooking_object::edit_send_save()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  function edit_send_save($data) {

    if (! $this->check_object ( $data )) {
      return false;
    }
    
    // Daten checken:
    $data ['obj_status'] = empty ( $data ['obj_status'] ) ? 0 : $data ['obj_status'];
    
    $fields [] = "module = '" . $this->_module_name . "'";
    $fields [] = "obj_name = '" . mxAddSlashesForSQL ( $data ['obj_name'] ) . "'";
    $fields [] = "obj_shortdescr = '" . mxAddSlashesForSQL ( $data ['obj_shortdescr'] ) . "'";
    $fields [] = "obj_description = '" . mxAddSlashesForSQL ( $data ['obj_description'] ) . "'";
    $fields [] = "obj_parent_id = " . intval ( $data ['obj_parent_id'] );
    $fields [] = "obj_picture = '" . mxAddSlashesForSQL ( $data ['obj_picture'] ) . "'";
    $fields [] = "obj_bookingtype = " . intval ( $data ['obj_bookingtype'] );
    $fields [] = "obj_status = " . intval ( $data ['obj_status'] );
    // $fields [] = "obj_mod_date = DATE()";
    
    $sql = "UPDATE `" . ALABOOKING_TABLE_OBJECT . "` SET " . implode ( ', ', $fields );
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND obj_id=" . $data ['obj_id'];
    $result = sql_query ( $sql );
    
    $this->_messages [] = _ALABOOKING_THERECORD . " <em>" . $data ['obj_name'] . "</em> " . _ALABOOKING_HASBEENCHANGED;
    
    return true;
  }

  /**
   * alaBooking_object::get_data()
   *
   * Enter description here ...
   *
   * @param unknown_type $data          
   */
  public function get_data($id) {

    $sql = "SELECT * FROM `" . ALABOOKING_TABLE_OBJECT . "`";
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= "  AND obj_id=" . $id;
    $result = sql_query ( $sql );
    $row = sql_fetch_assoc ( $result );
    if (! $row) {
      return $this->_defaults;
    }
    $row ['href_detail'] = "modules.php?name=" . $this->_module_name . "&amp;op=object_detail&amp;obj_id=" . $row ['obj_id'];
    $row ['href_booking'] = "modules.php?name=" . $this->_module_name . "&amp;op=booking&amp;obj_id=" . $row ['obj_id'];
    switch ($row ['obj_bookingtype']) {
      case 0 :
        $row ['choice_info'] = _ALABOOKING_PLEASE_SELECT . _ALABOOKING_DATESINGLE;
        break;
      case 1 :
        $row ['choice_info'] = _ALABOOKING_PLEASE_SELECT . _ALABOOKING_DATETIMESINGLE;
        break;
      case 2 :
      default :
        $row ['choice_info'] = _ALABOOKING_PLEASE_SELECT . _ALABOOKING_DATEMULTIPLE;
        break;
    }
    
    return array_merge ( $this->_defaults, $row );
  }

  /**
   * alaBooking_object::getObjectName()
   * 
   * Gibt den Namen des Objektes zurück
   *
   * @param
   *          $op
   */
  public function getObjectName($obj_id) {

    $obj_data = $this->get_data ( $obj_id );
    return $obj_data ['obj_name'];
  }

  public function getObjectCharacteristics($obj_id) {

    $member = $this->get_data ( $obj_id );
    if (! $member ['obj_picture']) {
      $member ['m_picture'] = PMX_MODULES_PATH . $this->_module_name . '/images/' . 'dummy_male.png';
    }
    
    $this->_template->assign ( compact ( 'member' ) );
    
    return $this->_template->fetch ( 'member_characteristics.html' );
  }
}

/**
 * alaBooking_object_admin
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_object_admin extends alaBooking_object {

  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {

    parent::__construct ();
    
    if (! $this->_is_admin) {
      return mxredirect ( 'modules.php?name=' . $this->_module_name, _GROUPRESTRICTEDAREA );
    }
    $this->_adminmode = true; // Aufruf über die admin.php
  }

  /**
   *
   * alaBooking_object_admin::admin_object
   *
   * @param
   *          $op
   */
  public function admin_object($op) {

    global $user_prefix;
    
    // evt. Aktion uebergeben?
    $act = (isset ( $_REQUEST ['act'] )) ? $_REQUEST ['act'] : "";
    $obj_id = (isset ( $_GET ['obj_id'] )) ? $_GET ['obj_id'] : "";
    /* Filter-Ausgangswert festlegen */
    $qryfilter = ((isset ( $_POST ['qryfilter'] )) ? $_POST ['qryfilter'] : ((mxSessionGetVar ( "qryfilter" )) ? mxSessionGetVar ( "qryfilter" ) : ''));
    $qrystatus = ((isset ( $_POST ['qrystatus'] )) ? $_POST ['qrystatus'] : ((mxSessionGetVar ( "qrystatus" )) ? mxSessionGetVar ( "qrystatus" ) : ''));
    
    $data = array ();
    if ($obj_id) {
      $data = $this->get_data ( $obj_id );
    }
    // Defaults setzen und mit Form-Daten überschreiben:
    $data = array_merge ( $this->_defaults, $data, $_POST );
    
    // Verarbeitung der Aktionen:
    // 1. wurde ein AdminForm-Button gedrückt?
    $tb = load_class ( 'AdminForm', "admin_alaBookingObject" );
    switch (pmxAdminForm::CheckButton ()) {
      case "save" :
        // In DB Speichern:
        $id = $this->add_send_save ( $data );
        
        if (! $id || $this->_errors) {
          mxStripSlashes ( $data );
          $act = 'new'; // Neuanlage wiederholen!
        } else {
          $act = ''; // Default-Aktion: Liste
        }
        break;
      case "edit" :
      case "accept" :
        // In DB Speichern:
        $id = $this->edit_send_save ( $data );
        
        if ($this->_errors) {
          mxStripSlashes ( $data );
          $act = 'edit'; // Edit wiederholen!
        } else {
          $act = ''; // Default-Aktion: Liste
        }
        break;
      case "set_qryfilter" :
        $act = ''; // Default-Aktion: Liste
    }
    
    // Verarbeitung der Aktionen:
    // 2. wurde ein act-Parameter gesendet?
    switch ($act) {
      case "delete" :
        $data = $this->get_data ( $obj_id );
        $this->del_send_save ( $obj_id, $data );
        $act = '';
        break;
    }
    
    // Admin-Formular aufbauen:
    $tb = load_class ( 'AdminForm', "admin_alaBookingObject" );
    $tb->tb_text = _ALABOOKING_BTN_OBJECT;
    $tb->tb_direction = 'right';
    $tb->acceptbutton = false; //
    $tb->infobutton = $this->_config ['FormInfobutton']; // Info-Button oder als Text
    $tb->tb_pic_heigth = 22;
    $tb->csstoolbar = "toolbar1";
	$tb->cssform = "adminForm";
    $tb->homelink = false;
    $tb->buttontext = false; // Anzeige von SAVE und UP-Button unter der Feldliste
    $tb->checklistflag = true;
    $tb->checkselector = 'check_all';
    
    // Die Objectn in das Optionsmenü:
    $SelList = array (
        '' => 0 
    );
    
    $qry = "SELECT obj_id, obj_name FROM `" . ALABOOKING_TABLE_OBJECT . "` ";
    $qry .= " WHERE obj_status = " . STATUS_ACTIVE;
    
    // Objectn-Optionsmenü
    $result1 = sql_query ( $qry );
    while ( list ( $obj_id, $obj_name ) = sql_fetch_row ( $result1 ) ) {
      $SelList [$obj_name] = $obj_id;
    }
    
    // Buchungstype 0=GanzerTag;1=Zeit
    $SelBookingType = array (
        _ALABOOKING_DATESINGLE => 0,
        _ALABOOKING_DATETIMESINGLE => 1,
        _ALABOOKING_DATEMULTIPLE => 2 
    );
    
    // Satzstatus:
    $Opt_Rec_Status = $this->get_StatusFormOption ( $this->_rec_status );
    
    switch ($act) {
      
      // -------------------------------------
      // - Spieler: Neuanlegen
      // -------------------------------------
      case 'new' :
        $tb->addToolbar ( "save" );
        $tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/object", _ALABOOKING_BTN_OBJECT, $this->_module_image_path . 'alaObjects.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        /* Form elements */
        $tb->addFieldSet ( "object", _ALABOOKING_TXT_OBJECT_NEW, "", false );
        $tb->add ( "object", "input", "obj_name", $data ['obj_name'], _ALABOOKING_O_NAME, _ALABOOKING_O_NAME_INFO, 40, 5 );
        $tb->add ( "object", "select", "obj_parent_id", $data ['obj_parent_id'], _ALABOOKING_O_PARENT, _ALABOOKING_O_PARENT_INFO, 1, $SelList );
        $tb->add ( "object", "filebrowse", "obj_picture", $data ['obj_picture'], _ALABOOKING_CONF_LOGOURL1, _ALABOOKING_CONF_LOGOURL2, 40, array (
            'type' => 'images',
            'showimage' => true 
        ) );
        $tb->add ( "object", "editor", "obj_shortdescr", $data ['obj_shortdescr'], _ALABOOKING_O_SHORTDESCR, _ALABOOKING_O_SHORTDESCR_INFO, 40, array (
            'height' => 100 
        ) );
        $tb->add ( "object", "editor", "obj_description", $data ['obj_description'], _ALABOOKING_O_DESCRIPTION, _ALABOOKING_O_DESCRIPTION_INFO, 40, array (
            'height' => 200 
        ) );
        $tb->add ( "object", "select", "obj_bookingtype", $data ['obj_bookingtype'], _ALABOOKING_O_BOOKINGTYPE, _ALABOOKING_O_BOOKINGTYPE_INFO, 1, $SelBookingType );
        $tb->add ( "object", "select", "obj_status", $data ['obj_status'], _ALABOOKING_O_STATUS, _ALABOOKING_O_STATUS_INFO, 1, $Opt_Rec_Status );
        
        $form = $tb->Show ();
        break;
      // -------------------------------------
      // - Spieler: Ändern
      // -------------------------------------
      case 'edit' :
        $tb->addToolbar ( "edit" );
        $tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/object", _ALABOOKING_BTN_OBJECT, $this->_module_image_path . 'alaObjects.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        /* Form elements */
        $tb->addFieldSet ( "object", _ALABOOKING_TXT_OBJECT_CHANGE, "", false );
        $tb->add ( "object", "input", "obj_name", $data ['obj_name'], _ALABOOKING_O_NAME, _ALABOOKING_O_NAME_INFO, 40, 5 );
        $tb->add ( "object", "select", "obj_parent_id", $data ['obj_parent_id'], _ALABOOKING_O_PARENT, _ALABOOKING_O_PARENT_INFO, 1, $SelList );
        $tb->add ( "object", "filebrowse", "obj_picture", $data ['obj_picture'], _ALABOOKING_CONF_LOGOURL1, _ALABOOKING_CONF_LOGOURL2, 40, array (
            'type' => 'images',
            'showimage' => true 
        ) );
        $tb->add ( "object", "editor", "obj_shortdescr", $data ['obj_shortdescr'], _ALABOOKING_O_SHORTDESCR, _ALABOOKING_O_SHORTDESCR_INFO, 40, array (
            'height' => 100 
        ) );
        $tb->add ( "object", "editor", "obj_description", $data ['obj_description'], _ALABOOKING_O_DESCRIPTION, _ALABOOKING_O_DESCRIPTION_INFO, 40, array (
            'height' => 200 
        ) );
        $tb->add ( "object", "select", "obj_bookingtype", $data ['obj_bookingtype'], _ALABOOKING_O_BOOKINGTYPE, _ALABOOKING_O_BOOKINGTYPE_INFO, 1, $SelBookingType );
        $tb->add ( "object", "select", "obj_status", $data ['obj_status'], _ALABOOKING_O_STATUS, _ALABOOKING_O_STATUS_INFO, 1, $Opt_Rec_Status );
        
        $form = $tb->Show ();
        break;
      // ------------------------------------------
      // - Spieler: Liste zur Bearbeitung anzeigen
      // ------------------------------------------
      default :
        
        $tb->addToolbarLink ( "new", "admin.php?op=" . $this->_module_name . "/object&amp;act=new", _ALABOOKING_BTN_OBJECT_NEW, PMX_IMAGE_PATH . 'adminform/new.png' );
        $tb->addToolbarLink ( "object", "admin.php?op=" . $this->_module_name . "/object", _ALABOOKING_BTN_OBJECT, $this->_module_image_path . 'alaObjects.png' );
        // Immer den Rücksprung zum Admin-Menü:
        $tb->addToolbarLink ( "cpanel", "admin.php?op=" . $this->_module_name );
        
        /* benötigte Werte in der Session speichern */
        mxSessionSetVar ( "qryfilter", $qryfilter );
        mxSessionSetVar ( "qrystatus", $qrystatus );
        
        $qry_where = ($qryfilter) ? " AND (obj_name like '%" . $qryfilter . "%' OR obj_description like '%" . $qryfilter . "%' )" : "";
        $qry_where .= ($qrystatus != '') ? " AND (obj_status = " . $qrystatus . " )" : "";
        
        $sql = "SELECT *  FROM " . ALABOOKING_TABLE_OBJECT . "";
        $sql .= " WHERE module = '" . $this->_module_name . "'";
        $sql .= $qry_where;
        $result = sql_query ( $sql );
        $rowset = array ();
        while ( $row = sql_fetch_assoc ( $result ) ) {
          // if (!$row['catname'] || !$row['cid']) {
          // $row['catname'] = _INACTIVE;
          // }
          $row ['status_icon'] = $this->get_StatusIcon ( $row ['obj_status'] );
          $rowset [] = $row;
        }
        
        // Searchfilter:
        $this->_template->assign ( compact ( 'query', 'qryfilter', 'status_icon' ) );
        $this->_template->assign ( 'qrystatus', $this->get_statusHtmlOpt ( $qrystatus ) );
        $out = $this->_template->fetch ( 'searchfilter_list.html' );
        
        $this->_template->assign ( compact ( 'rowset' ) );
        $out .= $this->_template->fetch ( 'admin_object_list.html' );
        $tb->add ( "", "html", $out );
        $form = $tb->Show ();
        break;
    }
    
    $this->adminpage ( $form );
  }
}

/**
 * alaBooking_object_public
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_object_public extends alaBooking_object {

  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct() {

    parent::__construct ();
    
    $this->op = (empty ( $_REQUEST ['op'] )) ? '' : rtrim ( $_REQUEST ['op'], ' /' );
    switch ($this->op) {
      case 'object_detail' :
        // Aktives Tab setzen:
        $currenttab = 'object_detail';
        $currenttab = 'hidetabs'; // Tabs ausblenden
        $content = $this->public_showObject ();
        break;
      case 'object' :
      default :
        // Aktives Tab setzen:
        $currenttab = 'hidetabs'; // Tabs ausblenden
        $content = $this->public_showObjectList ();
        break;
    }
    
    // Link zum Backend (Administration):
    $adminlink = $this->adminlink ( 'member' );
    $this->_template->assign ( 'adminlink', $adminlink );
    
    // Aktives Tab setzen:
    $this->_template->assign ( 'current', $currenttab );
    
    // Ausgabe im Haupt-Template
    return $this->page ( $content );
  }

  /**
   *
   * alaBooking_object_public::public_showObject
   *
   * @param
   *          $op
   */
  public function public_showObject() {

    $obj_id = ($_GET ['obj_id']) ? $_GET ['obj_id'] : 0;
    $row = $this->get_data ( $obj_id );
    
    // Check, whether status is valid:
    if ($row ['obj_status'] == STATUS_ACTIVE) {
      // href - Information
      
      $this->_template->assign ( compact ( 'row' ) );
      
      return $this->_template->fetch ( 'object_detail.html' );
    } else {
      $this->_errors [] = _ALABOOKING_THERECORD . " <em>" . $obj_id . "</em> " . _ALABOOKING_IS_NOTVALID;
      return false;
    }
  }

  /**
   * alaBooking_object_public::public_showObject
   */
  public function public_showObjectList() {
    
    // Übergabeparameter für pagination
    $start = (empty ( $_GET ['start'] ) || $_GET ['start'] < 0) ? 0 : intval ( $_GET ['start'] );
    $show = (empty ( $_GET ['show'] ) || $_GET ['show'] < 0) ? intval ( $this->_config ['NofObjectsPerPage'] ) : intval ( $_GET ['show'] );
    
    // Pagination erstellen:
    $result = sql_query ( "SELECT count(obj_id) FROM " . ALABOOKING_TABLE_OBJECT . " WHERE obj_status = " . STATUS_ACTIVE );
    list ( $allrows ) = sql_fetch_row ( $result );
    
    $link = "modules.php?name=" . $this->_module_name . "&amp;op=member&amp;start=%d";
    $link = "modules.php?name=" . $this->_module_name . "&amp;start=%d";
    if (isset ( $_GET ['show'] )) {
      $link .= '&amp;show=' . $show;
    }
    $pagination = $this->pagination ( $allrows, $start, $show, $link );
    $this->_template->assign ( 'pagination', $pagination );
    
    $rowset = array ();
    $sql = "SELECT * FROM " . ALABOOKING_TABLE_OBJECT;
    $sql .= " WHERE module = '" . $this->_module_name . "'";
    $sql .= " AND obj_status = " . STATUS_ACTIVE;
    $sql .= " ORDER BY obj_name";
    $sql .= " LIMIT {$start}, {$show}";
    $result = sql_query ( $sql );
    while ( $row = sql_fetch_assoc ( $result ) ) {
      $row ['href_detail'] = "modules.php?name=" . $this->_module_name . "&amp;op=object_detail&amp;obj_id=" . $row ['obj_id'];
      $row ['href_booking'] = "modules.php?name=" . $this->_module_name . "&amp;op=booking&amp;obj_id=" . $row ['obj_id'];
      $rowset [] = $row;
    }
    
    $this->_template->assign ( 'introtext', $this->_config ['Intro'] );
    $this->_template->assign ( compact ( 'rowset' ) );
    
    return $this->_template->fetch ( $this->get_template_name('object_list.html') );
  }
}

?>
