<?php
/**
 * This file is part of
 *
 * alaBooking
 *
 * a module for pragmamx (www.pragmamx.org)
 *
 * $Version: 1.2.1 $
 * $Author: André Lachnicht / aLaNiSo / www.alaniso.de $
 * $Date: 2015/11/12  $
 *
 */
defined ( 'mxMainFileLoaded' ) or die ( 'access denied' );

// eigene Includes einbinden
// Tabellennamen:
include_once (PMX_MODULES_DIR . DS . $module_name . DS . "core" . DS . "tabledef.php");
include (PMX_MODULES_DIR . DS . $module_name . DS . "setup.pmx.php");


/**
 * TimeLine
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class TimeLine extends alaBooking {
  /* Speichert die Instanz der Klasse */
  private static $_initialized = false;
  private $errors = array ();
  private $form = null;
  private $homepage = '';
  private static $__set = array (); // Konfiguration
  protected $_module_name = '';
  protected $_module_image_path = '';
  protected $_is_admin = false;
  protected $_adminmode = false; // es läuft über die admin.php
  protected $_user = array ();
  private static $ref_cfg; // Referenzvariable
  protected $_config = array ();
  protected $_tipp_status = array ();
  protected $_template; // Template zur HTML-Ausgabe
  protected $_messages = array ();
  protected $_warnings = array ();
  protected $_errors = array ();
  private $_perpage = 30;
  public $_tabs = array ();

  /**
   * TimeLine::__construct()
   *
   * @param string $parameter          
   */
  function __construct($obj_id) {
    
    parent::__construct ();
    
    mxGetLangfile ( PMX_MODULE, "timeline.lang-*.php" );
    
    $this->_module_name = PMX_MODULE;
    
    $loc_start_date = isset($_REQUEST ['scroll_start_date'])?$_REQUEST ['scroll_start_date']:'';
    $loc_obj_id = isset ( $_REQUEST ['obj_id'] ) ? $_REQUEST ['obj_id'] : isset($obj_id)?$obj_id:'';
    
    self::$__set = array(/* Standardwerte */
        // Aus den Übergabevariablen gesetzt:
    	'view_days_num' => isset ( $_REQUEST ['view_days_num'] ) ? $_REQUEST ['view_days_num'] : 30, // Anzahl Tage zur Anzeige
        'scroll_start_date' => $loc_start_date,
        'scroll_day' => isset($_REQUEST ['scroll_day']) ? $_REQUEST ['scroll_day'] : 0,
        'scroll_month' => isset($_REQUEST ['scroll_month']) ? $_REQUEST ['scroll_month'] : 0,
        // Anzuzeigende(s) Objekt(e)
        'obj_id' => $loc_obj_id,
        // Anzeige mehrerer Objekte?
        'is_show_objects_matrix' => (($loc_obj_id != '') && (strpos ( $loc_obj_id, ',' ) !== false)) ? true : false, 

        // SQL-Start- und Endedatum:
        'sql_startdate' => date("Y-m-d H:i:s"),  
        'sql_enddate' => date("Y-m-d H:i:s"),  
        // Standard-Settings:
        'booking_start_day_weeek' => 1, // [0]:Sun .. [6]:Sut
        'booking_time_format' => "m / d / Y, D", // [0]:Sun .. [6]:Sut
    );
    
    // Plausi:
    if (($this->is_show_objects_matrix) && ($this->view_days_num == '')) {
      //mxDebugFuncvars ( 'Keine Tageszahlangabe bei Matrix-Anzeige: Default auf 7 gesetzt!' );
      $this->view_days_num = 7;
    }
    
    // Start- und Endedatum für die SQL-Abfragen in das Klassenobjekt setzen:
    $this->set_sql_startend();
    
    /* modulspezifische ToolTip einbinden */
    pmxHeader::add_jquery();
    pmxHeader::add_jquery('ui/jquery.ui.core.min.js');
	pmxHeader::add_jquery('ui/jquery-ui-pmx-core.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.button.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.autocomplete.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.draggable.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.droppable.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.resizable.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.tooltip.min.js');
	pmxHeader::add_jquery('ui/jquery.ui.dialog.min.js');
	
	/* modulspezifisches Stylesheet einbinden */
    pmxHeader::add_style ( PMX_MODULES_PATH . $this->_module_name . '/style/style.timeline.css' );
    
    /* Template initialisieren */
    $this->_template = load_class ( 'Template' );
    $this->_template->init_path ( __FILE__ );
    $this->_template->assign ( 'modulname', $this->_module_name );
    $this->_template->assign ( '_config', $this->_config );
    
  }

  /**
   * TimeLine::__get()
   *
   * @param mixed $value_name          
   * @return
   *
   */
  public function __get($value_name) {

    if (isset ( self::$__set [$value_name] )) {
      return self::$__set [$value_name];
    }
    return false;
  }

  /**
   * TimeLine::__set()
   *
   * @param mixed $name          
   * @param mixed $val          
   * @return
   *
   */
  public function __set($name, $val) {

    self::$__set [$name] = $val;
  }

  /**
   * TimeLine::set_sql_startend()
   *
   * Setzt die Attribute sql_startdate und sql_enddate in das Klassenobjekt
   * 2015/04/25 aLaNiSo
   */
   public function set_sql_startend() {
    
    $start_year = date ( "Y" ); // 2015
    $start_month = date ( "m" ); // 04
    $start_day = 1; // Default
    if ($this->is_show_objects_matrix) {
      // MATRIX VIEW
      switch ($this->view_days_num) {
        case '1' :
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          break;
        
        case '30' :
        case '60' :
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
        
        case '7' : // 7 Week - start from Monday (or other start week day)
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          $start_week_day_num = date ( "w" );
          // aLaNiSo: $start_day_weeek = get_bk_option ( 'booking_start_day_weeek' ); // [0]:Sun .. [6]:Sut
          $start_day_weeek = $this->booking_start_day_weeek; // [0]:Sun .. [6]:Sut
          
          if ($start_week_day_num != $start_day_weeek) {
            for($d_inc = 1; $d_inc < 8; $d_inc ++) { // Just get week back
              $real_date = mktime ( 0, 0, 0, $start_month, ($start_day - $d_inc), $start_year );
              
              $start_week_day_num = date ( "w", $real_date );
              if ($start_week_day_num == $start_day_weeek) {
                $start_day = date ( "d", $real_date );
                $start_year = date ( "Y", $real_date );
                $start_month = date ( "m", $real_date );
                $d_inc = 9;
              }
            }
          }
          break;
        
        default : // 30
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
      }
    } else {
      // Show only one Object:
      switch ($this->view_days_num) {
        case '90' :
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          $start_week_day_num = date ( "w" );
          // aLaNiSo: $start_day_weeek = get_bk_option( 'booking_start_day_weeek' ); //[0]:Sun .. [6]:Sut
          $start_day_weeek = $this->booking_start_day_weeek;
          
          if ($start_week_day_num != $start_day_weeek) {
            for($d_inc = 1; $d_inc < 8; $d_inc ++) { // Just get week back
              $real_date = mktime ( 0, 0, 0, $start_month, ($start_day - $d_inc), $start_year );
              
              $start_week_day_num = date ( "w", $real_date );
              if ($start_week_day_num == $start_day_weeek) {
                $start_day = date ( "d", $real_date );
                $start_year = date ( "Y", $real_date );
                $start_month = date ( "m", $real_date );
                $d_inc = 9;
              }
            }
          }
          break;
        
        case '365' :
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
        
        default : // 30
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          break;
      }
    }
    
    if ($this->is_show_objects_matrix) { // MATRIX VIEW
      switch ($this->view_days_num) { // Set real start date for the each rows in calendar
        case '1' :
        case '7' :
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
        
        case '30' :
        case '60' :
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
        
        default : // 30
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
      }
    } else { // Show only one Object:
      switch ($this->view_days_num) { // Set real start date for the each rows in calendar
        case '90' :
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
        
        case '365' :
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
        
        default : // 30
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
      }
    }
    
    // Start-Datum:
    $this->sql_startdate = date ( "Y-m-d H:i:s", $real_date );
    // Ende-Datum berechnen:
    $start_day = date ( "d", $real_date );
    $start_year = date ( "Y", $real_date );
    $start_month = date ( "m", $real_date );
    $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->view_days_num), $start_year );
    $this->sql_enddate = date ( "Y-m-d H:i:s", $real_date );
  }
  
  
  /**
   * TimeLine::TimeLine_Show()
   *
   * Zeigt den Buchungskalender (timeline)
   *
   * @param unknown_type $form          
   */
  public function TimeLine_Show($op) {
      
      // Arrays initialisieren:
    $date_rec = array ();
    $ar_bookings = array ();
    $ar_objects = array ();
    $ar_time_rec = array ();
    
    if (method_exists ( $this, 'TimeLinePrepareData' )) {
      //mxDebugFuncvars ( 'TimeLinePrepareData existiert!');
      $ar_ar = $this->TimeLinePrepareData();
      $date_rec = $ar_ar[0];
      $ar_bookings = $ar_ar[1];
      $ar_objects = $ar_ar[2];
      $ar_time_rec = $ar_ar[3];
    } else {
      //mxDebugFuncvars ( 'TimeLinePrepareData ist nicht vorhanden!' );
      $date_rec = array ();
      $ar_bookings = array ();
      $ar_objects = array ();
      $ar_time_rec = array ();
    }
    
    // Objekt zur Anzeige aufbereiten:
    $timeline_objectinfo =$this->alaBooking_timeline_objectinfo($ar_objects);
    // Kalender-Navigation
    $timeline_buttons = $this->alaBooking_timeline_buttons ();
    $timeline_buttons_navigation = $this->alaBooking_timeline_buttons_navigation ();
    
    // Kalender-Blatt
    $form = $this->alaBooking_timeline ( $date_rec, $ar_bookings, $ar_objects, $ar_time_rec );
    
    /* hier die Ausgabefelder angeben */
    $this->_template->assign ( compact ( 'form', 'formClose', 'timeline_buttons', 'timeline_buttons_navigation', 'timeline_objectinfo' ) );
    
    /* Template aufbereiten und zurückgeben) */
    $container_timeline =  $this->_template->fetch ( 'timeline.html' );
    
    
    return $container_timeline;
    
    // Admin-Formular aufbauen:
    //$tl_frm = load_class ( 'AdminForm', "admin_timeline" );
    $tl_frm = new pmxAdminForm;
    $tl_frm->__set('AdminForm',"admin_timeline");
    $tl_frm->__set('tb_direction', 'left');
    $tl_frm->tb_text = 'Timeline';
    $tl_frm->tb_direction = 'left';
    $tl_frm->acceptbutton = false; //
    $tl_frm->tb_show = "both";
    $tl_frm->infobutton = true; // Info-Button oder als Text
    $tl_frm->tb_pic_heigth = 12;
    $tl_frm->cssclass = "toolbar";
    $tl_frm->homelink = false;
    $tl_frm->buttontext = false; // Anzeige von SAVE und UP-Button unter der Feldliste
    
    
    
    // Neue URL erstellen (ohne 'view_days_num')
    $get_url = $this->build_timeline_url ( array (
    		'view_days_num'
    ) );
    if (! $this->is_show_objects_matrix) {
      $tl_frm->addToolbarLink ( "month", $get_url . '&view_days_num=30', _TIMELINE_MONTH );
      $tl_frm->addToolbarLink ( "3month", $get_url . '&view_days_num=90', _TIMELINE_3MONTH );
      $tl_frm->addToolbarLink ( "year", $get_url . '&view_days_num=365', _TIMELINE_YEAR );
    } else {
      $tl_frm->addToolbarLink ( "day", $get_url . '&view_days_num=1', _TIMELINE_DAY );
      $tl_frm->addToolbarLink ( "week", $get_url . '&view_days_num=7', _TIMELINE_WEEK );
      $tl_frm->addToolbarLink ( "month", $get_url . '&view_days_num=30', _TIMELINE_MONTH );
      $tl_frm->addToolbarLink ( "2month", $get_url . '&view_days_num=60', _TIMELINE_2MONTH );
    }       
    
     
    
    $tl_frm->add ( "", "html", $container_timeline );
    return $tl_frm->Show ();
    
    return $form;
  }
    
  /**
   * TimeLine::check_object_date()
   * 
   * Prüfung, ob Datumssätze zum aktiven Objekt gehören...
   * 
   * @param unknown $ar_booking_dates
   * @param unknown $o_id
   * @param unknown $ar_bookings
   * @return multitype:unknown
   */ 
   function check_object_date($ar_booking_dates, $o_id, $ar_bookings) {

    foreach ( $ar_booking_dates as $key => $value ) {
      
      $new_array = array ();
      foreach ( $value as $b_id ) {
        if ($b_id ['resource'] == $o_id) {
          $new_array [] = $b_id ['id'];
        }
      }
      if (! empty ( $new_array ))
        $ar_booking_dates [$key] = $new_array;
      else
        unset ( $ar_booking_dates [$key] );
    }
    return $ar_booking_dates;
  }

  /**
   * TimeLine::check_object_time()
   * 
   * Prüfung, ob Zeitdaten zum aktiven Objekt gehören ...
   * 
   * @param unknown $ar_time_rec
   * @param unknown $o_id
   * @param unknown $ar_bookings
   * @return multitype:unknown
   */ 
   function check_object_time($ar_time_rec, $o_id, $ar_bookings) {

    if ($o_id > 0) {
      foreach ( $ar_time_rec as $date_key => $times_array ) {
        
        foreach ( $times_array as $time_key => $value ) {
          
          $new_array = array ();
          foreach ( $value as $b_id ) {
            
            if ($b_id ['resource'] == $o_id) {
              $new_array [] = $b_id ['id'];
            }
          }
          $ar_time_rec [$date_key] [$time_key] = $new_array;
        }
      }
    }
    return $ar_time_rec;
  }

  function set_css_class_b_id($prefix, $previous_b_id) {

    if ((! isset ( $previous_b_id )) || (empty ( $previous_b_id )))
      return '';
    
    if (is_string ( $previous_b_id ))
      $ar_b_id = explode ( ',', $previous_b_id );
    else if (is_array ( $previous_b_id ))
      $ar_b_id = $previous_b_id;
    else // Some Unknown situation
      return '';
    
    $ar_b_id = array_unique ( $ar_b_id );
    
    $css_class = '';
    
    foreach ( $ar_b_id as $b_id ) {
      $css_class .= $prefix . $b_id . ' ';
    }
    
    return $css_class;
  }
    

  /**
   * TimeLine::alaBooking_timeline_booking_row()
   * 
   * Aufbereitung einer timeline-Zeile mit Buchungsinformationen
   * 
   * @param unknown $current_object_id
   * @param unknown $start_date
   * @param unknown $booking_data
   * @return string
   */
  public function alaBooking_timeline_booking_row($current_object_id, $start_date, $booking_data = array()) {

    $html_out = '';
    
    $ar_booking_dates = $booking_data [0];
    $ar_bookings = $booking_data [1];
    $ar_objects = $booking_data [2];
    $ar_time_rec = $booking_data [3];
    
    // Die Daten-Arrays auf die gültige(n) Objekte reduzieren:
    if (empty ( $current_object_id )) {
      $current_object_id = 1;
    }
    // Nur gültige Objekte in booking_dates
    $ar_booking_dates = $this->check_object_date ( $ar_booking_dates, $current_object_id, $ar_bookings );
    // nur gültiges Objekt in time_rec
    $ar_time_rec = $this->check_object_time ( $ar_time_rec, $current_object_id, $ar_bookings );
    $current_date = $start_date;
    
    // URL vorbereiten:
    $booking_url_listing = 'admin.php?op=alaBooking/booking&act=edit';
    
    if (! $this->is_show_objects_matrix) { // Single booking resource
      
      switch ($this->view_days_num) {
        case '90' :
          $days_num = 7;
          $cell_width = '13.8%';
          $nof_time_cells = 1;
          break;
        case '365' :
          $days_num = 32;
          $cell_width = '3%';
          $nof_time_cells = 1;
          break;
        default : // 30
          $days_num = 1;
          $cell_width = '99%';
          $nof_time_cells = 24; // 25;
                                 // $this->view_days_num = 1;
          break;
      }
    } else { // Multiple booking resources
      switch ($this->view_days_num) {
        case '1' :
          $days_num = 1;
          $cell_width = '99%'; // (7*4.75*31) . 'px';
          $nof_time_cells = 24;
          break;
        case '7' :
          $days_num = 7;
          $cell_width = '13.8%'; // (4.75*31) . 'px';
          $nof_time_cells = 4;
          break;
        case '60' :
          $days_num = 62;
          $cell_width = '1.5%'; // (12) . 'px';;
          $nof_time_cells = 1;
          break;
        case 'old_365' :
          $days_num = 365;
          $cell_width = '1%'; // (2) . 'px';;
          $nof_time_cells = 1;
          break;
        
        default : // 30
          $days_num = 32;
          $cell_width = '3%'; // (31) . 'px';;
          $nof_time_cells = 1; // 25;
          break;
      }
    }
    
    if ($start_date === false) {
      $start_year = date ( 'Y' );
      $start_month = date ( 'n' );
      $start_day = date ( 'j' );
      if ($this->scroll_start_date != '') { // scroll_start_date=2013-07-01
        $scroll_start_date = explode ( '-', $this->scroll_start_date );
        
        $start_year = $scroll_start_date [0]; // 2012
        $start_month = $scroll_start_date [1]; // 09
        $start_day = $scroll_start_date [2]; // date("d");//1; //31
      }
    } else {
      $start_year = date ( "Y", $start_date ); // 2012
      $start_month = date ( "m", $start_date ); // 09
      $start_day = date ( "d", $start_date ); // 31
    }
    $previous_booking_id = false;
    $html_objtype = ($this->is_show_objects_matrix) ? ' matrix_resources ' : ' single_resource ';
    
    $html_out = '<div class="container-fluid' . $html_objtype . '">';
    $html_out .= '<div class="row-fluid">';
    $html_out .= '<div class="span12">';
    $html_out .= '<div id="timeline_scroller' . $current_object_id . '" class="calendar_timeline_scroller" style="width: 100%">';
    $html_out .= '<div class="calendar_timeline_frame" style="width: 100%;">';
    
    $status_class = '';
    $previous_month = '';
    for($d_inc = 0; $d_inc < $days_num; $d_inc ++) {
      
      $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $d_inc), $start_year );
      
      if (date ( 'm.d.Y' ) == date ( "m.d.Y", $real_date ))
        $is_today = ' today_date ';
      else
        $is_today = '';
      
      $yy = date ( "Y", $real_date ); // 2012
      $mm = date ( "m", $real_date ); // 09
      $dd = date ( "d", $real_date ); // 31
      $ww = date ( "N", $real_date ); // 7
      
      $day_filter_id = $yy . '-' . $mm . '-' . $dd;
      
      if ($previous_month != $mm) {
        $previous_month = $mm;
        $month_title = mx_strftime ( '%B, %Y', $real_date ); // 09
        $month_class = ' new_month ';
      } else {
        $month_title = '';
        $month_class = '';
      }
      
      $html_out .= '<div id="cell_' . $current_object_id . '_' . $day_filter_id . '"';
      $html_out .= ' class="calendar_overview_cell weekday' . $ww . ' ' . $is_today . ' ' . $day_filter_id . ' ' . $month_class . '"';
      $html_out .= ' style="width:' . $cell_width . ';">';
      
      // Show current date in calendar.
      $tooltip_date = mx_strftime ( $this->_config ['DateFormat'], $real_date );
      $html_out .= '<span title="' . $tooltip_date . '" class="calendar_inday_title time_in_days_num_' . $this->view_days_num . ' "' . '   >' . $dd . (($this->view_days_num == '90') ? '/' . $mm : '') . '</span>';
      
      $title_in_day = $title = $title_hint = '';
      $is_bk = 0;
      if ($nof_time_cells != 24) { // Full D a t e s
        
        if ($ar_booking_dates !== false) {
          
          $link_id_parameter = array ();
          if (isset ( $ar_booking_dates [$day_filter_id] )) { // Buchungseintrag vorhanden:
            
            $is_bk = 1;
            $ar_booking_dates [$day_filter_id] = array_unique ( $ar_booking_dates [$day_filter_id] );
            foreach ( $ar_booking_dates [$day_filter_id] as $bk_id ) {
              
              $booking_num_in_day = count ( $ar_booking_dates [$day_filter_id] );
              if (($previous_booking_id != $bk_id) || ($booking_num_in_day > 1)) {
                // Falls eine Buchung mehrere Tage belegt, darf der Titel nur beim ersten erfolgen!
                $my_bk_info = $this->get_booking_info_4_tooltip ( $bk_id, $ar_bookings, $ar_objects, $title_in_day, $title, $title_hint );
                
                $title_in_day = $my_bk_info [0];
                $title = $my_bk_info [1];
                $title_hint = $my_bk_info [2];
                $status_class = $my_bk_info [3];
              }
              if ($booking_num_in_day > 1) {
                $previous_booking_id .= ',' . $bk_id;
              } else
                $previous_booking_id = $bk_id;
              
              $link_id_parameter [] = $bk_id;
            }
          } else
            $previous_booking_id = false;
            
            // Just one day cell
          $title_hint = str_replace ( '"', "", $title_hint );
          $link_id_parameter = implode ( ',', $link_id_parameter );
          if (strpos ( $title_in_day, ',' ) !== false) {
            $title_in_day = explode ( ',', $title_in_day );
            $title_in_day = $title_in_day [0] . '..' . $title_in_day [(count ( $title_in_day ) - 1)];
            $title_in_day = '<span style=\'font-size:7px;\'>' . $title_in_day . '</span>';
          }
          
          $html_out .= '<a href="' . $booking_url_listing . '&b_id=' . $link_id_parameter . '"';
          $html_out .= ' data-tooltip="' . $title . '" class="popup_b_id_' . $link_id_parameter . ' showTtInfo ' . (($title != '') ? 'label_in_booking' : '') . ' ">' . $title_in_day . '</a>';
          
          $tm = floor ( 24 / $nof_time_cells );
          $tt = 0;
          $my_bkid_title = '';
          $html_out .= '<div class="' . $this->set_css_class_b_id ( 'cell_b_id_', $previous_booking_id ) . ' time_section_in_day timeslots_in_this_day' . $nof_time_cells . ' time_hour' . ($tt * $tm) . '  time_in_days_num_' . $this->view_days_num . ' ' . ($is_bk ? 'time_booked_in_day' : '') . ' ' . $status_class . ' ">' . (($is_bk) ? ($my_bkid_title) : '') . '</div>';
        }
      }
      
      // mxDebugFuncvars($ar_time_rec );
      
      // Ausgabe der eigentlichen Kalender-Zellen
      if ($nof_time_cells == 24) { // Time Slots in a date
        if (isset ( $ar_time_rec [$day_filter_id] )) {
          // Loop time cells
          $tm = floor ( 24 / $nof_time_cells );
          for($tt = 0; $tt < $nof_time_cells; $tt ++) {
            
            $my_bk_id_array = $ar_time_rec [$day_filter_id] [$tt * 60 * 60];
            $my_bk_id_array = array_unique ( $my_bk_id_array ); // remove duplicates
            
            if (empty ( $my_bk_id_array )) { // Time cell is E m p t y
              $is_bk = 0;
              $previous_booking_id = false;
              $my_bkid_title = $title_in_day = $title = $title_hint = '';
            } else { // Time cell is B O O K E D
              
              $is_bk = 1;
              $link_id_parameter = array ();
              
              if (($previous_booking_id !== $my_bk_id_array) || ($previous_booking_id === false)) {
                $my_bkid_title = $title_in_day = $title = $title_hint = '';
                foreach ( $my_bk_id_array as $bk_id ) {
                  
                  $my_bk_info = $this->get_booking_info_4_tooltip ( $bk_id, $ar_bookings, $ar_objects, $title_in_day, $title, $title_hint );
                  
                  $title_in_day = $my_bk_info [0];
                  $title = $my_bk_info [1];
                  $title_hint = $my_bk_info [2];
                  $status_class = $my_bk_info [3];
                  $link_id_parameter [] = $bk_id;
                }
              } else {
                $my_bkid_title = $title_in_day = $title = $title_hint = '';
              }
              $previous_booking_id = $my_bk_id_array;
              
              $title_hint = str_replace ( '"', "", $title_hint );
              $link_id_parameter = implode ( ',', $link_id_parameter );
              if (strpos ( $title_in_day, ',' ) !== false) {
                $title_in_day = explode ( ',', $title_in_day );
                $title_in_day = $title_in_day [0] . '..' . $title_in_day [(count ( $title_in_day ) - 1)];
                $title_in_day = '<span style=\'font-size:7px;\'>' . $title_in_day . '</span>';
              }
              
              // Show the circle with b_id in a day
              $my_bkid_title = '<a  href="' . $booking_url_listing . '&b_id=' . $link_id_parameter . '"
                                       data-content="<div class=\'\'>' . $title_hint . '</div>"
                                       data-tooltip="' . $title . '"
    				                   class="showTtInfo ' . (($title != '') ? 'label_in_booking' : '') . ' ">' . $title_in_day . '</a>';
            }
            
            // Abschließendes div mit Class für die Formatierung:
            $html_out .= '<div class="' . $this->set_css_class_b_id ( 'cell_b_id_', $previous_booking_id ) . ' time_section_in_day timeslots_in_this_day' . $nof_time_cells . ' time_hour' . ($tt * $tm) . '  time_in_days_num_' . $this->view_days_num . ' ' . ($is_bk ? 'time_booked_in_day' : '') . ' ' . $status_class . ' ">' . (($is_bk) ? ($my_bkid_title) : '') . '</div>';
          } // ////////////////////////////////////////////////////////////////////////////////////////////////////////////
        } else { // Just time borders
          $tm = floor ( 24 / $nof_time_cells );
          for($tt = 0; $tt < $nof_time_cells; $tt ++) {
            $html_out .= '<div class="time_section_in_day timeslots_in_this_day' . $nof_time_cells . ' time_hour' . ($tt * $tm) . '  time_in_days_num_' . $this->view_days_num . ' ' . ($is_bk ? 'time_booked_in_day' : '') . ' ' . $status_class . ' ">' . (($is_bk) ? ($my_bkid_title) : '') . '</div>';
          }
        }
      }
      
      $html_out .= '</div>';
    }
    $html_out .= '</div>';
    $html_out .= '</div>';
    $html_out .= '</div>';
    $html_out .= '</div>';
    $html_out .= '</div>';
    
    return $html_out;
  }

  
  
  

  /**
   * TimeLine::alaBooking_timeline_header_row
   * 
   * Aufbereitung der Kopfzeile H E A D E R
   * 
   * @param string $start_date
   * @return string
   */
  public function alaBooking_timeline_header_row($start_date = false) {

    $current_object_id = '';
    // Initial params
    
    if ($this->is_show_objects_matrix) {
      // MATRIX VIEW
      switch ($this->view_days_num) {
        case '1' :
          $days_num = 1;
          $cell_width = '99%';
          
          $dwa = array (
              1 => _WEEKSECONDDAY,
              2 => _WEEKTHIRDDAY,
              3 => _WEEKFOURTHDAY,
              4 => _WEEKFIFTHDAY,
              5 => _WEEKSIXTHDAY,
              6 => _WEEKSEVENTHDAY,
              7 => _WEEKFIRSTDAY 
          );
          $nof_time_cells = 24;
          break;
        case '7' :
          $days_num = 7;
          $cell_width = '13.8%';
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 1;
          break;
        case '30' :
          $days_num = 31;
          $cell_width = '3%';
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 1;
          break;
        case '60' :
          $days_num = 62;
          $cell_width = '1.5%';
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 1;
          break;
        default : // 30
          $days_num = 31;
          $cell_width = '3%';
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 1;
          break;
      }
    } else {
      
      switch ($this->view_days_num) {
        case '90' :
          $days_num = 7;
          $cell_width = '13.8%';
          $dwa = array (
              1 => _WEEKSECONDDAY,
              2 => _WEEKTHIRDDAY,
              3 => _WEEKFOURTHDAY,
              4 => _WEEKFIFTHDAY,
              5 => _WEEKSIXTHDAY,
              6 => _WEEKSEVENTHDAY,
              7 => _WEEKFIRSTDAY 
          );
          $nof_time_cells = 1;
          break;
        case '365' :
          $days_num = 32;
          $cell_width = '3%';
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 1;
          break;
        default : // 30
          $days_num = 1;
          $cell_width = '99%';
          ;
          $dwa = array (
              1 => _TIMELINE_MON,
              2 => _TIMELINE_TUE,
              3 => _TIMELINE_WED,
              4 => _TIMELINE_THU,
              5 => _TIMELINE_FRI,
              6 => _TIMELINE_SAT,
              7 => _TIMELINE_SUN 
          );
          $nof_time_cells = 24;
          break;
      }
    }
     
    if ($start_date === false) {
      $start_year = date ( 'Y' );
      $start_month = date ( 'n' );
      $start_day = date ( 'j' );
      if ($this->scroll_start_date != '') { // scroll_start_date=2013-07-01
        $scroll_start_date = explode ( '-', $this->scroll_start_date );
        
        $start_year = $scroll_start_date [0]; // 2012
        $start_month = $scroll_start_date [1]; // 09
        $start_day = $scroll_start_date [2]; // date("d");//1; //31
      }
    } else {
      $start_year = date ( "Y", $start_date ); // 2012
      $start_month = date ( "m", $start_date ); // 09
      $start_day = date ( "d", $start_date ); // 31
    }
    $html_objtype = ($this->is_show_objects_matrix) ? ' matrix_resources ' : ' single_resource ';
    
    $html_out = '<div class="container-fluid ' . $html_objtype . ' timeline_header">';
	$html_out .= '<div class="row-fluid">';
	$html_out .= '<div class="span12">';
	$html_out .= '<div id="timeline_scroller' . $current_object_id . '"	class="calendar_timeline_scroller">';
	$html_out .= '<div class="calendar_timeline_frame">';
    
    $previous_month = '';
    // Neue URL erstellen (ohne 'view_days_num ...')
    $get_url_today = $this->build_timeline_url ( array (
        'scroll_month',
        'scroll_day',
        'scroll_start_date' 
    ) );
    for($d_inc = 0; $d_inc < $days_num; $d_inc ++) {
      
      $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $d_inc), $start_year );
      
      if (date ( 'm.d.Y' ) == date ( "m.d.Y", $real_date ))
        $is_today = ' today_date ';
      else
        $is_today = '';
      
      $yy = date ( "Y", $real_date ); // 2012
      $mm = date ( "m", $real_date ); // 09
      $dd = date ( "d", $real_date ); // 31
      $ww = date ( "N", $real_date ); // 7
      $day_week = $dwa [$ww]; // Su
      
      $day_title = $dd . ' ' . $day_week;
      if ($this->is_show_objects_matrix) {
        if ($this->view_days_num == 1) {
          $day_title = mx_strftime('%A', $real_date) . '<br/>' . mx_strftime($this->_config['DateFormat'], $real_date);
        }
        if ($this->view_days_num == 7) {
          $day_title = mx_strftime('%A', $real_date) . '<br/>' . mx_strftime($this->_config['DateFormat'], $real_date);
        }
        if ($this->view_days_num == 30) {
          $day_title = mx_strftime('%d', $real_date) . '<br/>' . mx_strftime('%a', $real_date);
        }
        
        if ($this->view_days_num == 60) {
          $day_title = mx_strftime('%d', $real_date) . '<br/>' . mx_strftime('%a', $real_date);
        }
      } else {
        if ($this->view_days_num == 1) {
          $day_title = mx_strftime('%A', $real_date) . '<br/>' . mx_strftime($this->_config['DateFormat'], $real_date);
        }
        if ($this->view_days_num == 7) {
          $day_title = mx_strftime('%A', $real_date) . '<br/>' . mx_strftime('%d', $real_date);
        }
        if ($this->view_days_num == 30) {
          $day_title = _TIMELINE_TIMES;
        }
        if ($this->view_days_num == 90) {
          $day_title = mx_strftime('%a', $real_date);
        }
        if ($this->view_days_num == 365) {
          $day_title = mx_strftime('%d', $real_date);
        }
      }
      $day_filter_id = $yy . '-' . $mm . '-' . $dd;
      
      if ($previous_month != $mm) {
        $previous_month = $mm;
        $month_title = mx_strftime('%B, %Y', $real_date ); // 09
        $month_class = ' new_month ';
      } else {
        $month_title = '';
        $month_class = '';
      }
      
      
      $html_out .= '<div id="cell_' . $current_object_id . '_' . $day_filter_id . '"';
      $html_out .= ' class="calendar_overview_cell cell_header time_in_days_num_' . $this->view_days_num . ' weekday' . $ww . ' '.$day_filter_id.' '.$month_class .'"';
      $html_out .= ' style="width: ' . $cell_width . ';">';
      if ($month_title != '') { 
        $html_out .= '<div class="month_year">' . $month_title.'</div>';
      }
      if (($this->view_days_num == 30) || ($this->view_days_num == 60)) {
        $html_out .= '<a href="' . $get_url_today . '&scroll_start_date=' . $yy . '-' . $mm . '-' . $dd . '">';
      }
      
      $html_out .= '<div class="day_num">' . $day_title . '</div>';
      
      if (($this->view_days_num == 30) || ($this->view_days_num == 60)) {
        $html_out .= '</a>';
      }
      
      // die einzelnen Zellen:
      $tm = floor ( 24 / $nof_time_cells );
      for($tt = 0; $tt < $nof_time_cells; $tt ++) {
        $html_out .= '<div class="time_section_in_day time_section_in_day_header time_hour' . ($tt*$tm) . ' time_in_days_num_' . $this->view_days_num.'">';
        $html_out .= (  ( ($this->view_days_num<31)? (( ($tt*$tm) < 10?'0':'').($tt*$tm).'<sup>:00</sup>'):'' )  );
        $html_out .= '</div>';
      }
      $html_out .= '</div>';
    }
    $html_out .= '</div>';
	$html_out .= '</div>';
	$html_out .= '</div>';
	$html_out .= '</div>';
    $html_out .= '</div>';
    
    return $html_out;
  }
  
  /**
   * TimeLine::alaBooking_timeline()
   * 
   * Aufbau der TimeLine (Struktur) mit Unterprogrammaufrufen...
   * 
   * @param unknown $dates_array
   * @param unknown $ar_bookings
   * @param unknown $ar_objects
   * @param unknown $ar_time_rec
   * @return string
   */
  public function alaBooking_timeline($dates_array, $ar_bookings, $ar_objects, $ar_time_rec = array()) {
    
    $start_year = date ( "Y" ); // 2015
    $start_month = date ( "m" ); // 04
    
    // Set the correct start date, if was selected the stard date different from the today in the Filters Tab.
    if ($this->scroll_start_date != '') { // scroll_start_date=2015-04-01
      $scroll_start_date = explode ( '-', $this->scroll_start_date );
      
      $start_year = $scroll_start_date [0]; // 2015
      $start_month = $scroll_start_date [1]; // 04
      $start_day = $scroll_start_date [2]; // date("d");//1; //31
    }
    
    // Ermittlung des $start_day und der scroll-variablen Tag und Monat
    if ($this->is_show_objects_matrix) {
      // Anzeige als Matrix
      $bk_resources_id = explode ( ',', $this->obj_id );
      $max_rows_number = count ( $bk_resources_id );
      // debuge($bk_resources_id);
      switch ($this->view_days_num) {
        case '1' :
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          break;
        
        case '30' :
        case '60' :
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
        
        case '7' : // 7 Week - start from Monday (or other start week day)
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          $start_week_day_num = date ( "w" );
          // aLaNiSo: $start_day_weeek = get_bk_option ( 'booking_start_day_weeek' ); // [0]:Sun .. [6]:Sut
          $start_day_weeek = $this->booking_start_day_weeek; // [0]:Sun .. [6]:Sut
          
          if ($start_week_day_num != $start_day_weeek) {
            for($d_inc = 1; $d_inc < 8; $d_inc ++) { // Just get week back
              $real_date = mktime ( 0, 0, 0, $start_month, ($start_day - $d_inc), $start_year );
              
              $start_week_day_num = date ( "w", $real_date );
              if ($start_week_day_num == $start_day_weeek) {
                $start_day = date ( "d", $real_date );
                $start_year = date ( "Y", $real_date );
                $start_month = date ( "m", $real_date );
                $d_inc = 9;
              }
            }
          }
          break;
        
        default : // 30
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
      }
    } else {
      // Show only one Object
      switch ($this->view_days_num) {
        case '90' :          
          $max_rows_number = 12;
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          $start_week_day_num = date ( "w" );
          // Start-Tag aus Konfiguration:
          $start_day_weeek = $this->booking_start_day_weeek;
          
          if ($start_week_day_num != $start_day_weeek) {
            for($d_inc = 1; $d_inc < 8; $d_inc ++) { // Just get week back
              $real_date = mktime ( 0, 0, 0, $start_month, ($start_day - $d_inc), $start_year );
              
              $start_week_day_num = date ( "w", $real_date );
              if ($start_week_day_num == $start_day_weeek) {
                $start_day = date ( "d", $real_date );
                $start_year = date ( "Y", $real_date );
                $start_month = date ( "m", $real_date );
                $d_inc = 9;
              }
            }
          }
          break;
        
        case '365' :
          $max_rows_number = 12;
          if ($this->scroll_start_date == '')
            $start_day = 1;
          break;
        
        default : // 30
          
          $max_rows_number = 31;
          if ($this->scroll_start_date == '')
            $start_day = date ( "d" );
          break;
      }
    }
    
    // Tabelle aufbauen:
    $html_out = '<div class="bookings_overview_in_calendar_frame">';
    $html_out .= '<table class="bookings_overview_in_calendar booking_table table table-striped" cellpadding="0" cellspacing="0">';
    $html_out .= '<tr>';
    
    $html_objtype = ($this->is_show_objects_matrix) ? _TIMELINE_RESOURCES : '';
    $html_out .= '<th style="width: 600px;">'. $html_objtype .'</th>';
    $html_out .= '<th style="text-align: center;">' . 'Datum' . '</th>';
    $html_out .= '</tr>';
    $html_out .= '<tr>';
    $html_out .= '<td colspan="2"></td>';
    $html_out .= '</tr>';
    $html_out .= '<tr>';
    $html_out .= '<td style="border-right: 2px solid #7F7F7F;"></td>';
    $html_out .= '<td style="padding: 0px;">';
    
    // Überschrift über dem Kalenderblatt:
    $real_date = mktime ( 0, 0, 0, ($start_month), $start_day, $start_year );
    
    if ($this->is_show_objects_matrix) { // MATRIX VIEW
      switch ($this->view_days_num) { // Set real start date for the each rows in calendar
        case '1' :
        case '7' :
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
        
        case '30' :
        case '60' :
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
        
        default : // 30
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
      }
    } else { // Show only one Object:
      switch ($this->view_days_num) { // Set real start date for the each rows in calendar
        case '90' :
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
        
        case '365' :
          $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
          break;
        
        default : // 30
          $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
          break;
      }
    }
    
    $html_out .= $this->alaBooking_timeline_header_row ( $real_date );
    
    $html_out .= '</td>';
    $html_out .= '</tr>';
        
    for($d_inc = 0; $d_inc < $max_rows_number; $d_inc ++) {
      
      // Get Start Date to real_date variabale 
      if ($this->is_show_objects_matrix) { // Anzeige als Matrix
        switch ($this->view_days_num) { // Set real start date for each rows in calendar
          case '1' :
          case '7' :
            $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $this->scroll_day), $start_year );
            break;
          
          case '30' :
          case '90' :
            $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
            break;
          
          default : // 30
            $real_date = mktime ( 0, 0, 0, ($start_month + $this->scroll_month), $start_day, $start_year );
            break;
        }
      } else { // Show only one Object:
        switch ($this->view_days_num) { // Set real start date for the each rows in calendar
          case '90' :
            $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $d_inc * 7 + $this->scroll_day), $start_year );
            break;
          
          case '365' :
            $real_date = mktime ( 0, 0, 0, ($start_month + $d_inc + $this->scroll_month), $start_day, $start_year );
            break;
          
          default : // 30
            $real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $d_inc + $this->scroll_day), $start_year );
            break;
        }
      }
      
      $html_out .='<tr>';
      $html_out .='<td style="border-right: 2px solid #7F7F7F;">';
      
				
      // Title in first collumn of each row in timeline
      if ($this->is_show_objects_matrix) { 

        // Matrix - resource titles
        $resource_value = $ar_objects [$bk_resources_id [$d_inc]];
        
        // Neue URL erstellen (ohne 'obj_id')
        $get_url = $this->build_timeline_url ( array (
            'obj_id' 
        ) );
        
        $html_out .= '<div class="resource_title ';
         
        if (isset($resource_value->parent)){
          if ($resource_value->parent == 0) {
            $html_out .= 'parent';
          } else {
            $html_out .= 'child';
          }
        } 
        $html_out .='">';
		$html_out .='<a href="' . $get_url . '&obj_id=' . $bk_resources_id[$d_inc]. '" />' . $resource_value->title. '</a>';
		$html_out .= '</div>';
		
      } else { 
        // Show only one Object: - Dates titles
        $html_out .= '<div class="resource_title">';
        switch ($this->view_days_num) {
          case '90' :
            $end_real_date = mktime ( 0, 0, 0, $start_month, ($start_day + $d_inc * 7 + $this->scroll_day) + 6, $start_year );
            $html_out .= mx_strftime('%b %d, %Y', $real_date) . ' - ' . mx_strftime('%b %d, %Y', $end_real_date); // Apr 20, 2015 - Apr 
            break;
          
          case '365' :
            $html_out .= mx_strftime('%B %Y', $real_date); // 'April, 2015'
            break;
          
          default : // 30
            $html_out .= mx_strftime('%a %d.%m.%y', $real_date);// 'Mi 23.04.2015
            break;
        }
        $html_out .='</div>';
      }
      
      $html_out .='</td>';
      $html_out .= '<td style="padding: 0px;">';
      $html_out .= '<div class="resource_dates">';
      
      if ($this->is_show_objects_matrix)
        $resource_id = $bk_resources_id [$d_inc];
      else {
        if ($this->obj_id )
          $resource_id = $this->obj_id;
        elseif (isset ( $_GET ['booking_type'] ))
          $resource_id = $_GET ['booking_type'];
        else
          $resource_id = '';
      }
      $html_out .= $this->alaBooking_timeline_booking_row ( $resource_id, $real_date, array (
          $dates_array,
          $ar_bookings,
          $ar_objects,
          $ar_time_rec 
      ) );
      
      $html_out .= '</div>';
      $html_out .= '</td>';
      $html_out .= '</tr>';
      
    }
    
    $html_out .= '</table>';
      $html_out .= '</div>';

    //$form = ob_get_clean ();
    return $html_out;
  }
      
  /**
   * TimeLine::get_booking_info_4_tooltip()
   * 
   * Ermittelt die Buchungsinformation für den "tooltip"
   * 
   * @param unknown $b_id
   * @param unknown $ar_bookings
   * @param unknown $ar_objects
   * @param string $title_in_day
   * @param string $tooltip
   * @param string $title_hint
   * @return multitype:string unknown Ambigous <unknown, multitype:string Ambigous <string, unknown> >
   */
  function get_booking_info_4_tooltip($b_id, $ar_bookings, $ar_objects, $title_in_day = '', $tooltip = '', $title_hint = '') {
    
    // mxDebugFuncvars($ar_bookings);
    if ($title_in_day != '')
      $title_in_day .= ' / '; // Other Booking in the same day
    $title_in_day .= $ar_bookings [$b_id] ['b_name'];
    
    // Buchungsstatus
    $status_class = '';
    list ( $status_txt, $status_title, $status_class,  ) = $this->get_StatusData ( $ar_bookings [$b_id] ['b_status'] );
    
    
      // title-Inhalt
    if ($tooltip != '')
      $tooltip .= ','; // Other Booking in the same day
    
    $tooltip .= $b_id;
    // aLaNiSo:
    return (array (
        $title_in_day, // title in day
        $tooltip,
        $title_hint,
        $status_class 
    ));
    
  }

  /**
   * TimeLine::build_timeline_url()
   *
   * Erstellt die neue URL aufgrund der Klassen-Parameter
   *
   * @param unknown $exclude_prms
   *          werden gefiltert!
   * @param string $only_these_parameters          
   * @return string
   */
  public function build_timeline_url($exclude_prms = array(), $only_these_parameters = false) {

    $url_start = 'admin.php?op=' . $this->_module_name . '/calendar&amp;act=show&amp;';
    $ar_op = array (
        'view_days_num' => $this->view_days_num,
        'scroll_start_date' => $this->scroll_start_date,
        'scroll_day' => $this->scroll_day,
        'scroll_month' => $this->scroll_month,
        'obj_id' => $this->obj_id 
    );
    
    foreach ( $ar_op as $prm_key => $prm_value ) {
      if (! in_array ( $prm_key, $exclude_prms ))
        if (($only_these_parameters === false) || (in_array ( $prm_key, $only_these_parameters )))
          if ($prm_value != '')
            $url_start .= $prm_key . '=' . $prm_value . '&';
    }
    $url_start = substr ( $url_start, 0, - 1 );
    
    return $url_start;
  }
    

  /**
   * TimeLine::alaBooking_timeline_objectinfo()
   * 
   * Prepare View-Information of Object for timeline header
   * 
   * @param unknown $ar_objects
   * @return string
   */
  function alaBooking_timeline_objectinfo($ar_objects) {
    
    $out = '';
    if (($this->_config ['TimeTableObjects'] == 'all') || (($this->_config ['TimeTableObjects'] == 'one') && (sizeof ( $ar_objects ) == 1))) {
      foreach ( $ar_objects as $obj_id => $objinfo ) {
        $this->_template->assign ( 'objinfo', $objinfo );
        $this->_template->assign ( 'obj_id', $obj_id );
        $this->_template->assign ( 'is_show_objects_matrix', $this->is_show_objects_matrix );
        $out .= $this->_template->fetch ( 'timeline_objectinfo.html' );
      }
    }
       
    return $out;
  }
  
  /**
   * TimeLine::alaBooking_timeline_buttons()
   * 
   *  Prepare Button-row for timeline
   */  
  function alaBooking_timeline_buttons() {
    
    // Neue URL erstellen (ohne 'view_days_num')
    $get_url = $this->build_timeline_url ( array (
        'view_days_num' 
    ) );
    
    $this->_template->assign ( compact ( 'get_url' ) );
    $this->_template->assign ( 'is_show_objects_matrix', $this->is_show_objects_matrix );
    $this->_template->assign ( 'view_days_num', $this->view_days_num );
    return $this->_template->fetch ( 'timeline_buttons.html' );
  }
  

  /**
   * TimeLine::alaBooking_timeline_buttons_navigation()
   * 
   *  Prepare Navigation-Button-row for timeline
   */  
  function alaBooking_timeline_buttons_navigation() {
    
    if (! $this->is_show_objects_matrix) {
      switch ($this->view_days_num) {
        case '90' :
          $scroll_params = array (
              '&scroll_day=' . intval ( $this->scroll_day - 4 * 7 ),
              '&scroll_day=' . intval ( $this->scroll_day - 7 ),
              '&scroll_day=0',
              '&scroll_day=' . intval ( $this->scroll_day + 7 ),
              '&scroll_day=' . intval ( $this->scroll_day + 4 * 7 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV4WEEKS,
              _TIMELINE_PREVWEEK,
              _TIMELINE_CURRWEEK,
              _TIMELINE_NEXTWEEK,
              _TIMELINE_NEXT4WEEKS 
          );
          break;
        case '30' :
          $scroll_params = array (
              '&scroll_day=' . intval ( $this->scroll_day - 4 * 7 ),
              '&scroll_day=' . intval ( $this->scroll_day - 7 ),
              '&scroll_day=0',
              '&scroll_day=' . intval ( $this->scroll_day + 7 ),
              '&scroll_day=' . intval ( $this->scroll_day + 4 * 7 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV4WEEKS,
              _TIMELINE_PREVWEEK,
              _TIMELINE_CURRWEEK,
              _TIMELINE_NEXTWEEK,
              _TIMELINE_NEXT4WEEKS 
          );
                    break;
        default : // 365
          $scroll_params = array (
              '&scroll_month=' . intval ( $this->scroll_month - 3 ),
              '&scroll_month=' . intval ( $this->scroll_month - 1 ),
              '&scroll_month=0',
              '&scroll_month=' . intval ( $this->scroll_month + 1 ),
              '&scroll_month=' . intval ( $this->scroll_month + 3 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV3MONTHS,
              _TIMELINE_PREVMONTH,
              _TIMELINE_CURRMONTH,
              _TIMELINE_NEXTMONTH,
              _TIMELINE_NEXT3MONTHS 
          );
          break;
      }
    } else { // Matrix
      
      switch ($this->view_days_num) {
        case '1' : // Day
          $scroll_params = array (
              '&scroll_day=' . intval ( $this->scroll_day - 7 ),
              '&scroll_day=' . intval ( $this->scroll_day - 1 ),
              '&scroll_day=0',
              '&scroll_day=' . intval ( $this->scroll_day + 1 ),
              '&scroll_day=' . intval ( $this->scroll_day + 7 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV7DAYS,
              _TIMELINE_PREVDAY,
              _TIMELINE_CURRDAY,
              _TIMELINE_NEXTDAY,
              _TIMELINE_NEXT7DAYS 
          );
          break;
        
        case '7' : // Week
          $scroll_params = array (
              '&scroll_day=' . intval ( $this->scroll_day - 4 * 7 ),
              '&scroll_day=' . intval ( $this->scroll_day - 7 ),
              '&scroll_day=0',
              '&scroll_day=' . intval ( $this->scroll_day + 7 ),
              '&scroll_day=' . intval ( $this->scroll_day + 4 * 7 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV4WEEKS,
              _TIMELINE_PREVWEEK,
              _TIMELINE_CURRWEEK,
              _TIMELINE_NEXTWEEK,
              _TIMELINE_NEXT4WEEKS 
          );
                    break;
        
        case '30' :
        case '60' :
        case '90' : // 3 months
          $scroll_params = array (
              '&scroll_month=' . intval ( $this->scroll_month - 3 ),
              '&scroll_month=' . intval ( $this->scroll_month - 1 ),
              '&scroll_month=0',
              '&scroll_month=' . intval ( $this->scroll_month + 1 ),
              '&scroll_month=' . intval ( $this->scroll_month + 3 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV3MONTHS,
              _TIMELINE_PREVMONTH,
              _TIMELINE_CURRMONTH,
              _TIMELINE_NEXTMONTH,
              _TIMELINE_NEXT3MONTHS 
          );
                    break;
        
        default : // 30, 60, 90...
          $scroll_params = array (
              '&scroll_month=' . intval ( $this->scroll_month - 3 ),
              '&scroll_month=' . intval ( $this->scroll_month - 1 ),
              '&scroll_month=0',
              '&scroll_month=' . intval ( $this->scroll_month + 1 ),
              '&scroll_month=' . intval ( $this->scroll_month + 3 ) 
          );
          $scroll_titles = array (
              _TIMELINE_PREV3MONTHS,
              _TIMELINE_PREVMONTH,
              _TIMELINE_CURRMONTH,
              _TIMELINE_NEXTMONTH,
              _TIMELINE_NEXT3MONTHS 
          );
                    break;
      }
    }
      // Neue URL - gefiltert
    $get_url = $this->build_timeline_url ( array (
        'scroll_month',
        'scroll_day' 
    ) );
    
    // Neue URL für "heute" - gefiltert
    $get_url_today = $this->build_timeline_url ( array (
        'scroll_month',
        'scroll_day',
        'scroll_start_date' 
    ) );
    
    $this->_template->assign ( compact ( 'get_url', 'get_url_today', 'scroll_params', 'scroll_titles' ) );
    
    return $this->_template->fetch ( 'timeline_navigation.html' );

    
  }

}

/**
 * stdObject
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class stdObject {

  public function __construct(array $arguments = array()) {

    if (! empty ( $arguments )) {
      foreach ( $arguments as $property => $argument ) {
        $this->{$property} = $argument;
      }
    }
  }

  public function __call($method, $arguments) {

    $arguments = array_merge ( array (
        "stdObject" => $this 
    ), $arguments ); // Note: method argument 0 will always referred to the main class ($this).
    if (isset ( $this->{$method} ) && is_callable ( $this->{$method} )) {
      return call_user_func_array ( $this->{$method}, $arguments );
    } else {
      throw new Exception ( "Fatal error: Call to undefined method stdObject::{$method}()" );
    }
  }
}

/**
 * alaBooking_TimeLine
 *
 * @author André Lachnicht / aLaNiSo / www.alaniso.de $
 * @copyright Copyright (c) 2015
 * @version 1.0 2015/05/27
 */
class alaBooking_TimeLine extends TimeLine {

  /**
   * class::__construct()
   *
   * @param string $parameter          
   */
  function __construct($obj_id) {

    parent::__construct ($obj_id);
    
  }

  /**
   * alaBooking_TimeLine::TimeLinePrepareData()
   * 
   * Ermittelt die notwendigen Daten für die TimeLine
   * 
   * @return multitype:multitype:unknown  Ambigous <multitype:, multitype:number , multitype:unknown > Ambigous <multitype:, multitype:unknown  > multitype:stdObject
   */
  function TimeLinePrepareData() {
      
      // Arrays initialisieren:
    $date_rec = array ();
    $ar_bookings = array ();
    $ar_objects = array ();
    $ar_time_rec = array ();
      
      // Die Objekte von der DB lesen:
    if ($this->obj_id) {
      $sql_where = ($this->obj_id) ? " AND obj_id in(" . $this->obj_id . ")" : "";
      $sql = "SELECT * FROM " . ALABOOKING_TABLE_OBJECT;
      $sql .= " WHERE module = '" . $this->_module_name . "'";
      $sql .= $sql_where;
      $sql .= " AND obj_status = " . STATUS_ACTIVE;
      $result = sql_query ( $sql );
      $rowset = array ();
      $ar_obj_id = array ();
      while ( $row = sql_fetch_assoc ( $result ) ) {
        $obj_booking = new stdObject ();
        $obj_booking->title = $row ['obj_name'];
        $obj_booking->pic = $row ['obj_picture'];
        $obj_booking->txt = $row ['obj_shortdescr'];
        if ($row ['obj_parent_id']) {
          $obj_booking->parent = $row ['obj_parent_id'];
        }
        $ar_objects [$row ['obj_id']] = $obj_booking;
        $ar_obj_id [] = $row ['obj_id'];
      }
      // // $this->obj_id aktualisieren:
      // $this->__set ( 'obj_id', implode ( ',', $ar_obj_id ) );
      // if (($this->obj_id != '') && (strpos ( $this->obj_id, ',' ) !== false))
      // $this->__set ( 'is_show_objects_matrix', true );
      // else
      // $this->__set ( 'is_show_objects_matrix', false );
      
      // die Termine zu den Objekten lesen:
      $sql_where = ($this->obj_id) ? " AND b_obj_id in(" . $this->obj_id . ")" : "";
      $sql = "SELECT * FROM " . ALABOOKING_TABLE_BOOKING;
      $sql .= " WHERE module = '" . $this->_module_name . "'";
      $sql .= $sql_where;
      $sql .= " AND b_status in (" . STATUS_REQUESTED . ", " . STATUS_CONFIRMED. ", " . STATUS_ACTIVE . ")";
      $sql .= " AND (( b_begin >= '" . $this->sql_startdate . "'";
      $sql .= " AND b_begin <= '" . $this->sql_enddate . "')";
      $sql .= "  OR ( b_end >= '" . $this->sql_startdate . "'";
      $sql .= " AND b_end <= '" . $this->sql_enddate . "') ";
      $sql .= "  OR ( b_begin <= '" . $this->sql_startdate . "'";
      $sql .= " AND b_end >= '" . $this->sql_enddate . "'))";
      $date_rec = array ();
      $result = sql_query ( $sql );
      while ( $row = sql_fetch_assoc ( $result ) ) {
                
        // Transform from MySQL date to PHP date
        $tmp_date = trim ( $row ['b_begin'] );
        $dta = explode ( ' ', $tmp_date );
        $tms = $dta [1];
        $tms_begin = explode ( ':', $tms ); // array('13','30','40')
        $dta = $dta [0];
        $dta_begin = explode ( '-', $dta ); // array('2012','12','30')
        $php_begin = mktime ( $tms_begin [0], $tms_begin [1], $tms_begin [2], $dta_begin [1], $dta_begin [2], $dta_begin [0] );
                
        // Transform from MySQL date to PHP date
        $tmp_date = trim ( $row ['b_end'] );
        $dta = explode ( ' ', $tmp_date );
        $tms = $dta [1];
        $tms_end = explode ( ':', $tms ); // array('13','30','40')
        $dta = $dta [0];
        $dta_end = explode ( '-', $dta ); // array('2012','12','30')
        $php_end = mktime ( $tms_end [0], $tms_end [1], $tms_end [2], $dta_end [1], $dta_end [2], $dta_end [0] );
        $php_work = $php_begin;
        $i = 0;
        while ( $php_work <= $php_end ) {
          
          $key = mx_strftime ( '%Y-%m-%d', $php_work ); // 2015-12-24
                                                        // $date_rec [( string ) $key] = array (
                                                        // array (
                                                        // 'id' => $row ['b_id'],
                                                        // 'resource' => $row ['b_obj_id']
                                                        // )
                                                        // )
          $date_rec [( string ) $key] [$row ['b_id']] = array (
              'id' => $row ['b_id'],
              'resource' => $row ['b_obj_id'] 
          );

          
          
          // Zeiten-Array:
          $fixed_time_hours_array = array ();
          $hourseconds = 0;
          $horrseconds_old = 0;
          for($tt = 0; $tt < 24; $tt ++) {
            
            // Stundensekunden:
            $hourseconds = $tt * 60 * 60;
            
            // Stunden-Datum auf aktuelles Datum
            // $php_currdate = mktime ( $tt, 0, 0, $dta_begin [1], $dta_begin [2], $dta_begin [0] );
            $php_currdate = mktime ( $tt, 0, 0, mx_strftime ( '%m', $php_work ), mx_strftime ( '%d', $php_work ), mx_strftime ( '%y', $php_work ) );
            
            if (($php_currdate >= $php_begin) && ($php_currdate <= $php_end)) {
              $ar_time_rec [( string ) $key] [$hourseconds][] = array (
                      'resource' => $row ['b_obj_id'],
                      'id' => $row ['b_id'] 
                 
              );
            } else {
              $ar_time_rec [( string ) $key] [$hourseconds][] = array (
                      'resource' => 0,
                      'id' => 0       
              );
           }
          } /* Example: Array ( [0] => array(), [3600] => array(), [7200] => array(), ..... [43200] => array(),.... [82800] => array() ) */
          
          // Arbeitsdatum um einen Tag erhöhen:
          $i ++;
          $php_work = mktime ( $tms_begin [0], $tms_begin [1], $tms_begin [2], $dta_begin [1], $dta_begin [2] + $i, $dta_begin [0] );
        }
        
        // Buchungen:
        $ar_bookings [$row ['b_id']] = $row;
      }
      $dates_array [] = $date_rec;
    }
    
    return array($date_rec, $ar_bookings,  $ar_objects, $ar_time_rec);
  }


}

?>